# Release process: Core package

1) Change version numbers:
   - Update SnpEff pom.xml
   - Update SnpSift pom.xml
   - Update `scripts_build/make.sh`, line `export VERSION=5.1`
   - Check `Config.DATABASE_COMPATIBLE_VERSIONS` for new version compatibilities added
2) Build JAR files: `./make.bds`
3) Run tests: `./make.bds -test`
4) Run `SnpEff/git/reelease` and `SnpSift/git/reelease`
5) Create distro ZIP files: `./make.bds -distroCore`
6) Upload core files to Azure: `./make.bds -uploadCore`
7) Update web page and documentation: `./make.bds -createDocs`, see [Documentation section](#documentation)

# Release process: Databases

1) Download databases: `./make.bds -download`, (see [Download Database sources](#download_database_sources)
2) Build databases: `./make.bds -db`, see section "Databases sources updates details" for details
3) Upload files to Azure: `./make.bds -uploadDbs`

**AWS instance notes**:
Downloading database sources: Can be done in a small instance (4 cores)
- Disk: 2 TB
- Memory: 32 GB (building dbNSFP loads large files in memory to sort by chr:pos)

Building databases: 64 cores recommended

# Documentation

- **NOTES**:
	- GitHub pages are published from `/docs` directory (main project's directory). This is configured in GitHub's project settings.
	- Markdown source for `mkdocs` is under `src/docs`

### Building docs

```
./make.bds -createDocs
```

This will create `site` directory (ref: <https://www.mkdocs.org/#building-the-site>) and copy the html pages to `docs` directory, so when you push to github it will be "published"

### Testing: Local

Localhost web-server starting: This will create local web-site on <http://127.0.0.1:8000> (ref: <https://www.mkdocs.org/#getting-started>)
```
# Go to snpEff's install dir, activate virtual environment containing mkdocs
cd ~/snpEff; source ./bin/activate
./bin/mkdocs serve
```

### Publishing docs

Just commit to GitHub, the updated pages in `docs` directory will be shown after a few minutes

```
./git/commit 'Documentation updated'
```

### Requirements

SnpEff uses `mkdocs`.
To build docs you need mkdocs-material theme installed.
`mkdocs` dependencies is included in `mkdocs-material` now (ref: <https://www.mkdocs.org/#installing-mkdocs>

```
# Go to snpEff's install dir, activate virtual environment containing mkdocs
cd ~/snpEff; source ./bin/activate

pip install mkdocs-material
```

# Download Database sources

### Database compatible versions

Update `make.bds`, variable `dbCompatibleVersions`. 
Add list of all database versions that are compatible with this release

### ENSEMBL vertebrates release number

1) Go to ENSEMBL's site and check the latest release number: http://ftp.ensembl.org/pub/
2) Update `make.bds` variable `ensemblRelease`
3) Create an empty config file `config/snpEff.ENSEMBL_{RELEASE_NUMBER}.config`
4) Run `./make.bds -download` will create the appropriate line for the config file `config/snpEff.ENSEMBL_{RELEASE_NUMBER}.config`
5) 

### UCSC genomes list updates

1) Download list of UCSC genomes from API
```
curl https://api.genome.ucsc.edu/list/ucscGenomes > ucscGenomes.json
```
2) Check UCSC genomes (API call + jq):
``` 
jq -r '.ucscGenomes | keys[] ucscGenomes.json'
```
3) Use the list of genomes to update `make.bds`, variable `ucscGenomes`
4) WARNING: You need to filter out repeated genomes and use the latest versions for each (maybe except `hg` and `mm`)

### ENSEMBL vertebrates release number

1) Check latest release number from http://ftp.ensemblgenomes.org/pub/ 
2) Update release number on `make.bds`, variable `ensemblBfmppRelease`
3) Create an empty config file `config/snpEff.ENSEMBL_BFMPP_{RELEASE_NUMBER}.config`
4) Run `./make.bds -download` will create the appropriate line for the config file `config/snpEff.ENSEMBL_BFMPP_{RELEASE_NUMBER}.config`

### FlyBase

**Note:** It looks like FlyBase is not providing any GTF files for other than 'dmel', this is really weird, they used to have them in the past (maybe the project is dead/dying?)

1) Check latest release from http://ftp.flybase.net/releases/
2) Update `make.bds`, variable `flybaseRelease`
3) Update the list of genomes, variable `flybaseGenomes`
4) Check which genomes have GTF files (right click on each link and look for `gtf` subdir)
5) Create / Update the config file `config/snpEff.FLYBASE_{FLYBASE_RELEASE}.config`

### MANE Genome

1) Check latest version from https://ftp.ncbi.nlm.nih.gov/refseq/MANE/MANE_human/
2) Update `make.bds`, variable `maneRelease`
3) Update file `config/snpEff.dbs.config`, look for `GRCh38.mane.*` entries

### Clinvar

Usually nothing to update, there is a stable link to the latest version

### dbSnp

Usually nothing to update

1) Check release vresion from https://ftp.ncbi.nih.gov/snp/latest_release/VCF/
2) Update `src/bds/download/downloadHumanDb.bds`
    1) GRCh37: Variable `urlDbSnpGrch37`
    2) GRCh38: Variable `urlDbSnpGrch38`

### dbNSFP

1) Check latest version from https://sites.google.com/site/jpopgen/dbNSFP
2) Update `make.bds`, variable `dbNsfpVersion` (use the version ending in "a")

### Gwas-Catalog

Usually nothing to update

1) Check the page https://www.ebi.ac.uk/gwas/docs/file-downloads
2) WARNING: If there are changes in the format, Java code might need to change

### Jaspar

1) Check the download page https://jaspar.genereg.net/downloads/
2) Download link from https://jaspar.genereg.net/download/data/2022/CORE/JASPAR2022_CORE_non-redundant_pfms_jaspar.txt 
3) Update `src/bds/download/downloadHumanDb.bds`, variable `urlJaspar` 
 
### NextProt

Usually nothing to update

1) Check release from https://download.nextprot.org/pub/current_release/
2) Update link in `src/bds/download/downloadHumanDb.bds`, variable `urlNextProt`

### PDB

1) Check download page for change https://www.rcsb.org/docs/programmatic-access/file-download-services
2) Check rsyn script

### AlphaFold

#-------------------------------------------------------------------------------
#
# Bayes-factor correction for gene set analysis (SnpEff gsa)
#
#
#															Pablo Cingolani 2013
#-------------------------------------------------------------------------------


#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

show = TRUE		# Used for debugging
show = FALSE	# Used for production

pvalCoefThreshold = 10^-12	# Adjust only if linearmodel p-value is less than this

#---
# Parse command line arguments
#---
if( ! exists('fileName') ) {
    args <- commandArgs(trailingOnly = TRUE)
    fileName = args[1]
    outFileName = args[2]
    minScoreCount = args[3]
}

#---
# Read data
#---
d = read.table(fileName, sep="\t", header=TRUE)

# p-values or scores. 
# Note: the conversion 'as.numeric(as.character())' is necesary 
# because R reads '0.6049666666666666' as a number, 
# but reads       '0.60496666666666666' as a string (yes, R is amazing!)
p = as.numeric(as.character(d$score))	
c = d$scoreCount						# number of variants 

keep = (c > 0)

p = p[keep]
mu = mean(p)
sigma = sd(p)
lp = as.vector(scale(p[keep]))		# Scale to mean=0 and var=1 => Convert to z-scores using an inverse normal distribution

c = c[keep]
lc = log10(c)

#---
# Linear model
#---
lmfit = lm( lp ~ lc )
sumLmfit =  summary(lmfit)
pvalCoef = sumLmfit$coefficients[2,4]

res = lmfit$residuals		# Residuals
padj = sigma * res + mu	# Adjusted bayesian factor

# Don't adjust under 'minScoreCount'
padj[ c <= minScoreCount ] = p[ c <= minScoreCount ]

if( show ) {
	print(sumLmfit)
	cat('Slope:\t', sumLmfit$coefficients[2], '\tp-value:\t', pvalCoef, 'File:\t', fileName, '\n');

	par(mfrow=c(2,2))
	smoothScatter( lc, p, main="Z-Scores", xlab="Number of scores", ylab="Z-Score" )
	lines(lowess(lc, p ), col='orange')

	smoothScatter( lc, padj, main="Adjusted Z-Scores", xlab="Number of scores", ylab="Z-Score" )
	lines(lowess(lc, padj ), col='orange')

	plot( density(p) , main="Bayes-Factors distribution", xlab="red:Adjusted black:Unadjusted")
	lines( density(padj) , col='red')

	plot( density(lc) , main="log10(Number of scores)", xlab="")
}

#---
# Decide whether to use corrected scores or not
#---
if( pvalCoef < pvalCoefThreshold ) { 
	so = padj		# Significant? Then use correction
	so[ c <= minScoreCount ] = p[ c <= minScoreCount ]
} else {
	so = d$score	# Not very significant? Use original scores
}

#---
# Create output file
#---
dout = data.frame( geneId = d$geneId[keep], score = so )
write.table( dout, file=outFileName, quote=FALSE, row.names = FALSE, col.names = FALSE, sep="\t")

library(pheatmap)   
library(gplots)

#-------------------------------------------------------------------------------
# Transform into a matrix
#-------------------------------------------------------------------------------

exprList2Matrix <- function( exprList ) {
	# Length of all lists
	lengths <- unlist( lapply( 1:length(exprList), function(x) length(unlist(exprList[[x]])) ) )
	ncol <- max(lengths)
	nrow <- length(lengths)
	exprMatrix <- matrix(data = NA, nrow = nrow, ncol = ncol)

	for( i in 1:nrow ) {
		len <- lengths[i]
		cat('\ti:', i, '\tLength', len, '\n')
		exprMatrix[i,1:len] <- unlist( exprList[[i]] )
	}

	return (exprMatrix)
}

#-------------------------------------------------------------------------------
# Box plot of a matrix
#-------------------------------------------------------------------------------
boxplotMatrix <- function( exprMatrix, title ) {
	# Colorize according to values
	m <- t(exprMatrix)
	means <- colMeans(m, na.rm=T)

	numCols <- 100
	minMean <- -4.5
	maxMean <- 4.5
	cols <- cols <- heat.colors(numCols, alpha = 1)
	colIdx <- round( (numCols-1) * (means - minMean ) / (maxMean  - minMean) + 1 )

	boxplot( m, las=2, col=cols[colIdx], ylim=c(minMean, maxMean), main=title )
	abline( h=0, lty=2, col='grey' )
}

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

usePdf <- T
if( usePdf) { pdf( width=3, height=50, "boxPlots.pdf"); }

# Read data
d <- read.table('heatMap.txt', sep='\t', header=TRUE)
dm <- as.matrix(d)
dmn <- dm

colnames(dmn) <- NULL
rownames(dmn) <- NULL

lab <-  unlist(colnames(dm)) 

tissues <- c("Brain", "Liver", "Pancreas", "Muscle_Skeletal", "Adipose_Subcutaneous", "Adipose_Visceral")
tissuesShort <- c("Brain", "Liver", "Pancreas", "Skeletal", "Subcut.", "Visceral")

par(mfcol=c(25,1) )

for( geneIdx in 1:dim(dm)[1] ) {
	gene <- rownames(dm)[geneIdx]

	cat('Gene:', gene, '\n')
	exprList <- list()

	for( tissue in tissues ) {
		cat('\tTissue:', tissue, '\n');
		keep <- unlist( lapply( lab, function(x) ! is.na( pmatch(tissue , x)) ) )

		# Append list to list of expressions
		exprList[[ length(exprList)+1 ]] <- list( unlist(dmn[geneIdx,keep]) )
	}

	# Convert to matrix (fill with NA)
	exprMatrix <- exprList2Matrix(exprList)
	# Add tissue names
	rownames(exprMatrix) <- tissuesShort
	# Boxplot
	boxplotMatrix( exprMatrix, gene )
}

if( usePdf ) { dev.off(); }

library(pheatmap)   
library(gplots)

pdfSize <- 15

# Read data
d <- read.table('heatMap.txt', sep='\t', header=TRUE)
dm <- as.matrix(d)

# Replace NA by 0, otherwise R stops
dm[ is.na(dm) ] <- 0

# PDF output
pdf( width=pdfSize, height=pdfSize, "heatMap_small.pdf")
pheatmap(dm) # Create heatmap
dev.off()

ratio <- dim(dm)[2] / dim(dm)[1]
pdfSizeX <- ratio * pdfSize
pdf( width=pdfSizeX, height=pdfSize, "heatMap_large.pdf")
pheatmap(dm) # Create heatmap
dev.off()

#-------------------------------------------------------------------------------
#
# Show simmulated values from Reactome + GTEx "circuit" simmulation
#
#																Pablo Cingolani
#-------------------------------------------------------------------------------

savePdf <- FALSE
savePdf <- TRUE

maxPval <- 1E-3
minNameCount <- 5

if( ! exists('d') ) {
	# Simaltion data
	d <- read.table('circuits.non_zero.txt', sep='\t', header=TRUE)

	# Experiment names
	names <- read.table('expNames_full.txt', sep='\t', header=TRUE)
	names <- read.table('expNames.txt', sep='\t', header=TRUE)
}

# Experiment indexes
minExp <- 3
maxExp <- dim(d)[2]

# Column names
cnames <- colnames(d)
rnames <- d$entityName

# Experiment name
# Remove low counts and 'NA'
nameShort <- as.vector( names$nameShort[minExp:maxExp] )
nameShort[ is.na(nameShort) ] <- "Etc"
nshort <- sort(unique(nameShort))
for( ns in nshort ) {
	keep <- (nameShort == ns)
	if( sum(nameShort == ns) <= minNameCount ) { 
		nameShort[ nameShort == ns ] <- "Etc" 
	}
}

minColor = 1

if( savePdf ) { pdf(width=20, height=20); }

# Plot values
for( i in 1:length(rnames) ) {
	#if( length( grep("insulin", rnames[i], fixed=TRUE) ) > 0 ) {
	if( (d$enityId[i] == 74695) || (d$enityId[i] == 165690) || (d$enityId[i] == 373676) ) {
		x <- as.numeric(d[i,minExp:maxExp])

		# Kruskal-Wallis test
		kw <- kruskal.test( list( x, nameShort ) )
		pval.kw <- kw$p.value

		# Annova test
		anv <- oneway.test(x ~ nameShort)
		pval <- anv$p.value

		# Density plots
		if( !is.na(pval) && (pval < maxPval)) {
			name = as.character(d$entityName[i])

			# Boxplots
			par( mfrow=c(2,1) ) 
			boxplot(x ~ nameShort, main=name )

			cat('  \t', i,'\tp-value:', pval, '\tNode:', i, '\tId:', d$enityId[i], '\tName:', name, '\n');
			pvalStr <- paste('p-value(ANNOVA):', pval, '  p-value(Kruskal):', pval.kw)
			dens <- density(x)
			plot( dens, xlim=c(-1,1), main=rnames[i], sub=pvalStr, xlab="All" )

			if( F ) {

			# Plot chrts for each tissue
			par( mfrow=c(3,3) ) 
			col <- minColor
			for( ns in nshort ) {
				# Only keep matching experiments
				keep <- (nameShort == ns) & (! is.na(x))
				xns <- x[keep]
				xns <- xns[ ! is.na(xns) ]

				# At least 'minNameCount' samples?
				if( length(xns) > minNameCount ) {
					# Plot this density and overall density
					main <- paste(ns, '(#samples:',length(xns), ')')
					plot( density(xns), xlim=c(-1,1), main=main, xlab=rnames[i], sub=col, col=col )
					lines( dens, lty=2, col='gray' )

					col <- col + 1
				}
			}

			}
		} else {
			cat('NO\t', i,'\tp-value:', pval, '\tNode:', i, d$enityId[i], d$entityName[i],as.character(rnames[i]), '\n');
		}
	}
}

if( savePdf ) { dev.off(); }

#-------------------------------------------------------------------------------
# Mean non-zero value 
#-------------------------------------------------------------------------------

lnz <- function(x) {
	log2( x[(x > 0)] );
}

mainName <- function(n) {
	idx = regexpr(".SM.", n, fixed=T)[1]
	if( idx > 1 ) {
		return( substr(n, 1, idx-1) )
	}
	return(n)
}

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

# Load data
if( ! exists('gt') ) {
	cat("Loading data from gtex.txt\n");
	gt = read.table("gtex.txt", sep="\t", header=TRUE);
}

minCol = 3

# Experiment names
colExpNames = as.vector( sapply(colnames(gt), mainName) )
expNames = unique( sort( colExpNames[3:ncol(gt)] ) )

# Plot histogram
plot(0, 0, xlim = c(-15,15), ylim = c(0, 0.15) )

#---
# Perform
#	i) Log2( colum )
#	ii) Column wise mean correction
#---
cat("Step 1:\n");
L = matrix( 0 , nrow = nrow(gt), ncol = ncol(gt)-2 )
for( idx in minCol:ncol(gt) ) {
	cat('\t', colExpNames[idx], "\n");
	x = gt[,idx]
	l = log2( x )	

	k = ( x > 0 )
	l[!k] = NA

	mu = mean( l, na.rm = TRUE )
	l = l - mu

	L[,idx-minCol+1] = l
}

#---
# Difference to average
#---
cat("Step 2:\n");
lmu = rowMeans(L, na.rm = TRUE)
plot( density( lmu[k] ) , xlim = c(-15,15) )
for( idx in 1:ncol(L) ) {
	l = L[, idx] - lmu

	k = ! is.na(l)
	mu = mean(l , na.rm = TRUE )
	l = (l - mu) / sd(l,  na.rm = TRUE)

	lines( density( l[k] ), col=idx )

	L[,idx] = l

	cat('\t', colExpNames[idx], "\n");
}

colnames(L) = colnames(gt)[minCol:ncol(gt)]
norm = data.frame( geneId = gt[,1], geneName = gt[,2], L)

write.table(norm, file="gtex_norm.txt", quote = FALSE, sep = "\t", row.names = FALSE)

#!/bin/bash -eu
set -o pipefail

# ClinVar
mkdir $HOME/snpEff/data/GRCh38/clinvar
cd $HOME/snpEff/data/GRCh38/clinvar
wget https://ftp.ncbi.nlm.nih.gov/pub/clinvar/vcf_GRCh38/clinvar.vcf.gz

# DbSnp
mkdir $HOME/snpEff/data/GRCh38/dbSnp
cd $HOME/snpEff/data/GRCh38/dbSnp
wget https://ftp.ncbi.nih.gov/snp/archive/b154/VCF/GCF_000001405.38 -O dbSnp.vcf.gz

# Cosmic (Copied to tmp bucket in AWS)
mkdir $HOME/snpEff/data/GRCh38/cosmic
cd $HOME/snpEff/data/GRCh38/cosmic
aws s3 cp $S3_TMP/cosmic/cosmic-v92.vcf.gz

# GnomAD
mkdir $HOME/snpEff/data/GRCh38/gnomAD
cd $HOME/snpEff/data/GRCh38/gnomAD
aws s3 sync s3://gnomad-public-us-east-1/release/4.1/vcf/joint/ .

#!/bin/sh

# cp Crubella_183.fa.gz ../genomes/crubella_183.fa.gz

# gunzip -c ORI/Crubella_183_gene.gff3.gz > genes.gff

gunzip -c ORI/Crubella_183_cds.fa | sed "s/>.*PACid:/>PAC:/" > cds.fa
gunzip -c ORI/Crubella_183_protein.fa | sed "s/>.*PACid:/>PAC:/" > protein.fa

#!/bin/sh

REF=GRCh37.66

IN_VCF=$HOME/snpEff/1kg/test.Broad_NS_SYN.vcf.gz
OUT_VCF=all.vcf

# Run SnpEff
./scripts/snpEffXL.sh eff -v -noStats -o vcf $REF $IN_VCF > $OUT_VCF

# Calculate number of lines
SILENT=`cat $OUT_VCF | grep "SILENT" | wc -l`
MISSENSE=`cat $OUT_VCF | grep "MISSENSE" | wc -l`
NONSENSE=`cat $OUT_VCF | grep "NONSENSE" | wc -l`
SILENT_AND_MISSENSE=`cat $OUT_VCF | grep "SILENT" | grep "MISSENSE" | wc -l`

PSILENT=`echo "100 * $SILENT/($SILENT + $MISSENSE + $NONSENSE ) " | bc -l`
PMISSENSE=`echo "100 * $MISSENSE/($SILENT + $MISSENSE + $NONSENSE ) " | bc -l`
PNONSENSE=`echo "100 * $NONSENSE/($SILENT + $MISSENSE + $NONSENSE ) " | bc -l`

echo -e "Silent              :\t$SILENT ($PSILENT %)" 
echo -e "Missense            :\t$MISSENSE ($PMISSENSE %)"
echo -e "Nonsense            :\t$NONSENSE ($PNONSENSE %)"
echo -e "Silent and missense :\t$SILENT_AND_MISSENSE"

#!/bin/sh

WGET="wget -N"

#---
# Download files
#---

# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerEsmeraldo-like/gff/data/TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like.gff
# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerEsmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_AnnotatedCDSs.fasta
# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerEsmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_AnnotatedProteins.fasta
# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerEsmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_Genome.fasta

# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerNon-Esmeraldo-like/gff/data/TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like.gff
# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerNon-Esmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_AnnotatedCDSs.fasta
# $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerNon-Esmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_AnnotatedProteins.fasta
# # $WGET http://tritrypdb.org/common/downloads/release-8.1/TcruziCLBrenerNon-Esmeraldo-like/fasta/data/TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_Genome.fasta

#---
# Create joint GFF
#---

# rm -vf genes.gff genesDef.gff
# 
# for gff in TriTrypDB-8.1_TcruziCL*.gff
# do
# 	echo $gff
# 	FASTA_DELIMITER=`grep -n "^##FASTA" $gff | cut -f 1 -d :`
# 	GFF_LINES=$(($FASTA_DELIMITER-1))
# 
# 	head -n $GFF_LINES $gff >> genesDef.gff
# done
# 
# # Join files and append genomic fasta
# cat genesDef.gff > genes.gff
# echo "##FASTA" >> genes.gff
# cat TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_Genome.fasta TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_Genome.fasta \
# 	| sed "s/>\(.*\) | organism=.*/>\1/" \
# 	>> genes.gff

#---
# Create CDS fasta
#---

echo Building CDS fasta
cat TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_AnnotatedCDSs.fasta TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_AnnotatedCDSs.fasta \
	| sed "s/>\(.*\) | organism=.*/>rna_\1-1/" \
	> cds.fa

echo Building protein fasta
cat TriTrypDB-8.1_TcruziCLBrenerEsmeraldo-like_AnnotatedProteins.fasta TriTrypDB-8.1_TcruziCLBrenerNon-Esmeraldo-like_AnnotatedProteins.fasta \
	| sed "s/>\(.*\) | organism=.*/>rna_\1-1/" \
	> protein.fa

#!/bin/sh -e

# These variables need to be updated with every version
base="dbNSFP4.0a"                                # Database version
dbZip="$base.zip"                               # Zip file name
db="$base.txt.gz"                                  # Output file

# Check dbNSFP
if [ ! -e "$dbZip" ]
then
	echo "ERROR: Expected dbNSFP zip file '$dbZip' not found"
	exit 1
fi

#---
# Create DB
#---
echo Create file $db

( gunzip -c $base\_variant.chr1.gz | head -n 1 || true ; 
	gunzip -c \
		$base\_variant.chr1.gz \
		$base\_variant.chr2.gz \
		$base\_variant.chr3.gz \
		$base\_variant.chr4.gz \
		$base\_variant.chr5.gz \
		$base\_variant.chr6.gz \
		$base\_variant.chr7.gz \
		$base\_variant.chr8.gz \
		$base\_variant.chr9.gz \
		$base\_variant.chr10.gz \
		$base\_variant.chr11.gz \
		$base\_variant.chr12.gz \
		$base\_variant.chr13.gz \
		$base\_variant.chr14.gz \
		$base\_variant.chr15.gz \
		$base\_variant.chr16.gz \
		$base\_variant.chr17.gz \
		$base\_variant.chr18.gz \
		$base\_variant.chr19.gz \
		$base\_variant.chr20.gz \
		$base\_variant.chr21.gz \
		$base\_variant.chr22.gz \
		$base\_variant.chrX.gz \
		$base\_variant.chrY.gz \
	| grep -v "^#" \
) | bgzip -c > $db

echo TABIX $db.gz
pwd
tabix -s 1 -b 2 -e 2 $db

#!/bin/sh

# wget http://www.candidagenome.org/download/gff/C_albicans_SC5314/archive/C_albicans_SC5314_version_A21-s02-m09-r08_features_with_chromosome_sequences.gff.gz

zcat C_albicans_SC5314_version_A21-s02-m09-r08_features_with_chromosome_sequences.gff.gz \
	| sed "s/Ca21chr1_C_albicans_SC5314/chr1/g" \
	| sed "s/Ca21chrR_C_albicans_SC5314/chrR/g" \
	| sed "s/Ca21chr2_C_albicans_SC5314/chr2/g" \
	| sed "s/Ca21chr3_C_albicans_SC5314/chr3/g" \
	| sed "s/Ca21chr4_C_albicans_SC5314/chr4/g" \
	| sed "s/Ca21chr5_C_albicans_SC5314/chr5/g" \
	| sed "s/Ca21chr6_C_albicans_SC5314/chr6/g" \
	| sed "s/Ca21chr7_C_albicans_SC5314/chr7/g" \
	| sed "s/Ca19-mtDNA/chrMt/g" \
	> genes.gff

#!/bin/sh -e

#---
# Convert chromosome names for FASTA files
#
# Original files downloaded from
#   http://ftp.ensembl.org/pub/rapid-release/species/Sciurus_carolinensis/GCA_902686445.2/
#---

# Fixing GFF file. Remove 'gene:' from IDs to make them consistent with CDS and protein fasta files
gunzip -c ORI/Sciurus_carolinensis-GCA_902686445.2-2020_12-genes.gff3.gz \
  | sed 's/gene:\(.*\)$/\1/' \
  | sed 's/transcript:\(.*\)$/\1/' \
  | sed 's/CDS:\(.*\)$/\1/' \
  > genes.gff

# Changing labels in protein fasta file (use transcript ID)
gunzip -c ORI/Sciurus_carolinensis-GCA_902686445.2-2020_12-pep.fa.gz \
  | sed "s/^>.*transcript:\(.*\)*$/>\1/" \
  > protein.fa

# Copy files that do not need modification
cp ORI/Sciurus_carolinensis-GCA_902686445.2-softmasked.fa.gz sequences.fa.gz
cp ORI/Sciurus_carolinensis-GCA_902686445.2-2020_12-cds.fa.gz cds.fa.gz

#!/bin/sh

# wget ftp://ftp.solgenomics.net/genomes/Solanum_lycopersicum/wgs/assembly/build_2.40/S_lycopersicum_chromosomes.2.40.fa.gz

# GFF has to be downloaded manually from 
#
# http://solgenomics.net/itag/release/2.3/list_files#
#          File ITAG2.3_gene_models.gff3
#
#

# Create genes.gff
echo Decompressing the file
cp ITAG2.3_gene_models.gff3.gz genes.gff.gz
rm -f genes.gff
gunzip genes.gff.gz 

echo Fixing start-end problem
cat genes.gff | ./fixStartEnd.pl > g
mv g genes.gff

# Append FASTA Sequences
echo "###" >> genes.gff
echo "##FASTA" >> genes.gff
zcat S_lycopersicum_chromosomes.2.40.fa.gz >> genes.gff

#!/bin/sh

for chr in chr10.fa chr11.fa chr12.fa chr13.fa chr14.fa chr15.fa chr16.fa chr17.fa chr18.fa chr19.fa chr1.fa chr20.fa chr21.fa chr22.fa chr2.fa chr3.fa chr4.fa chr5.fa chr6.fa chr7.fa chr8.fa chr9.fa chrMT.fa chrX.fa chrY.fa
do
	MDGR=`cat GRCh37.65/$chr | grep -v "^>" | tr -d "\n" | tr "[a-z]" "[A-Z]" | md5sum`
	MDHG=`cat hg19/chr$chr   | grep -v "^>" | tr -d "\n" | tr "[a-z]" "[A-Z]" | md5sum`
	echo -e "$chr\n\t$MDGR\n\t$MDHG"
done

#!/bin/sh

zcat="gunzip -c"

# Download  FASTA
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG3.2_release/S_lycopersicum_chromosomes.3.00.fa.gz
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG3.2_release/ITAG3.2_cds.fasta
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG3.2_release/ITAG3.2_proteins.fasta

# Download GFF3
# wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG3.2_release/ITAG3.2_gene_models.gff

# Create genes.gff
echo Fixing start-end problem
$zcat ORI/ITAG3.2_gene_models.gff.gz | ./fixStartEnd.pl | ./removeExonFrame.pl > genes.gff

# Append FASTA Sequences
echo Sequence FASTA
cp ORI/S_lycopersicum_chromosomes.3.00.fa.gz sequences.fa.gz

echo Create CDS file
$zcat ORI/ITAG3.2_cds.fasta.gz | sed "s/^>/>mRNA:/" > cds.fa

echo Create Proteins file
$zcat ORI/ITAG3.2_proteins.fasta.gz | sed "s/^>/>mRNA:/" > protein.fa

gzip cds.fa protein.fa genes.gff

#!/bin/sh -e

# Convert chromosome names for FASTA files

# zcat ORI/ref_Macaca_fascicularis_5.0_top_level.gff3.gz \
# 	| sed "s/NC_022272.1/chr1/" \
# 	| sed "s/NC_022273.1/chr2/" \
# 	| sed "s/NC_022274.1/chr3/" \
# 	| sed "s/NC_022275.1/chr4/" \
# 	| sed "s/NC_022276.1/chr5/" \
# 	| sed "s/NC_022277.1/chr6/" \
# 	| sed "s/NC_022278.1/chr7/" \
# 	| sed "s/NC_022279.1/chr8/" \
# 	| sed "s/NC_022280.1/chr9/" \
# 	| sed "s/NC_022281.1/chr10/" \
# 	| sed "s/NC_022282.1/chr11/" \
# 	| sed "s/NC_022283.1/chr12/" \
# 	| sed "s/NC_022284.1/chr13/" \
# 	| sed "s/NC_022285.1/chr14/" \
# 	| sed "s/NC_022286.1/chr15/" \
# 	| sed "s/NC_022287.1/chr16/" \
# 	| sed "s/NC_022288.1/chr17/" \
# 	| sed "s/NC_022289.1/chr18/" \
# 	| sed "s/NC_022290.1/chr19/" \
# 	| sed "s/NC_022291.1/chr20/" \
# 	| sed "s/NC_022292.1/chrX/" \
# 	| sed "s/NC_012670.1/chrMT/" \
#  	> genes.ORI.gff

grep "Parent=rna" genes.ORI.gff | cut -f 3- | grep ^CDS | cut -f 7 | tr ";" "\t" | cut -f 2,3 | tr "=" "\t" | cut -f 2,4 | uniq > replace_list.txt
cat genes.ORI.gff | ./replace.GFF_ID_Parent.pl > genes.gff

# gzip genes.gff

# Convert chromosome names for GFF file
#
# zcat  \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr1.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr2.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr3.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr4.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr5.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr6.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr7.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr8.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr9.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr10.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr11.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr12.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr13.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr14.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr15.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr16.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr17.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr18.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr19.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chr20.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chrX.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_chrMT.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_unlocalized.fa.gz \
# 	ORI/mfa_ref_Macaca_fascicularis_5.0_unplaced.fa.gz \
# 	| sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" \
# 	| sed "s/NC_022272.1/chr1/" \
# 	| sed "s/NC_022273.1/chr2/" \
# 	| sed "s/NC_022274.1/chr3/" \
# 	| sed "s/NC_022275.1/chr4/" \
# 	| sed "s/NC_022276.1/chr5/" \
# 	| sed "s/NC_022277.1/chr6/" \
# 	| sed "s/NC_022278.1/chr7/" \
# 	| sed "s/NC_022279.1/chr8/" \
# 	| sed "s/NC_022280.1/chr9/" \
# 	| sed "s/NC_022281.1/chr10/" \
# 	| sed "s/NC_022282.1/chr11/" \
# 	| sed "s/NC_022283.1/chr12/" \
# 	| sed "s/NC_022284.1/chr13/" \
# 	| sed "s/NC_022285.1/chr14/" \
# 	| sed "s/NC_022286.1/chr15/" \
# 	| sed "s/NC_022287.1/chr16/" \
# 	| sed "s/NC_022288.1/chr17/" \
# 	| sed "s/NC_022289.1/chr18/" \
# 	| sed "s/NC_022290.1/chr19/" \
# 	| sed "s/NC_022291.1/chr20/" \
# 	| sed "s/NC_022292.1/chrX/" \
# 	| sed "s/NC_012670.1/chrMT/" \
# 	> Macaca_fascicularis.fa
#
# gzip Macaca_fascicularis.fa

# Convert headers in FASTA protein and rna


# zcat ORI/protein.fa.gz | sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" > protein.fa
# zcat ORI/rna.fa.gz | sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" > cds.fa
# gzip -v cds.fa protein.fa

#!/bin/sh -e

#-------------------------------------------------------------------------------
#
# Example on how to annotate human variants using SnpSift
# Note: It is assumed that the organism is "human"
#
#															Pablo Cingolani 2012
#-------------------------------------------------------------------------------

#---
# Parameters
#--- 
INPUT_VCF="test.vcf"                        # Variants file to annotate
REFERENCE="GRCh37.66"                       # Reference genome

MEM="4G"                                    # Amount of memory to use (make sure there is enough physical memory)
SNPSIFT="java -Xmx$MEM -jar SnpSift.jar"	# SnpSift command
SNPEFF="java -Xmx$MEM -jar snpEff.jar"	    # SnpEff command

VCF_BASE=`basename $INPUT_VCF .vcf`         # Name to use for intermediate files

#---
# Annotate ID fields using dbSnp
#
# Note: We annotate using dbSnp before using SnpEff in order to 
#       have 'known' and 'unknown' statistics in SnpEff's summary page.
#       Those stats are based on the presence of an ID field. If the ID 
#       is non-empty, then it is assumed to be a 'known variant'.
#---

# Download and uncompress dbSnp database.
# Note: Uncomment the following line if you need to download it.
#
#wget -O dbSnp.vcf.gz ftp://ftp.ncbi.nih.gov/snp/organisms/human_9606/VCF/v4.0/00-All.vcf.gz
#gunzip dbSnp.vcf.gz

$SNPSIFT annotate -v $DB_SNP $VCF > $VCF_BASE.dbSnp.vcf

#---
# Annotate variants using SnpEff
#---
$SNPEFF eff -v  $REFERENCE  $VCF.dbSnp.vcf  > $VCF_BASE.eff.vcf

# Here is an example using regulatory annotations.
# Note: You should customize which annotations you use depending on what makes sense for your project.

# $SNPEFF eff -v \
# 	-reg H1ESC \
# 	-reg HUVEC \
# 	-reg HepG2 \
# 	-reg IMR90 \
# 	-reg NHEK \
# 	-reg Adult_Liver \
# 	-reg Muscle_Satellite_Cultured_Cells \
# 	-reg Pancreatic_Islets \
# 	-reg Skeletal_Muscle \
# 	$REFERENCE \
# 	$VCF.dbSnp.vcf \
# 	> $VCF_BASE.eff.vcf

# At this point, you should have an HTML summary file.
echo "Take a look at the summary. Open snpEff_summary.html in your browser."

#---
# Annotate using GWAS catalog
#---

# Download GWAS catalog 
# Note: Uncomment the following lines if you need to download the database.
#
#wget http://www.genome.gov/admin/gwascatalog.txt

# Annotate
$SNPSIFT gwasCat -v gwascatalog.txt $VCF_BASE.eff.vcf > $VCF_BASE.gwas.vcf

#---
# Annotate using SIFT (Sorts Intolerant From Tolerant) score.
# Note: SIFT and SnpSift are two unrelated projects, but you can use SnpSift to annotate using SIFT databases (yes, I know it's confusing...)
#---

# Download database 
# Note: Uncomment the following lines if you need to download the database.
#
#wget http://sourceforge.net/projects/snpeff/files/databases/sift.vcf.gz
#gunzip sift.vcf.gz

# Annotate
$SNPSIFT sift $VCF_BASE.gwas.vcf > $VCF_BASE.sift.vcf

#---
# Other (optional) annotations
#---

# Hardy Weinberg 
$SNPSIFT hw $VCF_BASE.sift.vcf > $VCF_BASE.hw.vcf

# Variant types
$SNPSIFT varType $VCF_BASE.hw.vcf > $VCF_BASE.annotated.vcf

#!/bin/sh

rm genes.gtf* protein.fa* cds.fa*

# GTF
zcat ORI/Anopheles-gambiae-PEST_BASEFEATURES_AgamP4.2.gtf.gz \
	| sed "s/Parent=\(.*\);/transcript_id \"\1\";/" \
	> genes.gtf

# Chromosomes FASTA
cp ORI/Anopheles-gambiae-PEST_CHROMOSOMES_AgamP4.fa.gz  ../genomes/agam4.2.fa.gz

# CDS
cp ORI/Anopheles-gambiae-PEST_TRANSCRIPTS_AgamP4.2.fa.gz cds.fa.gz

# Proteins
zcat ORI/Anopheles-gambiae-PEST_PEPTIDES_AgamP4.2.fa.gz | sed "s/-P/-R/" > protein.fa

gzip -v protein.fa genes.gtf

#!/bin/sh -e

echo "Processing GFF file"
gunzip -c Gmax_109_gene.gff3.gz > genes.gff
#	| sed "s/.five_prime_UTR.1//" \
#	| sed "s/.three_prime_UTR.1//" \
#	> genes.gff

echo "Adding FASTA sequence"
( echo "###" ; echo "##FASTA" ; gunzip -c Gmax_109.fa.gz ) >> genes.gff

ehco "Create CDS file"
gunzip -c Gmax_109_cds.fa.gz \
	| sed "s/|PACid:/|PAC:/" \
	| sed "s/Glyma.*|//" \
	> cds.fa 

echo "Create protein file"
gunzip -c Gmax_109_peptide.fa.gz \
	| sed "s/|PACid:/|PAC:/" \
	| sed "s/Glyma.*|//" \
	> protein.fa

# Build databse
cd $HOME/snpEff

./scripts/snpEffM.sh build -v -gff3 gmax1.09v8 2>&1 | tee gmax1.09v8.build

# CDS test
./scripts/snpEffM.sh cds -v gmax1.09v8 data/gmax1.09v8/cds.fa 2>&1 | tee gmax1.09v8.cds

cd -

echo Done!

#!/bin/sh

zcat Araly1_GeneModels_FilteredModels6.gff.gz \
	| sed "s/name/gene_id/" \
	| sed "s/transcriptId \(.*\)/transcript_id \"\1\";/" \
	| sed "s/exonNumber \(.*\)/exon_number \"\1\";/" \
	> g1

./convert.pl g1 > genes.gtf
rm -vf g1

#!/bin/sh -e

#---
# Convert chromosome names for FASTA files
#---

zcat ORI/ref_Zonotrichia_albicollis-1.0.1_top_level.gff3.gz > genes.ORI.gff

grep "Parent=rna" genes.ORI.gff | cut -f 3- | grep ^CDS | cut -f 7 | tr ";" "\t" | cut -f 2,3 | tr "=" "\t" | cut -f 2,4 | uniq > replace_list.txt
cat genes.ORI.gff | ./replace.GFF_ID_Parent.pl > genes.gff

gzip genes.gff

#---
# Convert chromosome names for GFF file
#---

zcat ORI/44394_ref_Zonotrichia_albicollis-1.0.1_chrUn.fa.gz \
 	| sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" \
 	> Zonotrichia_albicollis_1.0.fa

gzip Zonotrichia_albicollis_1.0.fa

#---
# Convert headers in FASTA protein and rna
#---

zcat ORI/protein.fa.gz | sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" > protein.fa
zcat ORI/rna.fa.gz | sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" > cds.fa
gzip -v cds.fa protein.fa

#!/bin/sh -e

# # Get files and create one file for all chromosomes
# echo Download files
# cd ~/snpEff/data/spombe
# wget ftp://ftp.sanger.ac.uk/pub/yeast/pombe/Chromosome_contigs/chromosome1.contig.embl
# wget ftp://ftp.sanger.ac.uk/pub/yeast/pombe/Chromosome_contigs/chromosome2.contig.embl
# wget ftp://ftp.sanger.ac.uk/pub/yeast/pombe/Chromosome_contigs/chromosome3.contig.embl
# cat chromosome?.contig.embl > genes.embl
# cd -

# Build
echo Build database
java -Xmx1g -jar snpEff.jar build -embl -v spombe 2>&1 | tee spombe.build

# Dump
echo Dump database
java -Xmx1g -jar snpEff.jar dump spombe > spombe.dump

#!/bin/bash -eu
set -o pipefail

rm -rvf site/
mkdocs build
cp -vf src/docs/index.html site/

cd ~/workspace/SnpEff
rm -rvf docs/*
cp -rvf ~/snpEff/site/* docs/

./git/commit 'Documentation updated'

#-------------------------------------------------------------------------------
#
# Process data from Epigenome roadmap
#
#-------------------------------------------------------------------------------

macs="/sb/programs/diabetes_analysis/tools/MACS-1.4.2/bin/macs14"
dir=`pwd -P`"/sample-experiment"
macsDir=`pwd -P`"/macs"

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

#---
# Run peak finding algorithm
#---
for pair in \
            Adult_Liver/Histone_H3K27me3/BI.Adult_Liver.H3K27me3.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K27me3/BI.Adult_Liver.H3K27me3.5.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.5.bed.gz \
            Adult_Liver/Histone_H3K36me3/BI.Adult_Liver.H3K36me3.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K36me3/BI.Adult_Liver.H3K36me3.4.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.4.bed.gz \
            Adult_Liver/Histone_H3K36me3/BI.Adult_Liver.H3K36me3.5.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.5.bed.gz \
            Adult_Liver/Histone_H3K4me1/BI.Adult_Liver.H3K4me1.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K4me1/BI.Adult_Liver.H3K4me1.4.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.4.bed.gz \
            Adult_Liver/Histone_H3K4me1/BI.Adult_Liver.H3K4me1.5.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.5.bed.gz \
            Adult_Liver/Histone_H3K4me3/BI.Adult_Liver.H3K4me3.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K4me3/BI.Adult_Liver.H3K4me3.4.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.4.bed.gz \
            Adult_Liver/Histone_H3K4me3/BI.Adult_Liver.H3K4me3.5.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.5.bed.gz \
            Adult_Liver/Histone_H3K9ac/BI.Adult_Liver.H3K9ac.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K9ac/BI.Adult_Liver.H3K9ac.4.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.4.bed.gz \
            Adult_Liver/Histone_H3K9me3/BI.Adult_Liver.H3K9me3.3.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.3.bed.gz \
            Adult_Liver/Histone_H3K9me3/BI.Adult_Liver.H3K9me3.4.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.4.bed.gz \
            Adult_Liver/Histone_H3K9me3/BI.Adult_Liver.H3K9me3.5.bed.gz,Adult_Liver/ChIP-Seq_Input/BI.Adult_Liver.Input.5.bed.gz \
            Adipose_Tissue/Histone_H3K27ac/UCSD.Adipose_Tissue.H3K27ac.STL003.bed.gz,Adipose_Tissue/ChIP-Seq_Input/UCSD.Adipose_Tissue.Input.STL003.bed.gz \
			Pancreatic_Islets/Histone_H3K27me3/BI.Pancreatic_Islets.H3K27me3.pancreatic_islets_normal_3_27_09.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
			Pancreatic_Islets/Histone_H3K36me3/BI.Pancreatic_Islets.H3K36me3.pancreatic_islets_normal_3_27_09.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
			Pancreatic_Islets/Histone_H3K4me1/BI.Pancreatic_Islets.H3K4me1.pancreatic_islets_normal_3_27_09.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
			Pancreatic_Islets/Histone_H3K4me3/BI.Pancreatic_Islets.H3K4me3.pancreatic_islets_normal_3_27_09.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
			Pancreatic_Islets/Histone_H3K9ac/BI.Pancreatic_Islets.H3K9ac.pancreatic_islets_normal_3_27_09.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
			Pancreatic_Islets/Histone_H3K9me3/BI.Pancreatic_Islets.H3K9me3.pancreatic_islets_normal_0_0_00.bed.gz,Pancreatic_Islets/ChIP-Seq_Input/BI.Pancreatic_Islets.Input.pancreatic_islets_normal_3_27_09.bed.gz \
            Skeletal_Muscle/Histone_H3K27ac/BI.Skeletal_Muscle.H3K27ac.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K27me3/BI.Skeletal_Muscle.H3K27me3.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K27me3/BI.Skeletal_Muscle.H3K27me3.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K27me3/BI.Skeletal_Muscle.H3K27me3.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz \
            Skeletal_Muscle/Histone_H3K36me3/BI.Skeletal_Muscle.H3K36me3.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K36me3/BI.Skeletal_Muscle.H3K36me3.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K36me3/BI.Skeletal_Muscle.H3K36me3.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz \
            Skeletal_Muscle/Histone_H3K4me1/BI.Skeletal_Muscle.H3K4me1.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K4me1/BI.Skeletal_Muscle.H3K4me1.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K4me1/BI.Skeletal_Muscle.H3K4me1.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz \
            Skeletal_Muscle/Histone_H3K4me3/BI.Skeletal_Muscle.H3K4me3.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K4me3/BI.Skeletal_Muscle.H3K4me3.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K4me3/BI.Skeletal_Muscle.H3K4me3.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz \
            Skeletal_Muscle/Histone_H3K9ac/BI.Skeletal_Muscle.H3K9ac.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K9ac/BI.Skeletal_Muscle.H3K9ac.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K9ac/BI.Skeletal_Muscle.H3K9ac.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz \
            Skeletal_Muscle/Histone_H3K9me3/BI.Skeletal_Muscle.H3K9me3.19.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.19.bed.gz \
            Skeletal_Muscle/Histone_H3K9me3/BI.Skeletal_Muscle.H3K9me3.62.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.62.bed.gz \
            Skeletal_Muscle/Histone_H3K9me3/BI.Skeletal_Muscle.H3K9me3.63.bed.gz,Skeletal_Muscle/ChIP-Seq_Input/BI.Skeletal_Muscle.Input.63.bed.gz
do
    cs="$dir/"`echo $pair | cut -f 1 -d , | tr -d "\n"`
    input=$dir/`echo $pair | cut -f 2 -d , | tr -d "\n"`
    name=$macsDir/`basename $cs .bed.gz`

    echo $name
    echo $macs -t $cs -c $input -n $name -g hs | qsub
done

#---
# Intersect and create "consensus" peaks
#---

snpsift="java -Xmx1G -jar $HOME/snpEff/SnpSift.jar"
minOverlap=10
macs="macs/peaks/"
int2="$snpsift intersect -v -minOverlap $minOverlap -cluster 2 -intersect "
int3="$snpsift intersect -v -minOverlap $minOverlap -cluster 3 -intersect "

$int2 $macs/BI.Adult_Liver.H3K27me3.3_peaks.bed $macs/BI.Adult_Liver.H3K27me3.5_peaks.bed   > regulation.Adult_Liver.H3K27me3.peaks.bed
$int2 $macs/BI.Adult_Liver.H3K9ac.3_peaks.bed $macs/BI.Adult_Liver.H3K9ac.4_peaks.bed       > regulation.Adult_Liver.H3K9ac.peaks.bed

$int3 $macs/BI.Adult_Liver.H3K36me3.3_peaks.bed $macs/BI.Adult_Liver.H3K36me3.4_peaks.bed $macs/BI.Adult_Liver.H3K36me3.5_peaks.bed                   > regulation.Adult_Liver.H3K36me3.peaks.bed
$int3 $macs/BI.Adult_Liver.H3K4me1.3_peaks.bed $macs/BI.Adult_Liver.H3K4me1.4_peaks.bed $macs/BI.Adult_Liver.H3K4me1.5_peaks.bed                      > regulation.Adult_Liver.H3K4me1.peaks.bed
$int3 $macs/BI.Adult_Liver.H3K4me3.3_peaks.bed $macs/BI.Adult_Liver.H3K4me3.4_peaks.bed $macs/BI.Adult_Liver.H3K4me3.5_peaks.bed                      > regulation.Adult_Liver.H3K4me3.peaks.bed
$int3 $macs/BI.Adult_Liver.H3K9me3.3_peaks.bed $macs/BI.Adult_Liver.H3K9me3.4_peaks.bed $macs/BI.Adult_Liver.H3K9me3.5_peaks.bed                      > regulation.Adult_Liver.H3K9me3.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K27me3.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K27me3.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K27me3.63_peaks.bed    > regulation.Skeletal_Muscle.H3K27me3.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K36me3.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K36me3.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K36me3.63_peaks.bed    > regulation.Skeletal_Muscle.H3K36me3.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K4me1.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K4me1.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K4me1.63_peaks.bed       > regulation.Skeletal_Muscle.H3K4me1.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K4me3.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K4me3.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K4me3.63_peaks.bed       > regulation.Skeletal_Muscle.H3K4me3.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K9ac.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K9ac.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K9ac.63_peaks.bed          > regulation.Skeletal_Muscle.H3K9ac.peaks.bed
$int3 $macs/BI.Skeletal_Muscle.H3K9me3.19_peaks.bed $macs/BI.Skeletal_Muscle.H3K9me3.62_peaks.bed $macs/BI.Skeletal_Muscle.H3K9me3.63_peaks.bed       > regulation.Skeletal_Muscle.H3K9me3.peaks.bed

#!/bin/sh -e

# Genome name (in SnpEff's config file)
VER="GRCh38"
SUBVER="p7"
GENOME="$VER.$SUBVER.RefSeq"

# Path to scripts
SNPEFF_DIR="$HOME/snpEff"
SCRIPTS_DIR="$SNPEFF_DIR/scripts"
SCRIPTS_BUILD_DIR="$SNPEFF_DIR/scripts_build/data/$VER.RefSeq"
DB_DIR="$SNPEFF_DIR/data/$GENOME"

# File names
GFF_REF="ref_$VER.$SUBVER""_top_level.gff3.gz"
CHR_IDS="$DB_DIR/chromosomes.txt"
CHR_IDS_2_NAME="$DB_DIR/chromosomes2name.txt"

# Create dir
mkdir -p $DB_DIR/ORI
cd $DB_DIR/ORI

#---
# Download FASTA files
#---

echo Downloading reference seuquences
wget -N "ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/H_sapiens/Assembled_chromosomes/seq/hs_ref_$VER.$SUBVER\_*.fa.gz"

echo Downloading mRNA sequences
wget -N "ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/mRNA_Prot/human.*.rna.fna.gz"

echo Downloading protein sequences
wget -N "ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/mRNA_Prot/human.*.protein.faa.gz"

#---
# Download GFF data
#---

echo "Download GFF files"
wget -N ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/H_sapiens/GFF/$GFF_REF

echo "Copying genes.ORI.gff file"
cp $GFF_REF genes.ORI.gff.gz
gunzip -c genes.ORI.gff.gz > genes.ORI.gff

#---
# Download chromosome IDs file
#---

if [ -z "$ASSEMBLY_ID" ]
then
	ASSEMBLY_ID=`cat genes.ORI.gff | head -n 100 | grep "^#" | grep genome-build-accession | cut -f 2 -d :`
	echo "Assembly ID: $ASSEMBLY_ID"
fi

echo "Download chromosome IDs map file"
wget -O - ftp://ftp.ncbi.nlm.nih.gov/genomes/ASSEMBLY_REPORTS/All/$ASSEMBLY_ID.assembly.txt > $CHR_IDS

echo "Create a file mapping chromosome IDs to names: $CHR_IDS_2_NAME"
cat $CHR_IDS | cut -f 1,7 | grep -v "^#" > $CHR_IDS_2_NAME

#---
# Process files
#---

echo "Processing GFF file"
$SCRIPTS_BUILD_DIR/fix_gff.pl genes.ORI.gff $CHR_IDS_2_NAME > $DB_DIR/genes.gff 
gzip $DB_DIR/genes.gff

echo "Processing reference FASTA files"
gunzip -c hs_ref*.fa.gz | $SCRIPTS_BUILD_DIR/fix_fasta.pl $CHR_IDS_2_NAME | $SCRIPTS_DIR/fastaSplit.pl 

echo "Creating and compressing FASTA file $GENOME.fa"
cat chr[1-9].fa chr[1,2][0-9].fa chrX.fa chrY.fa chrMT.fa chr???*.fa | gzip -c > $DB_DIR/$GENOME.fa.gz

echo "Processing protein FASTA files"
gunzip -c human.?.protein.faa.gz | sed "s/^>gi|[0-9]*|ref|\(.*\)|.*/>\1/" > protein.ORI.fa 
cat protein.ORI.fa | $SCRIPTS_BUILD_DIR/fix_fasta_protein_cds.pl protein_id.map.txt > $DB_DIR/protein.fa
gzip $DB_DIR/protein.fa

echo "Processing RNA FASTA files"
gunzip -c human.?.rna.fna.gz | sed "s/^>gi|[0-9]*|ref|\(.*\)|.*/>\1/" > cds.ORI.fa 
cat cds.ORI.fa | $SCRIPTS_BUILD_DIR/fix_fasta_protein_cds.pl ids.map.txt > $DB_DIR/cds.fa
gzip $DB_DIR/cds.fa

echo "Done."

#!/bin/sh

#-------------------------------------------------------------------------------
# Convert the gene names in order to be used in an R script
#
# Usage: cat snpEff_genes.txt | ./scripts/genesTxtColumnNames.sh > genes.txt
#
# Once in R, you can:
#	- Load this table:
#			data <- read.csv("genes.txt", sep= "\t", header=TRUE);
#
#	- Access the data:
#			data$countINTRON
#
#	- Add missing or empty columns:
#			if( is.null(data$countINTRON ) { data$countINTRON <- 0 * (1:length(data$geneId) ); }
#
#																Pablo Cingolani
#-------------------------------------------------------------------------------

cat  \
    | grep -v "^# The following"\
    | sed "s/Bases affected (/bases/g" \
    | sed "s/Length (/len/g"  \
    | sed "s/Count (/count/g" \
    | sed "s/Total score (/score/g" \
    | sed "s/)//g" \
    | sed "s/#GeneId/geneId/" \
    | sed "s/GeneName/geneName/" \
    | sed "s/BioType/bioType/" \
    | sed "s/_PRIME//g" \
    | sed "s/SPLICE_SITE_//g" \
    | sed "s/SYNONYMOUS_CODING/SYN/g" \

#!/bin/sh -e

VCF="$HOME/snpEff/db/GRCh37/1kg/1kg.vcf"
VCF="$HOME/snpEff/db/GRCh37/1kg/1kg.no_gt.vcf"

REF=GRCh37.75
REF=hg19

VCFOUT_BASE=`dirname $VCF`/`basename $VCF .vcf`
VCFOUT_ANN=$VCFOUT_BASE.ann.vcf
VCFOUT_DBSNP=$VCFOUT_BASE.ann.dbSNp.vcf
VCFOUT_CLINVAR=$VCFOUT_BASE.ann.dbSNp.clinvar.vcf
VCFOUT_DBNSFP=$VCFOUT_BASE.ann.dbSNp.clinvar.dbNSFP.vcf

# Path to databases
DBDIR="$HOME/snpEff/db/GRCh37/"
DBSNP="$DBDIR/dbSnp/dbSnp.vcf"
DBCLINVAR="$DBDIR/clinvar/clinvar.vcf"
DBNSFP="$DBDIR/dbNSFP/dbNSFP.txt.gz"

#---
# Annotate
#---

time java -Xmx8G -jar snpEff.jar ann -v -noStats $REF $VCF > $VCFOUT_ANN

time java -Xmx8G -jar SnpSift.jar ann -v $DBSNP $VCFOUT_ANN > $VCFOUT_DBSNP

time java -Xmx8G -jar SnpSift.jar ann -v $DBCLINVAR $VCFOUT_DBSNP > $VCFOUT_CLINVAR

time java -Xmx8G -jar SnpSift.jar dbnsfp -v -db $DBNSFP $VCFOUT_CLINVAR > $VCFOUT_DBNSFP

#!/bin/sh

DIR=$HOME/snpEff/

java -Xmx3G \
	-classpath "$DIR/lib/charts4j-1.2.jar:$DIR/lib/flanagan.jar:$DIR/lib/freemarker.jar:$DIR/lib/junit.jar:$DIR/lib/trove-2.1.0.jar:$DIR" \
	ca.mcgill.mcb.pcingola.PromoterSequences \
	$*

#!/bin/sh -e

#---
# Download files
#---

# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/GFF/ref_Oar_v3.1_top_level.gff3.gz
# 
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr1.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr10.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr11.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr12.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr13.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr14.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr15.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr16.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr17.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr18.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr19.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr2.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr20.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr21.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr22.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr23.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr24.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr25.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr26.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr3.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr4.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr5.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr6.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr7.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr8.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chr9.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chrMT.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_chrX.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/Assembled_chromosomes/seq/oar_ref_Oar_v3.1_unplaced.fa.gz
#
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Ovis_aries/protein/protein.fa.gz
#
# mkdir ORI
# mv *.gz ORI

#---
# Create reference genome FASTA file
#---

zcat \
		ORI/oar_ref_Oar_v3.1_chr1.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr2.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr3.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr4.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr5.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr6.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr7.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr8.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr9.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr10.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr11.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr12.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr13.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr14.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr15.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr16.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr17.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr18.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr19.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr20.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr21.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr22.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr23.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr24.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr25.fa.gz \
		ORI/oar_ref_Oar_v3.1_chr26.fa.gz \
		ORI/oar_ref_Oar_v3.1_chrMT.fa.gz \
		ORI/oar_ref_Oar_v3.1_chrX.fa.gz \
		ORI/oar_ref_Oar_v3.1_unplaced.fa.gz \
	| sed "s/^>gi|.*|ref|\(N._.*\)|.*/>\1/" \
	> Oar_v3.1.fa
pigz Oar_v3.1.fa
mv Oar_v3.1.fa.gz ../genomes/


#---
# Create genes list
#---

zcat ORI/ref_Oar_v3.1_top_level.gff3.gz > genes.gff

grep "Parent=rna" genes.gff | grep CDS | cut -f 9 | tr ";" "\t" | cut -f 2,3 | tr "=" "\t" | cut -f 2,4 | uniq > replace_list.txt
cat genes.gff | ./replace.pl > genes.new.gff
mv genes.new.gff genes.gff


#---
# Create proteins list
#---

zcat ORI/protein.fa.gz \
	| sed "s/^>gi|.*|ref|\(.._.*\)|.*/>\1/" \
	> protein.fa

#!/bin/sh -e

#---
# Create ref sequence
#---

echo "Creating reference fasta"
rm -vf $HOME/snpEff/data/genomes/canFam3.103.fa

for fa in $HOME/snpEff/data/genomes/canFam3.103/chr*.fa
do
	chr=`basename $fa .fa`
	echo "    Chromosome $chr"

	cat $fa \
		| sed "s/^>gi|[0-9]*|ref|\(.*\)|.*/>\1/" \
		>> $HOME/snpEff/data/genomes/canFam3.103.fa
done

#---
echo "Build GFF file"
#---

zcat ORI/ref_CanFam3.1_top_level.gff3.gz \
	| ./fixGff.pl \
	> ./genes.gff

#---
echo "Build protein file"
#---

cat genes.gff \
	| grep CDS \
	| cut -f 9 \
	| tr ";" "\t" \
	| cut -f 1,2 \
	| grep Parent \
	| uniq \
	| tr "=" "\t" \
	| cut -f 2,4 \
	> cdsId_trId.txt

#---
#---

zcat ORI/protein.fa.gz \
	| sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" \
	| ./cdsId_trId.pl \
	> protein.fa

#---
echo "Build SnpEff database"
#---

cd $HOME/snpEff
java -Xmx4G -jar snpEff.jar build -v -gff3 canFam3.103 2>&1 | tee canFam3.103.build
java -Xmx4G -jar snpEff.jar dump canFam3.103 > canFam3.103.dump

#!/bin/sh

#cp ORI/Lusitatissimum_200.fa ../genomes/lusitatissimum_90.fa
#cp ORI/Lusitatissimum_200_gene_exons.gff3 ../genes.gff

cat ORI/Lusitatissimum_200_protein.fa \
	| sed "s/>.*PACid:/>PAC:/" \
	> protein.fa

cat ORI/Lusitatissimum_200_cds.fa \
	| sed "s/>.*PACid:/>PAC:/" \
	> cds.fa

#!/bin/sh

# Download files
#wget ftp://ftp.plantgdb.org/download/Genomes/PeGDB/Ppersica_139.fa.gz
#wget ftp://ftp.plantgdb.org/download/Genomes/PeGDB/Ppersica_139_gene.gff3.gz

( zcat Ppersica_139_gene.gff3.gz ; echo "###" ; echo "##FASTA" ; zcat Ppersica_139.fa.gz ) > genes.gff

#!/bin/sh

# # Test, only first columns
# #zcat GTEx_Analysis_RNA-seq_RNA-SeQCv1.1.8_gene_rpkm__Pilot_2013_01_31.gct.gz \
# #	| cut -f 1-20 \
# #	| grep -e ^Name -e ^ENS \
# #	> gtex.txt

cat GTEx_Analysis_2014-01-17_RNA-seq_RNA-SeQCv1.1.8_gene_rpkm.gct \
	| grep -e ^Name -e ^ENS \
	> gtex.txt

#!/bin/sh

zcat db/miRNA/human_predictions*.txt.gz \
	| ./scripts_build/mirna2bed.pl \
	| sort -k1,1 -k2,2g \
	> db/miRNA/human_predictions.bed

# This is for IGV
bgzip db/miRNA/human_predictions.bed
tabix -p bed db/miRNA/human_predictions.bed.gz

# Uncompress for java programs (they choke on bgzip input)
zcat db/miRNA/human_predictions.bed.gz > db/miRNA/human_predictions.bed

#!/bin/sh

echo
echo "WARNING: This database contains too many errors (88% of proteins do not match!)"
echo

cat ORI/AphidBase_OGS2.1b_withCDS.gff3 > genes.gff3
echo "##FASTA" >> genes.gff3
cat ORI/assembly2_scaffolds.fasta | sed "s/^>gi|[0-9]*|gb|\(.*\)\..*|.*/>\1/" | grep -v "^$" >> genes.gff3

cp ORI/aphidbase_2.1b_mRNA.fasta cds.fa
cat ORI/aphidbase_2.1b_pep.fasta | sed "s/-PA$/-RA/" > protein.fa

#!/bin/sh

cp $HOME/Downloads/Sitalica_164_v2.1.cds cds.fa
cp $HOME/Downloads/Sitalica_164_v2.1.protein protein.fa
cp $HOME/Downloads/Sitalica_164_v2 ../genomes/Sitalica_164_v2.1.fa

# Fix CDS names in GFF file (there are some errors in the GFF)
cat $HOME/Downloads/Sitalica_164_v2.1.gene \
    | sed "s/\.version2.1.CDS.[0-9]*/.CDS/" \
    | sed "s/\.version2.1//" \
    > genes.gff

#!/bin/sh

# Create GFF file with sequence
(cat ORI/Sbicolor_255_v2.1.gene_exons.gff3.gz ; echo "#" ; echo "##FASTA"; gunzip -c ORI/Sbicolor_v2.1_255.fa.gz ) > genes.gff 

# Create protein file
gunzip -c ORI/Sbicolor_255_v2.1.protein.gz | sed "s/^>.*ID=\(.*v2.1\) annot.*/>\1/" > protein.fa

# Create CDS file
gunzip -c ORI/Sbicolor_255_v2.1.cds.gz | sed "s/^>.*ID=\(.*v2.1\) annot.*/>\1/" > cds.fa

#!/bin/sh

# cp ORI/PlasmoDB-26_Pfalciparum3D7.gff genes.gff
# cp ORI/PlasmoDB-26_Pfalciparum3D7_Genome.fasta sequences.fa

cat ORI/PlasmoDB-26_Pfalciparum3D7_AnnotatedCDSs.fasta \
	| perl -pe 's|>(.*?) .*|>rna_\1-1|' \
	> cds.fa

cat ORI/PlasmoDB-26_Pfalciparum3D7_AnnotatedProteins.fasta \
	| perl -pe 's|>(.*?) .*|>rna_\1-1|' \
	> protein.fa

#!/bin/sh -e

SQLITE=$HOME/tools/sqlite3
SQLITE=sqlite3
OUT_FILE="sift.txt"
OUT_SORT_FILE="sift.sort.txt"
OUT_VCF="sift.vcf"

# Download files
for f in Human_CHR1.sqlite.gz Human_CHR10.sqlite.gz Human_CHR11.sqlite.gz Human_CHR12.sqlite.gz Human_CHR13.sqlite.gz Human_CHR14.sqlite.gz Human_CHR15.sqlite.gz Human_CHR16.sqlite.gz Human_CHR17.sqlite.gz Human_CHR18.sqlite.gz Human_CHR19.sqlite.gz Human_CHR2.sqlite.gz Human_CHR20.sqlite.gz Human_CHR21.sqlite.gz Human_CHR22.sqlite.gz Human_CHR3.sqlite.gz Human_CHR4.sqlite.gz Human_CHR5.sqlite.gz Human_CHR6.sqlite.gz Human_CHR7.sqlite.gz Human_CHR8.sqlite.gz Human_CHR9.sqlite.gz Human_CHRX.sqlite.gz Human_CHRY.sqlite.gz Human_Supp.sqlite.gz Human_enst.sqlite.gz 
do
	url=ftp://ftp.jcvi.org/pub/data/sift/Human_db_37_ensembl_63/$f
	echo Getting file $url 
	#wget $url
done

# Unzip files
for f in Human_CHR*.sqlite.gz
do
	echo Decompressing file $f 
	#gunzip $f
done

# Dumping data
rm -f $OUT_FILE
for f in Human_CHR*.sqlite
do
	echo Dumping Database $f to $OUT_FILE

	TABLES=`$SQLITE $f ".tables" | tr "\n" "\t"`
	for t in $TABLES
	do
		echo "    Dumping Table $t"

		$SQLITE $f "select CHR, COORD1, NT1, NT2, SCORE, MEDIAN, SEQS_REP from $t where SCORE != '' AND NT1 != NT2;" \
			| tr "|" "\t" \
			| sed "s/^chr//" \
			>> $OUT_FILE
	done
done

echo Sorting file
sort -k 1 -n -k 2 -n -o $OUT_SORT_FILE $OUT_FILE

echo Creating VCF 
cat $OUT_SORT_FILE | sift2vcf.pl > $OUT_VCF

#!/bin/sh -e

export VERSION=5.2

# Separate version-subversion by '_'
# E.g.: '4_1' (instead of '4.1')
export VERSION_UND=`echo $VERSION | tr '.' '_'`

#---
# Build SnpEff
#---

cd $HOME/workspace/SnpEff/

mvn clean compile assembly:single jar:jar

cp target/SnpEff-$VERSION-jar-with-dependencies.jar $HOME/snpEff/snpEff.jar

# Install JAR file in local Maven repo
mvn install:install-file \
	-Dfile=target/SnpEff-$VERSION.jar \
	-DgroupId=org.snpeff \
	-DartifactId=SnpEff \
	-Dversion=$VERSION \
	-Dpackaging=jar \
	-DgeneratePom=true \
	--quiet

cd - 

#---
# Build SnpSift
#---
cd $HOME/workspace/SnpSift/

mvn clean compile assembly:single jar:jar

cp target/SnpSift-$VERSION-jar-with-dependencies.jar $HOME/snpEff/SnpSift.jar

# Install JAR file in local Maven repo
mvn install:install-file \
	-Dfile=target/SnpSift-$VERSION.jar \
	-DgroupId=org.snpsift \
	-DartifactId=SnpSift \
	-Dversion=$VERSION \
	-Dpackaging=jar \
	-DgeneratePom=true \
	--quiet

cd - 

#---
# Update galaxy databases
#---
./scripts_build/galaxy.sh

echo "Build done!"

# Create direcotry for genome reference files
cd ~/snpEff
mkdir -p data/puccinia_striiformis_pst-78/ORI
cd data/puccinia_striiformis_pst-78/ORI
mv ~/Downloads/puccinia_striiformis_pst-78_1_* .

# Uncompress
unzip puccinia_striiformis_pst-78_1_data.zip
unzip puccinia_striiformis_pst-78_1_transcripts.gtf.zip
unzip puccinia_striiformis_pst-78_1_transcripts.fasta.zip
unzip puccinia_striiformis_pst-78_1_proteins.fasta.zip

# Copy files using the names SnpEff expects
cp puccinia_striiformis_pst-78_1_supercontigs.fasta ~/snpEff/data/genomes/puccinia_striiformis_pst-78.fa
cp puccinia_striiformis_pst-78_1_transcripts.gtf ../genes.gtf 
cp puccinia_striiformis_pst-78_1_transcripts.fasta ../cds.fa
cp puccinia_striiformis_pst-78_1_proteins.fasta ../protein.fa

# Add entry in config file
cd ~/snpEff
echo "puccinia_striiformis_pst-78.genome : puccinia_striiformis_pst-78" >> snpEff.config

# Build
java -jar snpEff.jar build -v puccinia_striiformis_pst-78

#!/bin/sh -e

#file=zzz.1660.txt.gz
file=$1

cat $file | ./filterAllZero.pl > circuits.non_zero.raw.txt
cut -f 1,2 circuits.non_zero.raw.txt | tr -d "-" | tr -s "_" > ids.txt
cut -f 3- circuits.non_zero.raw.txt > nums.txt

wc -l nums.txt ids.txt circuits.non_zero.raw.txt

# Create file
cat $file | head -n 1 |  tr -d "-" | tr -s "_" > circuits.non_zero.txt
paste ids.txt nums.txt >> circuits.non_zero.txt

head -n 1 circuits.non_zero.txt | tr "\t" "\n" > expNames.long.txt
head -n 1 circuits.non_zero.txt | tr "\t" "\n" | cut -f 1 -d "_" > expNames.short.txt
( echo -e "nameLong\tnameShort" ; paste expNames.long.txt expNames.short.txt ) > expNames.txt

rm -vf circuits.non_zero.raw.txt expNames.long.txt expNames.short.txt  ids.txt nums.txt

#!/bin/sh

# Download data
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/database/cpgIslandExt.txt.gz

# Annotate Shores & Shelves
gunzip -c cpgIslandExt.txt | cut -f 2- | ./cgShore.pl > cpgIslands_Shores_Shelf.bed
gzip cpgIslands_Shores_Shelf.bed

#!/bin/sh

# GFF
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/GFF/ref_Macaca_fascicularis_5.0_top_level.gff3.gz

# Fasta
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr1.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr10.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr11.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr12.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr13.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr14.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr15.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr16.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr17.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr18.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr19.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr2.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr20.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr3.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr4.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr5.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr6.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr7.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr8.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chr9.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chrMT.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_chrX.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_unlocalized.fa.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/Assembled_chromosomes/seq/mfa_ref_Macaca_fascicularis_5.0_unplaced.fa.gz

# Protein
wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/protein/protein.fa.gz

# RNA
wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Macaca_fascicularis/RNA/rna.fa.gz

#!/bin/sh

REF=hg19

#---
# Download latest datasets
#---

# # Genome sequence
# wget http://hgdownload.cse.ucsc.edu/goldenPath/$REF/bigZips/chromFa.tar.gz
# 
# # Protein sequences
# wget ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/mRNA_Prot/human.protein.faa.gz
# 
# # CDS sequences
# wget ftp://ftp.ncbi.nlm.nih.gov/refseq/H_sapiens/mRNA_Prot/human.rna.fna.gz
# 
# # RefLink
# wget http://hgdownload.cse.ucsc.edu/goldenPath/$REF/database/refLink.txt.gz
# 
# #---
# # Create files
# #---
# gunzip refLink.txt.gz
# 
# # Protein fasta
# zcat human.protein.faa.gz | ../../scripts/proteinFasta2NM.pl refLink.txt > protein.fa
# gzip protein.fa
# 
# # CDS fasta
# zcat human.rna.fna.gz | sed "s/^>gi|[0-9]*|ref|\(.*\)\..*|.*/>\1/" > cds.fa 
# gzip cds.fa

# Chromosome fasta
#rm -rvf chr
#mkdir chr 
cd chr
#tar -xvzf ../chromFa.tar.gz

FASTA=../$REF.fa
echo Creating FASTA file
rm -vf $FASTA
cat chr[1-9].fa	>> $FASTA
cat chr??.fa	>> $FASTA
cat chr[A-Z].fa	>> $FASTA
cat chr???*.fa	>> $FASTA

cd -

# # Compress genome file
# $HOME/tools/pigz/pigz hg19.fa
# cp hg19.fa.gz $HOME/snpEff/data/genomes/

#!/bin/sh -e

zcat c_remanei.WS234.annotations.gff3.gz \
    | grep -v "^#" \
    | grep -v SNP \
    | grep -v translated_nucleotide_match \
    | grep -v repeat_region \
    | grep -v inverted_repeat \
    | grep -v tandem_repeat \
    | grep -v nucleotide_match \
    | grep -v intron \
    > genes.gff

# Add fasta sequence
echo "###" >> genes.gff
echo "##FASTA" >> genes.gff
zcat c_remanei.WS230.genomic.fa.gz >> genes.gff

#!/bin/sh

# Delete old databases
rm -vf *.bin

# Create genes file
gunzip -c ../hg19/genes.refseq.gz \
	| grep -w \
			-e binNum \
			-e NM_001269 -e NM_001048194 -e NM_001048195 -e NM_001048199 \
			-e NM_001242466 -e NM_006218 -e NM_181504 -e NM_181523 -e NM_181524 \
			-e NM_001048194 -e NM_001048195 -e NM_001048199 -e NM_001269 \
	> genes.refseq

# Build chromosome reference sequence
cd ../genomes
rm -vf testHg19Pdb.fa.gz
for chr in `cat ../testHg19Pdb/genes.refseq | cut -f 3 | sort | uniq `
do
	echo chr=$chr
	cat hg19/$chr.fa.gz >> testHg19Pdb.fa.gz
done

# Build database
cd $HOME/snpEff
java -Xmx4g -jar snpEff.jar build -v testHg19Pdb

# Build PDB test database
java -Xmx4g -jar snpEff.jar pdb -v -pdbDir $HOME/snpEff/tests_snpeff/pdb testHg19Pdb 

#!/bin/sh

# echo Creating reference genome fasta file
# zcat ORI/cfe_ref_CB1_chrMT.fa.gz | sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" > ../genomes/camelus_ferus.fa
# zcat ORI/cfe_ref_CB1_chrUn.fa.gz | sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" >> ../genomes/camelus_ferus.fa
# 
# echo Creating proteins fasta file
# zcat ORI/protein.fa.gz | sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" > protein.fa
# 
# echo Creating RNA fasta file
# zcat ORI/rna.fa.gz | sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" > cds.fa
# 
echo Creating GFF
zcat ORI/ref_CB1_top_level.gff3.gz | grep "Parent=rna" | cut -f 3- | grep ^CDS | cut -f 7 | tr ";" "\t" | cut -f 2,3 | tr "=" "\t" | cut -f 2,4 | uniq > replace_list.txt
zcat ORI/ref_CB1_top_level.gff3.gz | ./replace.GFF_ID_Parent.pl > genes.gff


echo Done

#!/bin/sh -e

zcat c_briggsae.WS230.annotations.gff3.gz \
	| grep -v SNP \
	| grep -v translated_nucleotide_match \
	| grep -v repeat_region \
	| grep -v inverted_repeat \
	| grep -v tandem_repeat \
	| grep -v nucleotide_match \
	> genes.gff

# Add fasta sequence
echo "###" >> genes.gff
echo "##FASTA" >> genes.gff
zcat c_briggsae.WS230.genomic.fa.gz >> genes.gff

#!/bin/sh

gunzip -c ORI/parastrongyloides_trichosuri.PRJEB515.WBPS3.annotations.gff3.gz \
	| sed "s/gene://" \
	| sed "s/transcript://" \
	| sed "s/exon://" \
	| sed "s/cds://" \
	> genes.gff

echo "##FASTA" >> genes.gff

gunzip -c ORI/parastrongyloides_trichosuri.PRJEB515.WBPS3.genomic.fa.gz >> genes.gff

cp ORI/parastrongyloides_trichosuri.PRJEB515.WBPS3.CDS_transcripts.fa.gz cds.fa.gz
cp ORI/parastrongyloides_trichosuri.PRJEB515.WBPS3.protein.fa.gz protein.fa.gz

#!/bin/sh

# Create a file with genomes databases list
# Remove the first two lines (titles)
mkdir -p galaxy/tool-data
(
	echo "# SnpEff databases"
	echo "# List created using command: java -jar snpEff.jar databases"
	echo "# Version    Description"
	java -jar snpEff.jar databases \
		| tail -n +3 \
		| cut -f 1,2 \
		| awk '{ print $1, "\t", $2, " ", $1 }' \
		| sort -k 2
) > galaxy/tool-data/snpEff_genomes.loc

# Copy to 'sample'
cp galaxy/tool-data/snpEff_genomes.loc galaxy/tool-data/snpEff_genomes.loc.sample

#!/bin/sh

# Download  FASTA
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG2.4_release/S_lycopersicum_chromosomes.2.50.fa.gz
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG2.4_release/ITAG2.4_cds.fasta
#wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG2.4_release/ITAG2.4_proteins.fasta

# Download GFF3
# wget ftp://ftp.solgenomics.net/tomato_genome/annotation/ITAG2.4_release/ITAG2.4_gene_models.gff3

# Create genes.gff
echo Decompressing the file
cp ITAG2.4_gene_models.gff3 genes.gff

echo Fixing start-end problem
cat genes.gff | ./fixStartEnd.pl | ./removeExonFrame.pl > g
mv g genes.gff

# Append FASTA Sequences
echo Append FASTA
echo "###" >> genes.gff
echo "##FASTA" >> genes.gff
zcat S_lycopersicum_chromosomes.2.50.fa.gz >> genes.gff

echo Create CDS file
cat ITAG2.4_cds.fasta | sed "s/^>/>mRNA:/" > cds.fa

echo Create Proteins file
cat ITAG2.4_proteins.fasta | sed "s/^>/>mRNA:/" > protein.fa

#!/bin/sh

#-------------------------------------------------------------------------------
# Files
#-------------------------------------------------------------------------------

in=$1													# Input VCF file
eff=`dirname $in`/`basename $in .vcf`.snpeff.vcf		# SnpEff annotated VCF file
out=`dirname $in`/`basename $in .vcf`.gatk.vcf			# Output VCF file (annotated by GATK)

ref=$HOME/snpEff/data/genomes/hg19.fa					# Reference genome file
dict=`dirname $ref`/`basename $ref .fa`.dict			# Reference genome: Dictionary file

#-------------------------------------------------------------------------------
# Path to programs and libraries
#-------------------------------------------------------------------------------

gatk=$HOME/tools/gatk/GenomeAnalysisTK.jar
picard=$HOME/tools/picard/
snpeff=$HOME/snpEff/snpEff.jar

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

# Create genome index file
echo
echo "Indexing Genome reference FASTA file: $ref"
samtools faidx $ref
 
# Create dictionary
echo
echo "Creating Genome reference dictionary file: $dict"
java -jar $picard/CreateSequenceDictionary.jar R= $ref O= $dict
 
# Annotate
echo
echo "Annotate using SnpEff"
echo "    Input file  : $in"
echo "    Output file : $eff"
java -Xmx4G -jar $snpeff -c $HOME/snpEff/snpEff.config -v -o gatk hg19 $in > $eff

# Use GATK
echo
echo "Annotating using GATK's VariantAnnotator:"
echo "    Input file  : $in"
echo "    Output file : $out"
java -Xmx4g -jar $gatk \
	-T VariantAnnotator \
	-R $ref \
	-A SnpEff \
	--variant $in \
	--snpEffFile $eff \
	-L $in \
	-o $out

#!/bin/sh

#---
# Download
#---

mkdir ORI
cd ORI
wget http://www.icrisat.org/gt-bt/ICGGC/genomedata.zip
unzip genomedata.zip
cd -

#---
# Get propper chromosome names in FASTA file
#---

cat ORI/genomedata/assembly/Cicer_arietinum_GA_v1.0.masked.fa \
	| sed "s/^>\(\S*\).*/>\1/" 
  > Cicer_arietinum_v1.fa

gzip Cicer_arietinum_v1.fa
mv Cicer_arietinum_v1.fa.gz ~/snpEff/data/genomes/

#---
# Creage GFF file
#---
cat ORI/genomedata/annotation/02.gene/Cicer_arietinum_GA_v1.0.gene.gff \
	ORI/genomedata/annotation/03.ncRNA/Cicer_arietinum_GA_v1.0_ncRNA_annotation_*.gff \
	> genes.gff

cat ORI/genomedata/annotation/02.gene/Cicer_arietinum_GA_v1.0.gene.cds.fa \
	| sed "s/^>\(\S*\).*/>\1/" \
	> cds.fa

cat ORI/genomedata/annotation/02.gene/Cicer_arietinum_GA_v1.0.gene.pep.fa \
	| sed "s/^>\(\S*\).*/>\1/" \
	> protein.fa

#!/bin/sh -e

#-------------------------------------------------------------------------------
#
# Download a GenBank file form NCBI and build the corresponding SnpEff database
#
# Note: It is assumed to be run form SnpEff's directory and that 
#       the 'data' directory is 'data'
#
# Usage example:
#     $ cd ~/snpEff
#     $ ./scripts/buildDbNcbi.sh CP000724.1
#
#															Pablo Cingolani 2015
#-------------------------------------------------------------------------------

#---
# Command line arguments
#---
ID=$1

if [ -z "$ID" ]
then
	echo "Usage: $0 ncbi_genbank_accession"
	exit 1
fi

DIR="data/$ID"
GENE_FILE="$DIR/genes.gbk"

#---
# Download data
#---

# Create db directory
mkdir -p "$DIR" >/dev/null 2>&1 || true

# Download GenBank file
echo "Downloading genome $ID"
curl "https://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=nucleotide&id=$ID&rettype=gbwithparts&retmode=text" > $GENE_FILE

#---
# Build database
#---

# Add entry to config file
echo "$ID.genome : $ID" >> snpEff.config

# Build database
java -jar snpEff.jar build -v $ID

#!/bin/sh

mkdir ORI

# Download genome
wget http://agambiae.vectorbase.org/downloads/public_data/organism_data/agambiae/Genome/agambiae.CHROMOSOMES-PEST.AgamP3.fa.gz
wget http://agambiae.vectorbase.org/downloads/public_data/organism_data/agambiae/Geneset/agambiae.PEPTIDES-AgamP3.7.fa.gz
wget http://agambiae.vectorbase.org/downloads/public_data/organism_data/agambiae/Geneset/agambiae.BASEFEATURES_PEST-AgamP3.7.gtf.gz 
wget http://agambiae.vectorbase.org/downloads/public_data/organism_data/agambiae/Geneset/agambiae.TRANSCRIPTS-AgamP3.7.fa.gz

# Create genome file
mv agambiae.CHROMOSOMES-PEST.AgamP3.fa.gz ../genomes/agam3.7.fa.gz
gunzip ../genomes/agam3.7.fa.gz
echo "Edit and change chromosome names in FASTA file"
gzip ../genomes/agam3.7.fa

# Genes
mv agambiae.BASEFEATURES_PEST-AgamP3.7.gtf.gz ORI
cp ORI/agambiae.BASEFEATURES_PEST-AgamP3.7.gtf.gz genes.gtf.gz 

# Proteins
zcat ORI/agambiae.PEPTIDES-AgamP3.7.fa.gz | sed "s/^>\([^ ]*\)\(.*\)/>\1/" | sed "s/-P/-R/" > protein.fa 
gzip protein.fa 

# CDSs
mv agambiae.TRANSCRIPTS-AgamP3.7.fa.gz ORI
zcat ORI/agambiae.TRANSCRIPTS-AgamP3.7.fa.gz | sed "s/^>\([^ ]*\)\(.*\)/>\1/" > cds.fa
gzip cds.fa 

#!/bin/bash -eu
set -o pipefail

PROGRAM_DIR=$(cd $(dirname $0); pwd -P)

# Reference
# https://ftp.ncbi.nih.gov/genomes/refseq/vertebrate_mammalian/Homo_sapiens/annotation_releases/109.20200815/

VER="GRCh38"
SUBVER="p13"
ASSEMBLY_ID="GCF_000001405.39"
RELEASE="109.20200815"
GENOME="$VER.$SUBVER.RefSeq"

# Path to scripts
SNPEFF_DIR="$HOME/snpEff"
SCRIPTS_DIR="$SNPEFF_DIR/scripts"
SCRIPTS_BUILD_DIR="$PROGRAM_DIR"
DB_DIR="$SNPEFF_DIR/data/$GENOME"

# URLs
HTTP_URL="http://ftp.ncbi.nih.gov/"
HTTP_DIR="$HTTP_URL/genomes/refseq/vertebrate_mammalian/Homo_sapiens/all_assembly_versions/${ASSEMBLY_ID}_${VER}.${SUBVER}"

URL_BASE="$HTTP_DIR/${ASSEMBLY_ID}_${VER}.${SUBVER}_"
URL_SEQ="${URL_BASE}genomic.fna.gz"
URL_RNASEQ="${URL_BASE}rna.fna.gz"
URL_PROTSEQ="${URL_BASE}protein.faa.gz"
URL_GTF="${URL_BASE}genomic.gtf.gz"
URL_ASSEMBLY_REPORT="${URL_BASE}assembly_report.txt"

# Files
CHR_IDS_2_NAME="$DB_DIR/ORI/chromosomes2name.txt"
GTF_ORI="$DB_DIR/ORI/${ASSEMBLY_ID}_${VER}.${SUBVER}_genomic.gtf.gz"
FASTQ_ORI="$DB_DIR/ORI/${ASSEMBLY_ID}_${VER}.${SUBVER}_genomic.fna.gz"
PROT_FASTA_ORI="$DB_DIR/ORI/${ASSEMBLY_ID}_${VER}.${SUBVER}_protein.faa.gz"
RNA_FASTA_ORI="$DB_DIR/ORI/${ASSEMBLY_ID}_${VER}.${SUBVER}_rna.fna.gz"

#---
# Download files
#---

# Create dir
mkdir -p $DB_DIR/ORI
cd $DB_DIR/ORI

echo "Download reference genome"
wget -N "$URL_SEQ"

echo Downloading mRNA sequences
wget -N "$URL_RNASEQ"

echo Downloading protein sequences
wget -N "$URL_PROTSEQ"

echo "Download GTF files"
wget -N "$URL_GTF"

echo "Download chromosome IDs map file"
wget -N "$URL_ASSEMBLY_REPORT"

cd ..

#---
# Chromosome IDs file
#---

echo "Create a file mapping chromosome IDs to names: $CHR_IDS_2_NAME"
cat "ORI/${ASSEMBLY_ID}_${VER}.${SUBVER}_assembly_report.txt" | cut -f 1,7 | grep -v "^#" > "$CHR_IDS_2_NAME"

#---
# Process files
#---

echo "Processing GFF file"
$SCRIPTS_BUILD_DIR/fix_gtf.pl "$GTF_ORI" "$CHR_IDS_2_NAME" > "$DB_DIR/genes.gtf"

echo "Processing reference FASTA files"
gunzip -c "$FASTQ_ORI" | $SCRIPTS_BUILD_DIR/fix_fasta.pl "$CHR_IDS_2_NAME" > "$DB_DIR/sequences.fa"

echo "Processing protein FASTA files"
gunzip -c "$PROT_FASTA_ORI" | $SCRIPTS_BUILD_DIR/fix_fasta_protein_cds.pl protein_id.map.txt > "$DB_DIR/protein.fa"

echo "Processing RNA FASTA files"
gunzip -c "$RNA_FASTA_ORI" | perl -pe 's/^>(\S+).*/>$1/' > "$DB_DIR/mrna.fa"

#---
# Compress
#---
pigz -v genes.gtf mrna.fa protein.fa protein_id.map.txt sequences.fa

echo "Done."

#!/bin/sh

# #---
# # Download sequences
# #---
#
# wget http://rapdb.dna.affrc.go.jp/download/archive/irgsp1/IRGSP-1.0_genome.fasta.gz
# wget http://rapdb.dna.affrc.go.jp/download/archive/irgsp1/IRGSP-1.0_representative_2013-04-24.tar.gz
# wget http://rapdb.dna.affrc.go.jp/download/archive/irgsp1/IRGSP-1.0_protein_2013-04-24.fasta.gz
# wget http://rapdb.dna.affrc.go.jp/download/archive/irgsp1/IRGSP-1.0_cds_2013-04-24.fasta.gz
# 
# mkdir ORI
# mv IRGSP-1.0_* ORI/
# 
# # Add genome
# cp ORI/IRGSP-1.0_genome.fasta.gz ../genomes/rice_rap201304.fa.gz

# # Genes
# gunzip ORI/IRGSP-1.0_representative_2013-04-24.tar.gz
# tar -xvf ORI/IRGSP-1.0_representative_2013-04-24.tar
# mv IRGSP-1.0_representative_2013-04-24/* ORI/
# rmdir IRGSP-1.0_representative_2013-04-24

# Note: mRnas are missing Parent info (same thing happened in rice5, so I have a script for fixing this)
cat ORI/locus.gff ORI/transcripts.gff ORI/transcripts_exon.gff \
	| $HOME/snpEff/data/rice5/mRnaAddParent.pl \
	| sort -k1,1 -k4n,4n \
	| uniq \
	> genes.gff


cp ORI/IRGSP-1.0_cds_2013-04-24.fasta.gz cds.fa.gz
cp ORI/IRGSP-1.0_protein_2013-04-24.fasta.gz protein.fa.gz

#!/bin/sh -e 

# Genes to use
#cat GPCRs.txt | grep -v "$^" | tr "\n" "," > genes.txt
cat t2d_genes.txt | grep -v "$^" | tr "\n" "," | tr -d " \t"  > genes.txt

#---
# Prepare GTEx IDs file
#---
rm -vf gtex.ids || true
touch gtex.ids

for tissue in Brain Liver Pancreas Skeletal Subcutaneous Visceral
do

	tis=`echo $tissue | tr " -" "__" | tr -s "_" | tr "[a-z]" "[A-Z]"`
	echo $tissue $tis

	cat $HOME/snpEff/db/GTEx/gtex_ids.txt \
		| cut -f 1,4,7 \
		| grep -i $tissue \
		>> gtex.ids
done

# Create comma separated list of IDs
cat gtex.ids | cut -f 1 | grep -v "$^" | tr "\n" "," > gtexIds.comma.txt

cat gtex.ids \
	| cut -f 3 \
	| grep -v "$^" \
	| tr " " "_" \
	| tr "-" "_" \
	| tr -s "_" \
	| tr "\n" "," \
	| tr -cd "[a-z][A-Z][0-9],._" \
	> gtexLabels.comma.txt

# Select genes with expression (at least minValCount of the experiments)
./heatMap.py gtex_norm.txt `cat gtexIds.comma.txt` `cat gtexLabels.comma.txt` `cat genes.txt` > heatMap.txt

# Sort file by name
head -n 1 heatMap.txt > header.txt
grep -v -f header.txt heatMap.txt | sort > tmp.txt
cat header.txt tmp.txt > heatMap.txt

#---
# Invoke R script
#---
Rscript heatMap.r
Rscript boxPlots.r

#!/bin/sh -e

# mkdir ORI
cd ORI

#---
echo "Download data"
#---

# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/GFF/ref_CanFam3.1_top_level.gff3.gz
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/protein/protein.fa.gz

# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr1.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr10.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr11.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr12.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr13.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr14.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr15.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr16.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr17.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr18.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr19.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr2.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr20.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr21.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr22.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr23.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr24.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr25.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr26.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr27.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr28.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr29.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr3.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr30.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr31.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr32.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr33.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr34.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr35.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr36.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr37.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr38.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr4.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr5.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr6.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr7.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr8.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chr9.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chrMT.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_chrX.fa.gz	
# wget ftp://ftp.ncbi.nlm.nih.gov/genomes/Canis_lupus_familiaris/Assembled_chromosomes/seq/cfa_ref_CanFam3.1_unplaced.fa.gz


#---
echo "Build reference FASTA file"
#---

# Create 'chr.sh' script to change chromosome names
echo "#!/bin/sh" > chr.sh
echo >> chr.sh
echo "cat \\" >> chr.sh

for fa in cfa_ref_CanFam3.1_chr*.fa.gz
do
	chr=`echo $fa | cut -f 2 -d . | cut -f 2 -d _`
	chrName=`zcat $fa | head -n 1 | sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/\1/"`
	echo "    | sed \"s/$chrName/$chr/g\" \\" >> chr.sh
done
chmod a+x chr.sh

zcat  \
		cfa_ref_CanFam3.1_chr1.fa.gz \
		cfa_ref_CanFam3.1_chr2.fa.gz \
		cfa_ref_CanFam3.1_chr3.fa.gz \
		cfa_ref_CanFam3.1_chr4.fa.gz \
		cfa_ref_CanFam3.1_chr5.fa.gz \
		cfa_ref_CanFam3.1_chr6.fa.gz \
		cfa_ref_CanFam3.1_chr7.fa.gz \
		cfa_ref_CanFam3.1_chr8.fa.gz \
		cfa_ref_CanFam3.1_chr9.fa.gz \
		cfa_ref_CanFam3.1_chr10.fa.gz \
		cfa_ref_CanFam3.1_chr11.fa.gz \
		cfa_ref_CanFam3.1_chr12.fa.gz \
		cfa_ref_CanFam3.1_chr13.fa.gz \
		cfa_ref_CanFam3.1_chr14.fa.gz \
		cfa_ref_CanFam3.1_chr15.fa.gz \
		cfa_ref_CanFam3.1_chr16.fa.gz \
		cfa_ref_CanFam3.1_chr17.fa.gz \
		cfa_ref_CanFam3.1_chr18.fa.gz \
		cfa_ref_CanFam3.1_chr19.fa.gz \
		cfa_ref_CanFam3.1_chr20.fa.gz \
		cfa_ref_CanFam3.1_chr21.fa.gz \
		cfa_ref_CanFam3.1_chr22.fa.gz \
		cfa_ref_CanFam3.1_chr23.fa.gz \
		cfa_ref_CanFam3.1_chr24.fa.gz \
		cfa_ref_CanFam3.1_chr25.fa.gz \
		cfa_ref_CanFam3.1_chr26.fa.gz \
		cfa_ref_CanFam3.1_chr27.fa.gz \
		cfa_ref_CanFam3.1_chr28.fa.gz \
		cfa_ref_CanFam3.1_chr29.fa.gz \
		cfa_ref_CanFam3.1_chr30.fa.gz \
		cfa_ref_CanFam3.1_chr31.fa.gz \
		cfa_ref_CanFam3.1_chr32.fa.gz \
		cfa_ref_CanFam3.1_chr33.fa.gz \
		cfa_ref_CanFam3.1_chr34.fa.gz \
		cfa_ref_CanFam3.1_chr35.fa.gz \
		cfa_ref_CanFam3.1_chr36.fa.gz \
		cfa_ref_CanFam3.1_chr37.fa.gz \
		cfa_ref_CanFam3.1_chr38.fa.gz \
		cfa_ref_CanFam3.1_chrMT.fa.gz \
		cfa_ref_CanFam3.1_chrX.fa.gz \
		cfa_ref_CanFam3.1_unplaced.fa.gz \
	| sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" \
	| ./chr.sh \
	> ../../genomes/canFam3.1.fa

#---
echo "Build GFF file"
#---

zcat ref_CanFam3.1_top_level.gff3.gz \
	| ../fixGff.pl \
	| ./chr.sh \
	> ../genes.gff

cat ../genes.gff \
	| grep CDS \
	| cut -f 9 \
	| tr ";" "\t" \
	| cut -f 1,2 \
	| grep Parent \
	| uniq \
	| tr "=" "\t" \
	| cut -f 2,4 \
	> cdsId_trId.txt

#---
echo "Build protein file"
#---

zcat protein.fa.gz \
	| sed "s/^>gi|[0-9]*|ref|\(.*\..*\)|.*/>\1/" \
	| ../cdsId_trId.pl \
	> ../protein.fa

#---
echo "Build SnpEff database"
#---

cd ../../..
java -Xmx10G -jar snpEff.jar build -v -gff3 canFam3.1 2>&1 | tee canFam3.1.build
java -Xmx10G -jar snpEff.jar dump canFam3.1 > canFam3.1.dump

#!/bin/sh -e

#---
# Download
#---
for chr in LG1 LG2 LG3 LG4 LG5 LG6 LG7 LG8 LG9 LG10 LG11 LG12 LG13 LG14 LG15 LG16 MT
do
	echo "Download chromosome $chr"

	# Download GFF file
	#wget "http://biomirror.aarnet.edu.au/biomirror/ncbigenomes/Apis_mellifera/special_requests/gff/ame_ref_Amel_4.5_chr$chr.gff3.gz"

	# Download FASTA files
	#wget "ftp://ftp.ncbi.nih.gov/genomes/Apis_mellifera/Assembled_chromosomes/seq/ame_ref_Amel_4.5_chr$chr.fa.gz"
done

#---
echo "Create one GFF3 file"
#---
touch genes.gff
rm -vf genes.gff
for chr in LG1 LG2 LG3 LG4 LG5 LG6 LG7 LG8 LG9 LG10 LG11 LG12 LG13 LG14 LG15 LG16 MT
do
	echo "    $chr"
	gunzip -c "ame_ref_Amel_4.5_chr$chr.gff3.gz" >> genes.gff
done

# Some entries do not have ID, remove those.
# Note: There are not so many (only 300 or so)
#	$ cat genes.ori.gff | grep -v ID= | wc -l 
#     322
mv genes.gff genes.ori.gff 
cat genes.ori.gff | grep ID= > genes.gff

#---
echo "Create one FASTA file"
#---
touch amel4.5.fa
rm -vf amel4.5.fa
for chr in LG1 LG2 LG3 LG4 LG5 LG6 LG7 LG8 LG9 LG10 LG11 LG12 LG13 LG14 LG15 LG16 MT
do
	echo "    $chr"
	gunzip -c "ame_ref_Amel_4.5_chr$chr.fa.gz" \
		| sed "s/^>gi|.*|\(NC_.*\)|.*/>\1/" \
		>> amel4.5.fa
done

# Move fasta file
mv amel4.5.fa ../genomes/

- [ ] T_arvense_v2 assembly for Thlaspi arvense

Download
- [ ] ensembl
- [ ] ensemblBfmpp
- [ ] ucsc
- [ ] ucsckg
- [ ] mane
- [ ] pdb
- [ ] dbsnp
- [ ] dbnsfp
- [ ] cytobands
- [ ] jaspar
- [ ] gwasCatalog
- [ ] nextprot
- [x] clinvar
- [ ] flybase

# SnpSift Concordance

Calculate concordance between two VCF files.

### Typical usage

This is typically used when you want to calculate concordance between a genotyping experiment and a sequencing experiment.

For instance, you sequenced several samples and, as part of a related experiment or just as quality control, you also genotype the same samples using a genotyping array.
Now you want to compare the two experiments.
Ideally there would be no difference between the variants from genotyping and sequencing, but this is hardly the case in real world.

You can use `SnpSift concordance` to measure the differences between the two experiments.

!!! warning
    It is assumed that both VCF files are sorted by chromosome and position.

!!! warning
    Sample names are defined in '#CHROM' line of the header section.
    Concordance is calculated only if sample label matches in both files.

Example:
```
$ java -Xmx1g -jar SnpSift.jar concordance -v genotype.vcf sequencing.vcf > concordance.txt
00:00:00.000	Indexing file 'genotype.vcf'
        index:	MT	460030998
        index:	1	19705
                1 / 2	45170805 / 45174315
                2 / 3	77052081 / 77055591
                3 / 4	104065531 / 104069041
                4 / 5	124098372 / 124101881
                5 / 6	146535292 / 146538802
                6 / 7	184793526 / 184797035
                7 / 8	206156508 / 206160018
                8 / 9	223072816 / 223076326
                9 / 10	242315995 / 242319505
                10 / 11	261053789 / 261057299
                11 / 12	290190553 / 290194063
                12 / 13	312869636 / 312873146
                13 / 14	321966539 / 321970049
                14 / 15	336131317 / 336134827
                15 / 16	350871669 / 350875179
                16 / 17	368900523 / 368904032
                17 / 18	391305860 / 391309369
                18 / 19	398932237 / 398935747
                19 / 20	425219198 / 425222708
                20 / 21	437022008 / 437025517
                21 / 22	442563678 / 442567188
                22 / X	451783418 / 451786927
                X / Y	459553691 / 459557200
                Y / MT	459588787 / 459592296
00:00:01.137	Open VCF file 'genotype.vcf'
00:00:01.141	Open VCF file 'sequencing.vcf'
00:00:01.176	Chromosome: '1'
00:00:02.127		1:1550992	1:1528859
00:00:02.739		1:2426313	1:2389636
...
00:02:13.780		1:248487058	1:248471945
```

### Output

SnpSift's concordance output is written to STDOUT and two files.
For instance the command `java -jar SnpSift.jar concordance -v genotype.vcf sequencing.vcf` will write:

* Concordance by variant: Written to STDOUT
* Concordance by sample: Written to `concordance_genotyping_sequencing.by_sample.txt`
* Summary:  Written to `concordance_genotyping_sequencing.summary.txt`

#### Concordance by variant

This sections is a table showing concordance details for every entry (chr:position) that both files have in common.
E.g.:
```
chr  pos     ref  alt  change_0_0  change_0_1  change_0_2  change_1_0  change_1_1  change_1_2  change_2_0  change_2_1  change_2_2  missing_genotype_genotype  missing_genotype_sequencing
1    865584  G    A        508         0           0           0           2           0           0           0           0           0                                 5
1    865625  G    A        512         0           0           0           1           0           0           0           0           0                                 1
1    865628  G    A        511         0           0           0           2           0           0           0           0           0                                 1
1    865665  G    A        495         0           0           0           4           0           0           0           0           0                                17
1    865694  C    T        428         0           0           0          82           0           0           0           4           0                                 0
```
Each genotype is coded according to the number of ALT variants. i.e.:

* '0/0' (homozygous reference) is coded as '0'
* '0/1' or '1/0' (heterozygous ALT) coded as '1'
* '1/1' (homozygous ALT) is coded as '1'

So the column "change_X_Y" on the table shows how many genotypes coded 'X' in the first VCF, changed to 'Y' in the second VCF.
For example, 'change_0_1' counts the number of "homozygous reference in genotype.vcf" that changed to "heterozygous ALT in sequencing.vcf".
Or 'change_2_2' counts the number of "homozygous ALT" that did not change (in both files they are '2').

A few rules apply:

* If a VCF entry (chr:pos) is present in only one of the files, obviously we cannot calculate concordance, so it is ignored.
* If a VCF entry (chr:pos) has more than one ALT it is ignored. This means that non-biallelic variants are ignored.
* If, for the same chr:pos, REF field is different between the two files, then the entry is ignored.
* If, for the same chr:pos, ALT field is different between the two files, then the entry is ignored.

#### Concordance by sample

This section shows details in the same format as the previous section.
Here, concordance metrics are shown aggregated for each sample.
E.g.:
```
# Totals by sample
sample  change_0_0  change_0_1  change_0_2  change_1_0  change_1_1  change_1_2  change_2_0  change_2_1  change_2_2  missing_genotype_genotype  missing_genotype_sequencing
ID_003  79          0           0           1           8           0           0           0           2           1                          1
ID_004  83          0           0           1           2           0           0           0           5           0                          1
ID_005  80          0           0           0           7           0           0           0           4           1                          0
ID_006  79          0           0           0           5           0           0           0           6           0                          2
ID_008  81          0           0           0           4           0           0           0           4           0                          3
ID_009  80          0           0           0           7           0           0           0           3           0                          2
ID_012  74          0           0           0           10          0           0           0           1           0                          7
ID_013  79          1           0           0           4           0           0           0           5           0                          3
ID_018  84          0           0           0           5           0           0           0           3           0                          0
...
```

#### Summary

Summary file contains overall information and errors.
Here is an example of a summary file:
```
$ cat concordance_genotyping_sequencing.summary.txt
Number of samples:
    929    File genotype.vcf
    583    File sequencing.vcf
    514    Both files
Errors:
        ALT field does not match	19
```
The header indicates that one file ('genotype.vcf') has 929 samples, the other file has 583 and there are 514 matching sample IDs in both files.

At the end of the file, a footer shows the total for each column followed by number of possible errors (or mismatches).
In this case the were 19 ALT fields that did not match between 'genotype.vcf' and 'sequencing.vcf'.
This can happen, for instance, when there are INDELs, which cannot be detected by genotyping arrays.

!!! info
    Summary messages are shown to STDERR if you use verbose mode (command line option `-v`).

# SnpEff and SnpSift: Test cases

SnpEff and SnpSift have a comprehensive set of unit and integration test cases.

Some of these test cases require genome databases or other large files, see instructions below on how to download and install the test files.

### Nomenclature

In this document we assume you have the following variables properly set in your environment

```
# Change this to where you installed the SnpEff project from GitHub
export SNPEFF_PROJECT_DIR="$HOME/workspace/SnpEff"

# Change this to your SnpEff install dir
export SNPEFF_DIR="$HOME/snpEff"
```

### Install test datasets

- Note that the download link includes a SnpEff version, so it might change in future releases

- Download the [test dataset here](https://snpeff.blob.core.windows.net/databases/data_test_5.0.tar) 

- Untar and move the files to your SnpEff's `data` directory
```
# Here we assume that your 'data' directory is in '$SNPEFF_DIR/data'
cd $SNPEFF_DIR/data
tar -cvf path/to/data_test.5.0.tar
mv data_test/* .
```

## SnpEff Unit tests

To run unit test suite, you can run the following commands:

```
cd $SNPEFF_PROJECT_DIR

java -Xmx4g \
    -cp $SNPEFF_DIR/snpEff.jar \
    org.junit.runner.JUnitCore \
    org.snpeff.snpEffect.testCases.TestSuiteUnity \
    2>&1 \
    | tee testcases.snpeff.unity.txt
```

## SnpEff integration tests

To run integration test suite, you can run the following commands:

```
cd $SNPEFF_PROJECT_DIR

java -Xmx4g \
    -cp $SNPEFF_DIR/snpEff.jar \
    org.junit.runner.JUnitCore \
    org.snpeff.snpEffect.testCases.TestSuiteUnity \
    2>&1 \
    | tee testcases.snpeff.unity.txt
```

## SnpSift tests

To run SnpSift test suite, you can run the following commands:

```
cd $SNPEFF_PROJECT_DIR

java -Xmx4g \
    -cp $SNPEFF_DIR/SnpSift.jar \
    org.junit.runner.JUnitCore \
    org.snpsift.testCases.TestSuiteAll \
    2>&1 \
    | tee testcases.snpsift.all.txt
```

# CLAUDE.md

This file provides guidance to Claude Code (claude.ai/code) when working with code in this repository.

## Project Overview

SnpEff is a variant annotation and effect prediction tool for genomic variants. It's a Java-based bioinformatics application that analyzes VCF files and predicts the functional effects of genetic variants.

Documentation: https://pcingola.github.io/SnpEff/

## Build System

The project uses Maven for building and BDS (BigDataScript) for automation tasks.

### Building JAR files

```bash
# Build SnpEff JAR with dependencies
mvn clean compile assembly:single jar:jar

# The output JAR will be in target/SnpEff-5.2-jar-with-dependencies.jar
```

### Running SnpEff

Use the wrapper script that handles Java memory options:

```bash
# Using the wrapper script
./scripts/snpEff [options]

# Direct JAR execution
java -Xms1g -Xmx8g -jar snpEff.jar [options] -c snpEff.config
```

The main class is `org.snpeff.SnpEff`.

## Testing

Tests use JUnit Jupiter (JUnit 5):

```bash
# Run all tests using Maven
mvn test

# Run specific test class
mvn test -Dtest=TestCasesVcf

# Run BDS-based integration tests
./src/bds/integration_test.bds
```

Test files are located in:
- `src/test/java/org/snpeff/snpEffect/testCases/unity/` - Unit tests
- `src/test/java/org/snpeff/snpEffect/testCases/integration/` - Integration tests
- `tests/` - Test data files (VCF, FASTA, etc.)

## Code Architecture

### Core Packages

- `org.snpeff` - Main entry point and top-level commands
- `org.snpeff.snpEffect` - Core effect prediction engine
  - `Config` - Configuration management for genomes and databases
  - `SnpEffectPredictor` - Main predictor that analyzes variants
  - `VariantEffect` - Represents predicted effects on genes/transcripts
  - `commandLine/` - Command-line interface implementations for all subcommands
  - `factory/` - Factories for building genome databases
- `org.snpeff.interval` - Genomic intervals (genes, transcripts, exons, chromosomes)
  - Core genomic feature classes: `Gene`, `Transcript`, `Exon`, `Chromosome`, `Genome`
  - `Marker` - Base class for genomic intervals
  - `Variant` - Represents genetic variants
- `org.snpeff.vcf` - VCF file parsing and manipulation
  - `VcfEntry`, `VcfFileIterator` - Core VCF handling
- `org.snpeff.fileIterator` - File format parsers (VCF, GFF, GTF, BED, GenBank, etc.)
- `org.snpeff.outputFormatter` - Output formatters for different formats

### Command Line Structure

The main `SnpEff` class dispatches to subcommand implementations in `org.snpeff.snpEffect.commandLine`:
- `SnpEffCmdEff` - Main annotation command (default: "ann")
- `SnpEffCmdBuild` - Build genome databases from GTF/GFF files
- `SnpEffCmdDownload` - Download pre-built databases
- `SnpEffCmdDatabases` - List available databases
- And many more specialized commands

### Configuration

Configuration is managed through `.config` files in the `config/` directory:
- `snpEff.config` - Main configuration (symlink to `config/snpEff.config`)
- `config/snpEff.core.config` - Core configuration settings
- `config/snpEff.ENSEMBL_*.config` - Ensembl genome configurations
- Configuration files define genome data directories and database locations

## Database Building

Database building is orchestrated using BDS scripts (`src/bds/make.bds`):

```bash
# Build a specific genome database (requires genome data in data/ directory)
java -jar snpEff.jar build -v <genome_name>

# Download pre-built database
java -jar snpEff.jar download <genome_name>
```

Genome data is expected in `data/<genome_name>/` directory with:
- `genes.gtf` or `genes.gff` - Gene annotations
- `sequences.fa` - Reference genome sequences

## Java Version

The project requires Java 21 (specified in pom.xml compiler configuration).

## Key Design Patterns

- Command pattern: Each SnpEff subcommand is implemented as a separate class implementing `CommandLine` interface
- Iterator pattern: File parsers use iterator pattern for memory-efficient processing of large genomic files
- Factory pattern: Genome database factories handle different source formats (GTF, GFF, GenBank, EMBL)
- Serialization: Genome databases are pre-built and serialized to `.bin` files for fast loading

## Companion Tool: SnpSift

SnpSift is a companion tool developed in a separate repository but typically distributed together with SnpEff. The build script (`scripts_build/make.sh`) builds both tools.

# SnpSift Intervals Index

This is used to extract variants that intersect any interval.

!!! warning
    This is similar to "SnpSift intervals", but intended for huge VCF files, and relatively small number of intervals.

This command indexes the VCF file, thus is optimized for huge VCF files.
You must provide intervals as BED files.
BED format is tab separated zero-based coordinates "chr \t start \t end " (for this application, all other fields in the BED file are ignored).
You can use command line option '-if 1' if you want one-based coordinates.

E.g.:

    java -jar SnpSift.jar intidx variants.vcf my_intervals.bed > variants_intersecting_intervals.vcf

You can also have genomic coordinate in the command line.
Note that in this case, coordinates are assumed to be one-based (instead of zero-based, like in BED files):

    java -jar SnpSift.jar intidx -c variants.vcf chr1:12345-23456 chr2:3456789-4567890  > variants_intersecting_intervals.vcf


!!! warning
    BED file format is tab separated zero-based coordinates "chr \t start \t end " (for this application, all other fields in the BED file are ignored).

!!! warning
    If BED file has header lines, they must start with a '#'

# Features, versions and roadmap
##  1. Roadmap

Major features planned:

* **SnpEff**: Improvements in loss of function analysis
* **SnpSift**: Switch to ANTLR 4.X, handle arbitrary expressions.
				
## 2. Features

Features by version

**Version: 4.3 (2016-09).**

* Improved support for gene fusions
* Annotation of large structural variants


**Version: 4.1 (2015-01).**

* Standard annotation format: 'ANN' INFO field
* A better / more robust HGVS implementation
* Variants are re-aligned to the most 3'UTR (in agreement with HGVS).


**Version: 4.0 (2014-11).**

* Consistent 'help' screen when using command line option `-h`
* Effects sorted canonical transcripts first (for same level of effect / impact)
* Corrected problem on LOF annotations for gene names having spaces.


**Version: 4.0 (2014-07).**

* HGVS notations (now is default)
* Sequence Ontology terms (now by default)
* SnpEff downloads databases automatically
* Automatic third party databases downloads
* Support for new genome versions (such as GRCh38 / hg38)
* NextProt, Loss of function (LOF) and Nonsense mediated decay (MND) annotations by default
* Improved protein coding transcript detection (when building databases)
* Full support for MIXED variants: E.g. Some variants maybe a combination of Insertions, Deletions, SNPs or MNPs.
* Major code refactoring
* SnpSift `annotate`: Improved annotate support.
* SnpSift `dbNsfp`: Several improvements on annotation methods.
* Added support for gVCF files
                

**Version: 3.6 (2013-05-23).**

* Improved support for MIXED variants: E.g. Some variants maybe a combination of Insertions, Deletions, SNPs or MNPs.
* Improved HGVS notation
* SnpSift: `concordance`: Calculate concordance statistics between two VCF files (e.g. a sequencing and a chip-genotyping experiment)
* SnpSift: `vcfCheck` command (check VCF for several "common" problems)
* Moved to Java 7. mostly due to several problems in Java 6 libraries when reading bgzip files.


**Version: 3.5 (2013-03-23).**

* Improvements in cancer sample annotations
* Added `SPLICE_REGION` annotation
* SnpSift `private`: Annotate if a variant is "private" to a family (or cohort)
* SnpSift: `ccs`: Case / control summary statistics (of annotated files).
* SnpSift ` annotate `: Added tabix indexed files support. Automatic detection.


**Version: 3.4 (2013-11-23).**

* Automatic database download ("-download" option)
* Cancer samples: can be defined using a TXT file instead of VCF header.
* Improved GenBank
* Extended configuration options
* Better frame handling for GTF/GFF files
* Improvements in HGVS notation
* Galaxy support: Improvements and bug fixes
* SnpSift: Better support for dbNSFP (v2.1)


**Version: 3.3 (2013-06-12).**

* Over **8,500** genomes supported.
* All ENSEMBL (version 18) : Bacteria, Fungi, Metazoa, Plants and Protist genomes added.
* NextProt annotations added
* Motif annotations support added
* SnpSift: GeneSet annotations
* SnpEff count: Genomic region statistics counting reads, variants, intervals, etc.
                

** Version: 3.2 (2013-14-01).**

* **Cancer variants analysis**
* **GATK** compatible (`-o gatk`)
* HGVS notations support


**Version: 3.1 (2012-11-02).**

* All NCBI bacterial genomes added: Over 2,500 genomes added!
* Loss of function effect and tag added (experimental command line option '-lof')
* Nonsense-mediated decay effect and tag added (experimental command line option '-lof')
* ENSEMBL version 68 genomes added
* SnpEff 'countReads' count number of reads and bases (form a BAM file) on each gene, transcript, exon, intron, etc.
* SnpEff Intron and Intergenic annotations improved.


**Version: 3.0, revision 'f' (2012-08-23).**

* GATK output format compatibility option: '-o gatk'
* Fixed problem when parsing comment after GFF headers.
* Added GENCODE tags for GTF parsing
* Splice site analysis tools
* Analysis of U12 branch sites.
* Minor problems caused by empty VCF headers solved.
* Fixed bug in calculation of degenerate sites.
* Fixed problem in canonical transcripts.
* Plasmodium falciparum hand curated versions (by Daniel Park, Broad): Pf3D7v72 and Pf3D7v90
* Maven project, created by Louis Letourneau.
* Project source code changed to SVN (Louis Letourneau).
* Databases will be 'backwards compatible' from now on.
* New format for VCF files: added CDS length in amino acid (AA_LEN field).
* Canonical transcript filter (command line option "-canon").
* Improved GenBank parsing.
* SnpSift 'dbnsfp': Annotate using dbNSFP (Louis Letourneau).
* SnpSift 'gwasCat': Added GWA catalog annotations.
* SnpSift 'extractFields': extract fields to TXT files (tab separated)
* SnpSift 'sift': Annotate using SIFT database.
* SnpSift 'Annotate' and 'AnnMem': Now support to add all fields in a VCF file for annotations.


**Version: 2.1b (2012-04-26).**

* Revision "2.1c" : Maven project (by Louis Letourneau)
* Revision "2.1c" : Improved Galaxy wrappers (by Peter briggs)
* Revision "2.1b" : Improved RefSeq parsing
* Revision "2.1a" : Multi-thread race condition solved.
* **Note** If you are using **hg19**, it is recommended to download the latest database (due to improved RefSeq parsing in 2.1b).
* Added multi-threaded support (command line option '-t').
* GenBank support for building databases. See details [here](se_buildingdb.md#option-4-building-a-database-from-genbank-files).
* Config file simplified
* E.Coli database added
* Galaxy download database option added.
* Added all ENSEMBL version 66 genomes
* Database 'download' issue solved. Apparently SourceForge servers were choking on URL that had double slashes, this should not happen. Implemented a workaround.
* SnpSift GWAS catalog: Annotate using [GWAS Catalog](http://www.genome.gov/gwastudies/).
* SnpSift: Added 'varType' to annotate variant type (SNP/MNP/INS/DEL), as well as HOM/HET if possible.
* Faster VCF processing.
				

**Version: 2.0.5 (2011-11-25).**

* Support for RARE amino acids (see details [here](se_inputoutput.md#details-about-rare-amino-acid-effect))
* Database for Soybean (Glycine max) added


**Version: 2.0.5 (2011-11-25).**

* Database download command, e.g. "java -jar snpEff.jar download GRCH37.64"
* Added all ENSEMBL version 65 genomes
* RefSeq annotations support added.
* Rogue transcript filter: By default SnpEff filters out some suspicious transcripts from annotations databases. This should improve false positive rates.
* Amino acid changes in HGVS style (VCF output)
* Optimized parsing for VCF files with large number of samples (genotypes).
* Option to suppress summary calculation ('-noStats'), can speed up processing considerably in cases where VCF files have hundreds or thousands of genotype fields.
* Option '-onlyCoding' is set to 'auto' to reduce number of false positives (see next).
* Option '-onlyCoding' can be assigne a value: If value is 'true', report only 'protein_coding' transcripts as protein coding changes. If 'false', report all transcript as if they were conding. Default: Auto, i.e. if transcripts any marked as 'protein_coding' the set it to 'true', if no transcripts are marked as 'protein_coding' then set it to 'false'.
* Added BED output format. This is usefull to annotate the output of a Chip-Seq experiment (e.g. after performing peak calling with MACS, you want to know where the peaks hit).
* Added BED Annotation output format. This is usefull to get all annotation intervals that intersect a set of variants (or genomic regions).
* **SnpSift filter**:
    
     * Added generic index ('*') for variables, genotypes and effects. E.g.: ( 'GEN\[\*].GT = '1|1' )
     * Added support for 'EFF' and subfields (from SnpEff processed files). E.g.: ( EFF\[\*].EFFECT = 'NON_SYNONYMOUS_CODING' )
    
* **SnpSift intidx**: 
    Designed to extract a small number of intervals from huge VCF files. 
    Added indexing using  memory mapped I/O files for retrieving intervals from huge VCF files. 
    Works really fast! 


**Version: 2.0.3 (2011-10-08)**

* Functional classes added in VCF output (i.e. NONE, SILENT, MISSENSE, NONSENSE)
* Added MODIFIER effect 'impact'.
* Rice genome added.
* Added all ENSEMBL version 64 genomes.
* Several minor issues solved.
* Report usage statistics to server (can be disabled using '-noLog' options).


**Version: 2.0.2 (2011-09-09)**

* VCF output format
* **[GATK](http://www.broadinstitute.org/gsa/wiki/index.php/The_Genome_Analysis_Toolkit)** integration. Now you can use SnpEff from GATK's [VariantAnnotator](http://www.broadinstitute.org/gsa/wiki/index.php/Adding_Genomic_Annotations_Using_SnpEff_and_VariantAnnotator).
* Default input file is STDIN. I.e. inputFile parameter can be ommited now.
* Gene list outputs to a TXT file (tab separated) instead of the summary (HTML) file.
* Command line format changed for various options
* Option '-sort' deprecated.


**Version: 1.9.6 (2011-08-08)**

* Ensembl genomes v63 added.
* **Warning!** Genome names changed to agree with Ensembl naming convention, here are the names:

    Full name              | Short name
    ---------------------- | ------------
    Ailuropoda_melanoleuca |  ailMel1.63
    Anolis_carolinensis    |  AnoCar2.0.63
    Bos_taurus             |  Btau_4.0.63
    Caenorhabditis_elegans |  WS220.63
    Callithrix_jacchus     |  C_jacchus3.2.1.63
    Canis_familiaris       |  BROADD2.63
    Cavia_porcellus        |  cavPor3.63
    Choloepus_hoffmanni     |  choHof1.63
    Ciona_intestinalis      |  JGI2.63
    Ciona_savignyi          |  CSAV2.0.63
    Danio_rerio             |  Zv9.63
    Dasypus_novemcinctus    |  dasNov2.63
    Dipodomys_ordii         |  dipOrd1.63
    Drosophila_melanogaster |  BDGP5.25.63
    Echinops_telfairi       |  TENREC.63
    Equus_caballus          |  EquCab2.63
    Erinaceus_europaeus     |  HEDGEHOG.63
    Felis_catus             |  CAT.63
    Gallus_gallus           |  WASHUC2.63
    Gasterosteus_aculeatus  |  BROADS1.63
    Gorilla_gorilla         |  gorGor3.63
    Homo_sapiens            |  GRCh37.63
    Loxodonta_africana      |  loxAfr3.63
    Macaca_mulatta          |  MMUL_1.63
    Macropus_eugenii        |  Meug_1.0.63
    Meleagris_gallopavo     |  UMD2.63
    Microcebus_murinus      |  micMur1.63
    Monodelphis_domestica   |  BROADO5.63
    Mus_musculus            |  NCBIM37.63
    Myotis_lucifugus        |  Myoluc2.0.63
    Nomascus_leucogenys     |  Nleu1.0.63
    Ochotona_princeps       |  pika.63
    Ornithorhynchus_anatinus |  OANA5.63
    Oryctolagus_cuniculus    |  oryCun2.63
    Oryzias_latipes          |  MEDAKA1.63
    Otolemur_garnettii       |  BUSHBABY1.63
    Pan_troglodytes          |  CHIMP2.1.63
    Pongo_abelii             |  PPYG2.63
    Procavia_capensis        |  proCap1.63
    Pteropus_vampyrus        |  pteVam1.63
    Rattus_norvegicus        |  RGSC3.4.63
    Saccharomyces_cerevisiae |  EF3.63
    Sorex_araneus            |  COMMON_SHREW1.63
    Spermophilus_tridecemlineatus |  SQUIRREL.63
    Sus_scrofa               |  Sscrofa9.63
    Taeniopygia_guttata      |  taeGut3.2.4.63
    Takifugu_rubripes        |  FUGU4.63
    Tarsius_syrichta         |  tarSyr1.63
    Tetraodon_nigroviridis   |  TETRAODON8.63
    Tupaia_belangeri         |  TREESHREW.63
    Tursiops_truncatus       |  turTru1.63
    Vicugna_pacos            |  vicPac1.63
    Xenopus_tropicalis       |  JGI_4.2.63

* Problems with VCF heterozygous: Fixed
* Problems parsing some InDels: Fixed
* Error conditions on deletion at the border between UTR and Exon: Fixed
* Problems reporting some CDS relative positions: Fixed
* Some issues related to distance calculation on Downstream genes on negative strands: Fixed


**Version: 1.9.5 (2011-03-10)**

* Variants per gene table.
* Improvements in summary report.
* Improved GFF3 parsing.
* Several genomes added.


**Version: 1.9 (2011-03-10)**
Features recently added:

* Improved command line
* Genomes added (Arabidopsis) : alyrata107, athaliana130
* Genomes added (all ENSEMBL version 61): 
  
          ailmel1.61, anoCar2.0.61, btau4.0.61, bushBaby1.61, calJac3.2.1.61, canFam2.61, 
          cat1.61, cavPor3.61, ce.WS220.61, chimp2.1.61, choHof1.61, cInt2.61, cSav2.0.61, 
          danRer9.61, dasNov2.61, dipOrd1.61, dm5.25.61, equCab2.61, eriEur1.61, fugu4.61, 
          gacu1.61, ggallus2.61, gorGor3.61, hg37.61, loxAfr3.61, medaka1.61, meug1.0.61, 
          micMur1.61, mm37.61, mmul1.61, monDom5.61, myoLuc1.61, oana5.61, ochPri2.61, 
          oryCun2.61, ppyg2.61, proCap1.61, pteVam1.61, rat3.4.61, sacCer2.61, sorAra1.61, 
          speTri1.61, sScrofa9.61, taeGut3.2.4.61, tarSyr1.61, tenrec1.61, tetraodon8.61, 
          tupBel1.61, turkey.UMD2.61, turTru1.61, vicPac1.61, xtrop4.1.61

* Genomes added (Flybase): dm5.34
* Genomes added (legacy hg18): hg36.54
* Improved summary and statistics
* Supports BED format: if you just need to check where an interval hits (e.g. exon, intron, genes, etc.)
* Added support for GTF 2.2 format
* Improved robustness of GFF3 and GFF2 parsing
* Improved splice site detection: SPLICE_SITE_DONOR and SPLICE_SITE_ACCEPTOR
* Improved support for insertions and deletions: CODON_INSERTION, CODON_CHANGE_PLUS_CODON_INSERTION, CODON_DELETION, CODON_CHANGE_PLUS_CODON_DELETION 
* Improved support for large deletions: EXON_DELETED and UTR_DELETED
* Added suport for INTRON_CONSERVED and INTERGENIC_CONSERVED intervals (available in GTF 2.2 files)
* Added support for ambiguous sequences in exons (e.g. sequences that have "N")
* Database dump support: 

         java -jar snpEff.jar dump genome_version

* CDS testing support: 

         java -jar snpEff.jar cds genome_version cds.fasta


**Older features **

* Show DNA and amino acid sequence before and after change: option "-a, --around", e.g. "-a 5" shows 5 codons around sequence change)
* **WARNING**: Since version 1.7 snpEff assumes one-based coordinates (i.e. option "-1" is the default instead of "-0")
* **WARNING**: Since version 1.7 snpEff does not sort sequence changes. You should use option "-sort" if you want that.
* Genomes added (Pseudomonas): Pseudomonas aeruginosa (paeru.PA01 and paeru.PA14) and Pseudomonas fluorescens (pfluo.SBW25.NC_009444 and pfluo.SBW25.NC_012660)
* Genomes supported (all ENSEMBL version 60): 
        
            ailMel1.60, amel2, anoCar1.0.60, btau4.0.59, btau4.0.60, bushBaby1.60,
            calJac3.2.1.60, canFam2.59, canFam2.60, cat1.60, cavPor3.60, ce6, ce.WS210.60,
            chimp2.1.59, chimp2.1.60, choHof1.60, cInt2.60, cSav2.0.60, danRer6, danRer8.59,
            danRer9.60, dasNov2.60, dipOrd1.60, dm3, dm5.12, dm5.22, dm5.25.59, dm5.25.60,
            dm5.30, dm5.31, equCab2.60, eriEur1.60, fugu4.60, gacu1.60, ggallus2.59, ggallus2.60,
            gorGor3.60, hg37, hg37.59, hg37.60, loxAfr3.60, medaka1.60, meug1.0.60, micMur1.60,
            mm37, mm37.59, mm37.60, mmul1.60, monDom5.60, myoLuc1.60, oana5.60, ochPri2.60,
            oryCun2.60, ppyg2.60, proCap1.60, pteVam1.60, rat3.4.59, rat3.4.60, sacCer2,
            sacCer2.59, sacCer2.60, SIVmac239, sorAra1.60, speTri1.60, sScrofa9.60,
            taeGut3.2.4.60, tarSyr1.60, tenrec1.60, testCase, tetraodon8.60, tupBel1.60,
            turTru1.60, vicPac1.60, xtrop4.1.60

* VCF4 input format is now supported
* Support new genome Apis Mellifera
* Statistics and plots
* Filter intervals (only analyze selected intervals)
* One-based and zero-based positions for input and output (as well arbitrary offsets)
* Support for heterozygous SNPs (e.g. A/W)
* Predicts insertions and deletions (FRAME_SHIFT)
* Supports GFF format when building databases.
* Added: Multiple nucleotide polymorphisms (MNPs)
* New format shows SNP quality and coverage.
* Can filter SNPs, InDels and MNPs based on quality, coverage and zygosity (Hom/Het).

# SnpSift Variant type

Adds an INFO field denoting variant type.

It adds "SNP/MNP/INS/DEL/MIXED" in the INFO field.
It also adds "HOM/HET", but this last one works if there is only one sample (otherwise it doesn't make any sense).
```
$ java -jar SnpSift.jar varType  test.vcf | grep -v "^#" | head
20	10469	.	C	G	100.0	PASS	SNP;HOM	GT:AP	0|0:0.075,0.060
20	10492	.	C	T	100.0	PASS	SNP;HET	GT:AP	0|1:0.180,0.345
20	10575	.	C	CG	100.0	PASS	DEL;HET	GT:AP	0|1:0.000,0.000
20	10611	.	CG	C	100.0	PASS	INS;HET	GT:AP	0|1:0.000,0.010
20	10618	.	GT	TA	100.0	PASS	MNP;HET	GT:AP	0|1:0.020,0.030
```

# SnpSift `annotateMem` Command Documentation

The `annotateMem` command is a, high-performance tool for annotating VCF files using pre-built “databases” such as dbSnp, ClinVar, GnomAD, Cosmic, and more. It is optimized to handle large VCF files—annotating over 1 million VCF lines per minute in many cases. This is achieved by converting database VCF files into memory-optimized dataframes indexed by chromosome and variant type.

---

## Overview

The annotation process is divided into **two steps**:

1. **Create the Database:**
   - **Purpose:** Convert one or more VCF files (e.g., from ClinVar, dbSnp, Cosmic, etc.) into a database.
   - **Note:** Although the database creation step can take a long time, it only needs to be performed once per database. Subsequent annotations will leverage the pre-built databases, making the overall process very efficient.

2. **Annotate VCF Files:**
   - **Purpose:** Annotate your input VCF file(s) by querying the databases created in step 1.
   - **Performance:** During annotation, only the relevant dataframes for the current chromosome are loaded into memory, allowing for quick, in-memory searches for each VCF record.

---

## How It Works

- **Database Creation:**  
  The INFO fields from the provided VCF file are extracted and stored in a memory-optimized dataframe. The dataframe is indexed by chromosome and variant type, which facilitates rapid lookups during the annotation step.

- **Annotation:**  
  During annotation, each VCF line is enriched with the fields from the corresponding database entries by performing a fast in-memory search of the pre-built dataframes.

---

## Command Line Usage

### Creating a Database

When creating a database, specify the `-create` option along with one or more `-dbfile` parameters and the corresponding `-fields` that you want to include in the database.

**Example:**  
Create a database using ClinVar VCF, incorporating the INFO fields `CLNSIG`, `CLNDN`, and `ID`:

```bash
java -Xmx16G -jar SnpSift.jar \
    annmem \
    -create \
    -dbfile 'db/clinvar.2024-11-03.vcf' \
    -fields 'CLNSIG,CLNDN,ID'
```


When a database is created, it is stored in a dedicated directory named after the original VCF file, with the suffix `.snpsift.vardb` appended. For example, if your input VCF file is named `clinvar.vcf`, the resulting database will be saved in a directory called `clinvar.vcf.snpsift.vardb`.

Within this directory, the database is partitioned by chromosome. Each chromosome has its own file named following the pattern `{chromosomeName}.snpsift.df`. These files contain the serialized dataframes that store the selected INFO fields for that specific chromosome, enabling fast and efficient in-memory lookups during the annotation step.

Example: When creating a database for `clinvar.2024-11-03.vcf`, the following directory is created
```
# ls clinvar.2024-11-03.vcf.snpsift.vardb/
10.snpsift.df
11.snpsift.df
12.snpsift.df
13.snpsift.df
14.snpsift.df
15.snpsift.df
16.snpsift.df
    ...
MT.snpsift.df
X.snpsift.df
Y.snpsift.df
```


### Annotating a VCF File

Once the database(s) have been created, use the `annmem` command to annotate your input VCF file. You can specify multiple databases to annotate the VCF simultaneously.

**Example:**  
Annotate an input VCF file using multiple databases:

```bash
java -Xmx16G -jar SnpSift.jar \
   annmem \
   -dbfile 'db/clinvar.vcf.gz' \
   -dbfile 'db/dbSnp.151.vcf.gz' \
   -dbfile 'db/cosmic-v92.vcf.gz' \
   input.vcf \
   > input.ann.vcf
```

During this annotation step, the required dataframes are loaded into memory on a per-chromosome basis, ensuring efficient processing.

**Note:** If no `fields` parameter is used in the annotation command, all field in the database are used.

**Note:** If a variant from the input VCF file does not have an entry the database/s, then no INFO field is added.

**Note:** You can specify `-addAnnotated` to add the `ANNOTATED` flag to every VCF entry, so downstream processes know the VCF entry was annotated.

---

## Command Options

Below is a summary of the available command options for `annotateMem`:

- `-addAnnotated`  
  When annotating, add an `ANNOTATED` flag to every INFO field, this is added even if there are no annotations from the database/s added (e.g. because the variant doesn't have an entry in the databases).

- `-create`  
  Create one or more databases from the provided VCF file(s) using specific INFO field(s).

- `-dbfile file.vcf`  
  Use the specified VCF file. This file is either used to create a database or to provide annotation data.

- `-fields field_1,field_2,...,field_N`  
  Specify the comma-separated list of VCF INFO fields (without spaces) to use when creating or annotating.

- `-prefix prefix_db`  
  When annotating, prepend the given prefix to each annotated field name. This is useful when using multiple databases to avoid naming conflicts.

### Usage summary

**Create Databases**
```bash
java -jar SnpSift.jar annmem \
  -create \
  -dbfile database_1.vcf -fields field_1,field_2,...,field_N \
  -dbfile database_2.vcf -fields field_1,field_2,...,field_N \
  ... \
  -dbfile database_N.vcf -fields field_1,field_2,...,field_N
```

**Annotate VCF File**
```bash
java -jar SnpSift.jar annmem \
  [-addAnnotated] \
  -dbfile database_1.vcf -fields field_1,field_2,...,field_N [-prefix prefix_db_1] \
  -dbfile database_2.vcf -fields field_1,field_2,...,field_N [-prefix prefix_db_2] \
  ... \
  -dbfile database_N.vcf -fields field_1,field_2,...,field_N [-prefix prefix_db_N] \
  [input.vcf] > output.vcf
```

**Notes:**

- If `input.vcf` is not provided, `annotateMem` reads from standard input (STDIN).
- VCF files can be compressed with Gzip or Bgzip (if so, the file name must have a `.gz` extension)

---

## Summary

The SnpSift `annotateMem` command offers a fast and scalable solution for annotating large VCF files with data from multiple external databases. By leveraging memory-optimized dataframes and per-chromosome indexing, it delivers high annotation throughput—making it an essential tool for genomic variant analysis workflows.

# Help, New databases and Bugs

This project is maintained by [**Pablo Cingolani**](http://www.linkedin.com/in/pablocingolani)

## Asking for help

Please send any questions by creating issues in repositories:

* [SnpEff - https://github.com/pcingola/SnpEff/issues](https://github.com/pcingola/SnpEff/issues)
* [SnpSift - https://github.com/pcingola/SnpSift/issues](https://github.com/pcingola/SnpSift/issues)

!!!warning
    **Important:** In order to assess and your problem precisely, I must be able to reproduce your example.

Any request for help should include at least the following items:

Item         | Explanation | Example
------------ | ----------- | ---------
What?        | A clear explanation of what you are trying to achieve | "I want to annotate variants... and then filter them to obtain..."
How?         | A minimal demonstration of how you are trying to do it | "we run the following command...".<br> Make sure you send the exact command lines you are using.
Which?       | Which organism and genome version you are using | "we are analyzing human samples using GRCh37.72 reference genome"
Version      | Which SnpEFf version and sub-version you are using?<br> Make sure to try the **latest version** since the issue might be already solved. | "we are using SnpEFf 3.3H").<br> Hint: Running `java -jar snpEff.jar` shows version information.
Command line | The full command line that shows the issue. | `java -Xmx8g -jar snpEff.jar GRCh37.75 sample.vcf ...`
Data         | Sample data enough to reproduce the conditions<br>**Always attach the data files** such as VCF lines (even if you added some snippets in the email's body)  | "find attached a sample of the VCF file..."
Results      | What you expect to obtain | "we wanted to get information on variants that affect splcie regions..."

**Note:** A few guidelines when asking for help...

* **Use the latest version.** May be the issue has already been corrected.

* **Read the documentation first.** Please make sure you've read the documentation before asking fo help.
        I know this is obvious, but a lot of people ask for questions in that are answered, or shown as examples in the documentation.

* **If the documentation did not help.** I'm aware that the documentation is not always "easy reading".
        So let me know which part of the manual is confusing, outdated or plain wrong.
        I'll do my best to update and improve the docs.

* **Be polite.** This one should be obvious, but there is a reason it's in the list...

* **I'm too busy.** I always try to help people, but oftentimes I'm busy and I won't be able to answer your emails & requests in due time and manner.
     Apologies in advanced.

* **If I don't get back to you...** Do remind me if I don't get back to you within a few days.
      Sometimes I'm swamped with work or just out of town, a polite reminder helps.

* **Ask for too much advice.** I don't mind helping, I've been doing it forever.
      However I won't be able to help you with all the details (due to limited bamdwith), so most times, the best I can do is to provide some pointers and general advise you can follow up on.

## Bug reports

Please send any bug reports by creating issues in repositories:

* SnpEff:  [https://github.com/pcingola/SnpEff/issues](https://github.com/pcingola/SnpEff/issues)
* SnpSift: [https://github.com/pcingola/SnpSift/issues](https://github.com/pcingola/SnpSift/issues)

!!!warning
    **Important:** In order to assess and fix the issue, I must be able to reproduce exactly your error condition.

This means that I need the following information:

Item         | Explanation     | Example
------------ | --------------- | ---------
What?        | A clear explanation of the bug condition.<br>Please copy the full stack trace if one is available.| "a RuntimeException occurss when trying to annotate..."
How?         | A minimal bug-demonstrating test case | "when running the following command/s...".<br> Make sure you send the exact command lines you are using.
Which?       | Which organism and genome version you are using (if applicable) | "we use GRCh37.72"
Version      | Which SnpEFf version and sub-version you are using?<br> Make sure to try the **latest version** since the bug might be already fixed. | "we are using SnpEFf 3.3H").<br> Hint: Running `java -jar snpEff.jar` shows version information.
Command line | The full command line that shows the issue. | `java -Xmx8g -jar snpEff.jar GRCh37.75 sample.vcf ...`
Data         | Sample data enough to reproduce the conditions<br>**Always attach the data files** such as VCF lines (even if you added some snippets in the email's body)  | "find attached a sample of the VCF file..."
Results      | What you expect to obtain (if applicable)| "we expected result X, but we obtained Y instead..."

**Important tips:**

* Make sure you **attached** a minimal dataset to reproduce the error condition.
    For instance, a few VCF lines showing the problem are enough (sometimes one VCF line is enough), most of the times I don't need the whole VCF file.

* Always send the data **attached**, even if it's only one VCF line. Many times the problem is a malformed line, which I can only asses if the data is attached, and

* If you have to send large files, as sometimes happens with genome references, try uploading them to a server (e.g. Google Drive) and sending me a link. Remember to always compress them.

* **Try SnpEff's latest version.**
    SnpEff is updated often, may be the bug has already been corrected (e.g you are using version 5.0A, but I've already fixed it in version 5.0B).

## Asking for new features

I always take into account features request.
So don't hesitate to send me your ideas by creating issues in repositories:

* SnpEff:  [https://github.com/pcingola/SnpEff/issues](https://github.com/pcingola/SnpEff/issues)
* SnpSift: [https://github.com/pcingola/SnpSift/issues](https://github.com/pcingola/SnpSift/issues)

Of course, it  doesn't mean I'll get all suggestions implemented as soon as I get a request.
But if a lot of people are asking for the same feature, it is a strong indicator that I should try to implement it.

Please, don't be frustrated if I tell you I cannot implement your suggestion / idea. Keep in mind that some features are too difficult to implement for non-obvious reasons, e.g.:

* SnpEff uses some standard (e.g. VCF) and new features cannot break those standards.
* SnpEff is used by a LOT of people in MANY different pipelines. New features must be compatible with current infrastructure and cannot break operational production pipelines.
* Some feature requests are just too difficult to code, requiring large changes.

## Asking for new database / genome

I'm willing to help you out if you need to build a new database (a.k.a. add a new reference genome).
Building a new database (i.e. adding a new reference genome) is relatively easy and the procedure is described in detail [in the documentation](snpeff/build_db.md).
If you are unable to build the database, I can try to help you out. Please, create issue in repository: <https://github.com/pcingola/SnpEff>.

In order to do so, I need you to send me the following information:

* Name of the species
* Reference genome version
* A link to the reference genome sequence (i.e. a link to the FASTA file)
* A link to a gene and transcript definition file (either GTF, GFF, GenBank, etc.)
* At least one of the following (preferably, both):
     * A link to the CDS sequences (FASTA file)
     * A link to the protein sequences (FASTA files)
* Codon table information (take a look a the codon tables in `snpEff.config` file):
     * Which codon table does the organism use? (e.g. `codon.Standard` or `codon.Mycoplasma`).
     * Specific codon tables used by some chromosomes (e.g. chromosome `'MT'` uses `codon.Vertebrate_Mitochondrial` table)

I'm well aware that I could try to google that information myself, but I need you to send the information because I want to be absolutely sure we are using exactly the reference genome version, sub-version, and data files you need.

## Contact information

<strong>[Pablo Cingolani](http://www.linkedin.com/in/pablocingolani)</strong>

# Integration: GATK and Galaxy

SnpEff is integrated with other tools commonly used in sequencing data analysis pipelines.
Most notably [Galaxy](http://galaxyproject.org/) and Broad Institute's Genome Analysis Toolkit ([GATK](http://www.broadinstitute.org/gatk/)) projects support SnpEff.
By using standards, such as VCF, SnpEff makes it easy to integrate with other programs.

### Integration: GATK

In order to make sure SnpEff and GATK understand each other, you must activate GATK compatibility in SnpEff by using the `-o gatk` command line option.
The reason for using '-o gatk' is that, even though both GATK and SnpEff use VCF format, SnpEff has recently updated the `EFF` sub-field format and this might cause some trouble (since GATK still uses the original version).

!!! warning
    GATK only picks one effect.
    Indeed, the GATK team decided to only report the effect having the highest impact.
    This was done intentionally for the sake of brevity, in a 'less is more' spirit.
    You can get the full effect by using snpEff independently, instead of using it within GATK framework.

Script example: In this example we combine SnpEff and GATK's VariantAnnotator (you can find this script in `snpEff/scripts/` directory of the distribution)
```
#!/bin/sh

#-------------------------------------------------------------------------------
# Files
#-------------------------------------------------------------------------------

in=$1                                                   # Input VCF file
eff=`dirname $in`/`basename $in .vcf`.ann.vcf        # SnpEff annotated VCF file
out=`dirname $in`/`basename $in .vcf`.gatk.vcf          # Output VCF file (annotated by GATK)

ref=$HOME/snpEff/data/genomes/hg19.fa                   # Reference genome file
dict=`dirname $ref`/`basename $ref .fa`.dict            # Reference genome: Dictionary file

#-------------------------------------------------------------------------------
# Path to programs and libraries
#-------------------------------------------------------------------------------

gatk=$HOME/tools/gatk/GenomeAnalysisTK.jar
picard=$HOME/tools/picard/
snpeff=$HOME/snpEff/snpEff.jar

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

# Create genome index file
echo
echo "Indexing Genome reference FASTA file: $ref"
samtools faidx $ref

# Create dictionary
echo
echo "Creating Genome reference dictionary file: $dict"
java -jar $picard/CreateSequenceDictionary.jar R= $ref O= $dict

# Annotate
echo
echo "Annotate using SnpEff"
echo "    Input file  : $in"
echo "    Output file : $eff"
java -Xmx8g -jar $snpeff -c $HOME/snpEff/snpEff.config -v -o gatk hg19 $in > $eff

# Use GATK
echo
echo "Annotating using GATK's VariantAnnotator:"
echo "    Input file  : $in"
echo "    Output file : $out"
java -Xmx8g -jar $gatk \
    -T VariantAnnotator \
    -R $ref \
    -A SnpEff \
    --variant $in \
    --snpEffFile $eff \
    -L $in \
    -o $out
```

!!! warning
    **Important:** In order for this to work, GATK requires that the Genome Reference file should have the chromosomes in karotyping order
    (largest to smallest chromosomes, followed by the X, Y, and MT). Your VCF file should also respect that order.

Now we can use the script:
```
$ ~/snpEff/scripts/gatk.sh zzz.vcf

Indexing Genome reference FASTA file: /home/pcingola/snpEff/data/genomes/hg19.fa

Creating Genome reference dictionary file: /home/pcingola/snpEff/data/genomes/hg19.dict
[Fri Apr 12 11:23:12 EDT 2013] net.sf.picard.sam.CreateSequenceDictionary REFERENCE=/home/pcingola/snpEff/data/genomes/hg19.fa OUTPUT=/home/pcingola/snpEff/data/genomes/hg19.dict    TRUNCATE_NAMES_AT_WHITESPACE=true NUM_SEQUENCES=2147483647 VERBOSITY=INFO QUIET=false VALIDATION_STRINGENCY=STRICT COMPRESSION_LEVEL=5 MAX_RECORDS_IN_RAM=500000 CREATE_INDEX=false CREATE_MD5_FILE=false
[Fri Apr 12 11:23:12 EDT 2013] Executing as pcingola@localhost.localdomain on Linux 3.6.11-4.fc16.x86_64 amd64; OpenJDK 64-Bit Server VM 1.6.0_24-b24; Picard version: 1.89(1408)
[Fri Apr 12 11:23:12 EDT 2013] net.sf.picard.sam.CreateSequenceDictionary done. Elapsed time: 0.00 minutes.
Runtime.totalMemory()=141164544
To get help, see http://picard.sourceforge.net/index.shtml#GettingHelp
Exception in thread "main" net.sf.picard.PicardException: /home/pcingola/snpEff/data/genomes/hg19.dict already exists.  Delete this file and try again, or specify a different output file.
        at net.sf.picard.sam.CreateSequenceDictionary.doWork(CreateSequenceDictionary.java:114)
        at net.sf.picard.cmdline.CommandLineProgram.instanceMain(CommandLineProgram.java:177)
        at net.sf.picard.sam.CreateSequenceDictionary.main(CreateSequenceDictionary.java:93)

Annotate using SnpEff
    Input file  : zzz.vcf
    Output file : ./zzz.ann.vcf
00:00:00.000	Reading configuration file '/home/pcingola/snpEff/snpEff.config'
00:00:00.173	done
00:00:00.173	Reading database for genome version 'hg19' from file '/home/pcingola//snpEff/data/hg19/snpEffectPredictor.bin' (this might take a while)
00:00:11.860	done
00:00:11.885	Building interval forest
00:00:17.755	done.
00:00:18.391	Genome stats :
# Genome name                : 'Homo_sapiens (USCS)'
# Genome version             : 'hg19'
# Has protein coding info    : true
# Genes                      : 25933
# Protein coding genes       : 20652
# Transcripts                : 44253
# Avg. transcripts per gene  : 1.71
# Protein coding transcripts : 36332
# Cds                        : 365442
# Exons                      : 429543
# Exons with sequence        : 409789
# Exons without sequence     : 19754
# Avg. exons per transcript  : 9.71
# Number of chromosomes      : 50
# Chromosomes names [sizes]  : '1' [249250621]	'2' [243199373]	'3' [198022430]	'4' [191154276]	'5' [180915260]	'6' [171115067]	'7' [159138663]	'X' [155270560]	'8' [146364022]	'9' [141213431]	'10' [135534747]	'11' [135006516]	'12' [133851895]	'13' [115169878]	'14' [107349540]	'15' [102531392]	'16' [90354753]	'17' [81195210]	'18' [78077248]	'20' [63025520]	'Y' [59373566]	'19' [59128983]	'22' [51304566]	'21' [48129895]	'6_ssto_hap7' [4905564]	'6_mcf_hap5' [4764535]	'6_cox_hap2' [4734611]	'6_mann_hap4' [4679971]	'6_qbl_hap6' [4609904]	'6_dbb_hap3' [4572120]	'6_apd_hap1' [4383650]	'17_ctg5_hap1' [1574839]	'4_ctg9_hap1' [582546]	'Un_gl000220' [156152]	'19_gl000209_random' [145745]	'Un_gl000213' [139339]	'17_gl000205_random' [119732]	'Un_gl000223' [119730]	'4_gl000194_random' [115071]	'Un_gl000228' [114676]	'Un_gl000219' [99642]	'Un_gl000218' [97454]	'Un_gl000211' [93165]	'Un_gl000222' [89310]	'4_gl000193_random' [88375]	'7_gl000195_random' [86719]	'1_gl000192_random' [79327]	'Un_gl000212' [60768]	'1_gl000191_random' [50281]	'M' [16571]	
00:00:18.391	Predicting variants
00:00:20.267	Creating summary file: snpEff_summary.html
00:00:20.847	Creating genes file: snpEff_genes.txt
00:00:25.026	done.
00:00:25.036	Logging
00:00:26.037	Checking for updates...

Annotating using GATK's VariantAnnotator:
    Input file  : zzz.vcf
    Output file : ./zzz.gatk.vcf
INFO  11:23:41,316 ArgumentTypeDescriptor - Dynamically determined type of zzz.vcf to be VCF 
INFO  11:23:41,343 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,344 HelpFormatter - The Genome Analysis Toolkit (GATK) v2.4-9-g532efad, Compiled 2013/03/19 07:35:36 
INFO  11:23:41,344 HelpFormatter - Copyright (c) 2010 The Broad Institute 
INFO  11:23:41,344 HelpFormatter - For support and documentation go to http://www.broadinstitute.org/gatk 
INFO  11:23:41,347 HelpFormatter - Program Args: -T VariantAnnotator -R /home/pcingola/snpEff/data/genomes/hg19.fa -A SnpEff --variant zzz.vcf --snpEffFile ./zzz.ann.vcf -L zzz.vcf -o ./zzz.gatk.vcf 
INFO  11:23:41,347 HelpFormatter - Date/Time: 2013/04/12 11:23:41 
INFO  11:23:41,348 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,348 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,353 ArgumentTypeDescriptor - Dynamically determined type of zzz.vcf to be VCF 
INFO  11:23:41,356 ArgumentTypeDescriptor - Dynamically determined type of ./zzz.ann.vcf to be VCF 
INFO  11:23:41,399 GenomeAnalysisEngine - Strictness is SILENT 
INFO  11:23:41,466 GenomeAnalysisEngine - Downsampling Settings: Method: BY_SAMPLE, Target Coverage: 1000 
INFO  11:23:41,480 RMDTrackBuilder - Loading Tribble index from disk for file zzz.vcf 
INFO  11:23:41,503 RMDTrackBuilder - Loading Tribble index from disk for file ./zzz.ann.vcf 
WARN  11:23:41,505 RMDTrackBuilder - Index file /data/pcingola/Documents/projects/snpEff/gatk_test/./zzz.ann.vcf.idx is out of date (index older than input file), deleting and updating the index file 
INFO  11:23:41,506 RMDTrackBuilder - Creating Tribble index in memory for file ./zzz.ann.vcf 
INFO  11:23:41,914 RMDTrackBuilder - Writing Tribble index to disk for file /data/pcingola/Documents/projects/snpEff/gatk_test/./zzz.ann.vcf.idx 
INFO  11:23:42,076 IntervalUtils - Processing 33411 bp from intervals 
INFO  11:23:42,125 GenomeAnalysisEngine - Creating shard strategy for 0 BAM files 
INFO  11:23:42,134 GenomeAnalysisEngine - Done creating shard strategy 
INFO  11:23:42,134 ProgressMeter - [INITIALIZATION COMPLETE; STARTING PROCESSING] 
INFO  11:23:42,135 ProgressMeter -        Location processed.sites  runtime per.1M.sites completed total.runtime remaining 
INFO  11:23:49,268 VariantAnnotator - Processed 9966 loci.

INFO  11:23:49,280 ProgressMeter -            done        3.34e+04    7.0 s        3.6 m    100.0%         7.0 s     0.0 s 
INFO  11:23:49,280 ProgressMeter - Total runtime 7.15 secs, 0.12 min, 0.00 hours 
INFO  11:23:49,953 GATKRunReport - Uploaded run statistics report to AWS S3 
```

### Integration: Galaxy

In order to install SnpEff in your own Galaxy server, you can use the `galaxy/*.xml` files provided in the main distribution.

This is a screen capture from a Galaxy server (click to enlarge):

[![](../images/snpEff_galaxy_small.png)](../images/snpEff_galaxy.png){: .center}

Installing SnpEff in a Galaxy server:
```
# Set variable to snpEff install dir (we only use it for this install script)
export snpEffDir="$HOME/snpEff"

# Go to your galaxy 'tools' dir
cd galaxy-dist/tools

# Create a directory and copy the XML config files from SnpEff's distribution
mkdir snpEff
cd snpEff/
cp $snpEffDir/galaxy/* .

# Create links to JAR files
ln -s $snpEffDir/snpEff.jar
ln -s $snpEffDir/SnpSift.jar

# Link to config file
ln -s $snpEffDir/snpEff.config

# Allow scripts execution
chmod a+x *.{pl,sh}

# Copy genomes information
cd ../..
cp $snpEffDir/galaxy/tool-data/snpEff_genomes.loc tool-data/

# Edit Galaxy's tool_conf.xml and add all the tools
vi tool_conf.xml

-------------------- Begin: Edit tool_conf.xml --------------------
<!-- 
    Add this section to tool_conf.xml file in your galaxy distribution

    Note: The following lines should be added at the end of the 
          file, right before "</toolbox>" line
-->
<section name="snpEff tools" id="snpEff_tools">
    <tool file="snpEff/snpEff.xml" />
    <tool file="snpEff/snpEff_download.xml" />
    <tool file="snpEff/snpSift_annotate.xml" />
    <tool file="snpEff/snpSift_caseControl.xml" />
    <tool file="snpEff/snpSift_filter.xml" />
    <tool file="snpEff/snpSift_int.xml" />
</section>
-------------------- End: Edit tool_conf.xml --------------------

# Run galaxy and check that the new menus appear
./run.sh
```

# SnpSift RmInfo

This command removes INFO fields from a VCF file (i.e. removes annotations)

Removing INFO fields is usually done because you want to re-annotate the VCF file, thus removing old INFO fields in order to add new ones later.

SnpEff SnpSift only add annotations and do not change current ones.
So, in order to re-annotate a file, you should first remove the old annotations and then re-annotate.

The reason for this behavior is simply because replacing annotation values is considered a bad practice.
Imagine that you have a VCF entry  in your re-annotated file having the value "AA=1": How do you know if this is from the old annotations or from the new ones?
This confusion often leads to problems in downstream steps of your pipelines, so it's better to avoid the problem by first removing all the previous annotations and then adding the new ones.

Usage example:
```
$ cat test.snpeff.vcf
#CHROM	POS 	ID	    REF	ALT	QUAL	FILTER	INFO
1	    734462	1032	G	A	.	    s50	    AC=348;EFF=DOWNSTREAM(MODIFIER|||||RP11-206L10.8|processed_transcript|NON_CODING|ENST00000447500||1),INTRON(MODIFIER|||||RP11-206L10.6|processed_transcript|NON_CODING|ENST00000429505|1|1)

$ java -jar SnpSift.jar rmInfo test.snpeff.vcf EFF
#CHROM	POS	    ID	    REF	ALT	QUAL	FILTER	INFO
1	    734462	1032	G	A	.	    s50	    AC=348
```

# SnpSift GWAS Catalog

Annotate using [GWAS catalog](http://www.genome.gov/gwastudies/).

You need the GWAS catalog file (in TXT format), which can be downloaded [here](https://www.ebi.ac.uk/gwas/api/search/downloads/alternative).
```
$ java -jar SnpSift.jar gwasCat gwascatalog.txt test.vcf | tee test.gwas.vcf
1   1005806 rs3934834   C   T   .   PASS    AF=0.091;GWASCAT=Body_mass_index    
1   2069172 rs425277    C   T   .   PASS    AF=0.400;GWASCAT=Height
1   2069681 rs3753242   C   T   .   PASS    AF=0.211;GWASCAT=Reasoning  
1   2392648 rs2477686   G   C   .   PASS    AF=0.745;GWASCAT=Non_obstructive_azoospermia    
1   2513216 rs734999    C   T   .   PASS    AF=0.547;GWASCAT=Ulcerative_colitis
1   2526746 rs3748816   A   G   .   PASS    AF=0.489;GWASCAT=Celiac_disease
1   3083712 rs2651899   T   C   .   PASS    AF=0.467;GWASCAT=Migraine   
1   3280253 rs6658356   G   A   .   PASS    AF=0.070;GWASCAT=Response_to_statin_therapy
1   4315204 rs966321    G   T   .   PASS    AF=0.522;GWASCAT=Factor_VII
1   5170712 rs7513590   A   G   .   PASS    AF=0.256;GWASCAT=Anthropometric_traits  
1   6279370 rs846111    G   C   .   PASS    AF=0.153;GWASCAT=QT_interval,QT_interval    
1   6631431 rs11587438  C   T   .   PASS    AF=0.906;GWASCAT=White_blood_cell_types
1   7879063 rs2797685   C   T   .   PASS    AF=0.186;GWASCAT=Crohn_s_disease    
1   8021973 rs35675666  G   T   .   PASS    AF=0.093;GWASCAT=Ulcerative_colitis
1   8046672 rs12727642  C   A   .   PASS    AF=0.101;GWASCAT=Celiac_disease
1   8422676 rs2252865   T   C   .   PASS    AF=0.771;GWASCAT=Schizophrenia  
1   8526142 rs4908760   G   A   .   PASS    AF=0.630;GWASCAT=Vitiligo   
```

SnpEff is integrated with other tools commonly used in sequencing data analysis pipelines.

Most notably [Galaxy](http://galaxyproject.org/) and Broad Institute's Genome Analysis Toolkit ([GATK](http://www.broadinstitute.org/gatk/) projects support SnpEff.
By using standards, such as VCF, SnpEff makes it easy to integrate with other programs.

More details about integration [here](se_integration.md#integration-gatk-and-galaxy).

This is a screen capture from a Galaxy server (click to enlarge):
[![](images/snpEff_galaxy_small.png)](images/snpEff_galaxy.png){: .center}

# Building databases: Regulatory and Non-coding

SnpEff supports regulatory and non-coding annotations.
In this section we show how to build those databases.
As in the previous section, most likely you will never have to do it yourself and can just use available pre-built databases.

There are two ways to add support for regulatory annotations (these are not mutually exclusive, you can use both at the same time):

1. GFF regulation file (from ENSEMBL).
2. BED files.

!!! warning
    Adding regulation support and analyzing data using regulation tracks can take much more memory. For instance, for the human genome I use 10Gb to 20Gb of RAM.

!!! warning
    It is assumed the the genome is already installed, only regulatory tracks are added.

### Option 1: Using a GFF file

This example shows how to create a regulation database for human (GRCh37.65):

1. Get the GFF regulatory annotations (into path/to/snpEff/data/GRCh37.65/regulation.gff):

        cd path/to/snpEff/data/GRCh37.65
        wget ftp:/ftp.ensembl.org/pub/release-65/regulation/homo_sapiens/AnnotatedFeatures.gff.gz
        mv AnnotatedFeatures.gff.gz regulation.gff.gz 

2. Create databases. Note that we use `-onlyReg` flag, because we are only creating regulatory databases. If you omit it, it will create both of "normal' and regulatory databases:

        cd /path/to/snpEff
        java -Xmx20G -jar snpEff.jar build -v -onlyReg GRCh37.65 

    The output looks like this:

        Reading regulation elements (GFF)
            Chromosome '11'	line: 226964
            Chromosome '12'	line: 493780
            ...
            Chromosome '9'	line: 4832434
            Chromosome 'X'  line: 5054301
            Chromosome 'Y'  line: 5166958
        Done
            Total lines                 : 5176289
            Total annotation count      : 3961432
            Percent                     : 76.5%
            Total annotated length      : 3648200193
            Number of cell/annotations  : 266
        Saving database 'HeLa-S3' in file '/path/to/snpEff/data/GRCh37.65/regulation_HeLa-S3.bin'
        Saving database 'HepG2' in file '/path/to/snpEff/data/GRCh37.65/regulation_HepG2.bin'
        Saving database 'NHEK' in file '/path/to/snpEff/data/GRCh37.65/regulation_NHEK.bin'
        Saving database 'GM12878' in file '/path/to/snpEff/data/GRCh37.65/regulation_GM12878.bin'
        Saving database 'HUVEC' in file '/path/to/snpEff/data/GRCh37.65/regulation_HUVEC.bin'
        Saving database 'H1ESC' in file '/path/to/snpEff/data/GRCh37.65/regulation_H1ESC.bin'
        Saving database 'CD4' in file '/path/to/snpEff/data/GRCh37.65/regulation_CD4.bin'
        Saving database 'GM06990' in file '/path/to/snpEff/data/GRCh37.65/regulation_GM06990.bin'
        Saving database 'IMR90' in file '/path/to/snpEff/data/GRCh37.65/regulation_IMR90.bin'
        Saving database 'K562' in file '/path/to/snpEff/data/GRCh37.65/regulation_K562.bin'
        Done.

    As you can see, annotations for each cell type are saved in different files. This makes it easier to load annotations only for the desired cell types when analyzing data.

### Option 2: Using an BED file

This example shows how to create a regulation database for human (GRCh37.65).
We assume we have a file called `my_regulation.bed` which has information for H3K9me3 in Pancreatic Islets (for instance, as a result of a Chip-Seq experiment and peak enrichment analysis).

1. Add all your BED files to `path/to/snpEff/data/GRCh37.65/regulation.bed/` dir:

        cd path/to/snpEff/data/GRCh37.65
        mkdir regulation.bed
        cd regulation.bed
        mv where/ever/your/bed/file/is/my_regulation.bed ./regulation.Pancreatic_Islets.H3K9me3.bed
    **Note:** The name of the file must be `regulation.CELL_TYPE.ANNOTATION_TYPE.bed`. In this case, `CELL_TYPE=Pancreatic_Islets` and `ANNOTATION_TYPE=H3K9me3`

2. Create databases (note the `-onlyReg` flag):

        cd /path/to/snpEff
        java -Xmx20G -jar snpEff.jar build -v -onlyReg GRCh37.65 
    The output looks like this:

        Building database for 'GRCh37.65'
        Reading regulation elements (GFF)
        Cannot read regulation elements form file '/path/to/snpEff/data/GRCh37.65/regulation.gff'
        Directory has 1 bed files and 1 cell types
        Creating consensus for cellType 'Pancreatic_Islets', files: [/path/to/snpEff/data/GRCh37.65/regulation.bed/regulation.Pancreatic_Islets.H3K9me3.bed]
        Reading file '/path/to/snpEff/data/GRCh37.65/regulation.bed/regulation.Pancreatic_Islets.H3K9me3.bed'
            Chromosome '10'	line: 5143
            Chromosome '11'	line: 8521
            ...
            Chromosome 'X'	line: 52481
            Chromosome 'Y'	line: 53340
        Done
            Total lines                 : 53551
            Total annotation count      : 53573
            Percent                     : 100.0%
            Total annotated length      : 75489402
            Number of cell/annotations  : 1
        Creating consensus for cell type: Pancreatic_Islets
        Sorting: Pancreatic_Islets	, size: 53573
        Adding to final consensus
        Final consensus for cell type: Pancreatic_Islets	, size: 53549
        Saving database 'Pancreatic_Islets' in file '/path/to/snpEff/data/GRCh37.65/regulation_Pancreatic_Islets.bin'
        Done
        Finishing up

    **Note:** If there are many annotations, they are saved in one binary file for each cell type (i.e. several BED files for different cell types are collapsed together).
    This makes it easier to load annotations only for the desired cell types when analyzing data.

# SnpSift Private

Annotate if a variant is private to a family.

A `Private=Family_ID` is added to a variant's INFO field, if the variant is only found in one family.
A TFAM file (see PLINK's documentation) specifies a mapping from sample IDs to family IDs.

E.g.:

    $ java -jar SnpSift.jar private pheotypes.tfam imp.ann.vcf > imp.ann.private.vcf

An annotated variant may look like this:

    1   1005806 rs3934834   C   T   .   PASS    AF=0.091;..;Private=Family_47
This indicates that the variant is only found in members of `Family_47`, according to the definitions in `pheotypes.tfam`.

# SnpSift Intervals

This is used to extract variants that intersect any interval.

You must provide intervals as BED files.

Command line options:

* '-x' : Filter out (exclude) VCF entries that match any interval in the BED files.
* '-i file.vcf' : Specify the input VCF file (default is STDIN).

E.g.:

    cat variants.vcf | java -jar SnpSift.jar intervals my_intervals.bed > variants_intersecting_intervals.vcf

!!! warning
    BED file format is tab separated zero-based coordinates "chr \t start \t end " (for this application, all other fields in the BED file are ignored).

!!! warning
    If BED file has header lines, they must start with a '#'

# SnpSift dbNSFP

The [dbNSFP](https://sites.google.com/site/jpopgen/dbNSFP) is an integrated database of functional predictions from multiple algorithms (SIFT, Polyphen2, LRT and MutationTaster, PhyloP and GERP++, etc.).

### Typical usage

One of the main advantages is that you can annotate using multiple prediction tools with just one command.
This allows for faster annotations.
[Here](https://sites.google.com/site/jpopgen/dbNSFP) is the link to dbNSFP database website for more details.

**Database:** In order to annotate using dbNSFP, you need to download the dbNSFP database and the index file.
dbNSFP is large (several GB) so it might take a while to download it.
The database is compressed (block-gzip) and tabix-indexed, so two files are required (the data *.gz file and the *.gz.tbi index file).

### Doenloading

You can download the files from SnpEff's site.

WARNING: Remember that you need both the database and the index files

DbNSFP Version 4.5:
* GRCh37 / hg19:
    * [Database](https://snpeff.blob.core.windows.net/databases/db/GRCh37/dbNSFP/dbNSFP4.5c.txt.gz). Save file as `dbNSFP.txt.gz`
    * [Index](https://snpeff.blob.core.windows.net/databases/db/GRCh37/dbNSFP/dbNSFP4.5c.txt.gz.tbi). Save file as `dbNSFP.txt.gz.tbi`
* GRCh38 / hg38:
    * [Database](https://snpeff.blob.core.windows.net/databases/db/GRCh38/dbNSFP/dbNSFP4.5c.txt.gz). Save file as `dbNSFP.txt.gz`
    * [Index](https://snpeff.blob.core.windows.net/databases/db/GRCh38/dbNSFP/dbNSFP4.5c.txt.gz.tbi). Save file as `dbNSFP.txt.gz.tbi`

DbNSFP Version 4.1
* GRCh37 / hg19 (dbNSFP Academic):
    * [Database](https://snpeff.blob.core.windows.net/databases/dbs/GRCh37/dbNSFP_4.1a/dbNSFP4.1a.txt.gz). Save file as `dbNSFP.txt.gz`
    * [Index](https://snpeff.blob.core.windows.net/databases/dbs/GRCh37/dbNSFP_4.1a/dbNSFP4.1a.txt.gz.tbi). Save file as `dbNSFP.txt.gz.tbi`
* GRCh38 / hg38 (dbNSFP Academic):
    * [Database](https://snpeff.blob.core.windows.net/databases/dbs/GRCh38/dbNSFP_4.1a/dbNSFP4.1a.txt.gz). Save file as `dbNSFP.txt.gz`
    * [Index](https://snpeff.blob.core.windows.net/databases/dbs/GRCh38/dbNSFP_4.1a/dbNSFP4.1a.txt.gz.tbi). Save file as `dbNSFP.txt.gz.tbi`

### dbNSFP Annotation example

Here is a full example how to perform annotations:

```
# Annotate using dbNSFP
# Note that the first time you run the command, it will attempt to download the dbNSFP database.
java -jar SnpSift.jar dbnsfp -v myFile.vcf > myFile.annotated.vcf
```

!!! info
    You can now specify which fields you want to use for annotation using the `-f` command line option followed by a comma separated list of field names.
    Defaults fields are shown when running the command without any arguments `java -jar SnpSift.jar dbNSFP`

If your dbNSFP file is not in the 'default' path (where SnpEff expects it), you can specify the path to your dbNSFP file using the `-db` command line option:

```
# Annotate using dbNSFP
java -jar SnpSift.jar dbnsfp -v -db path/to/my/dbNSFP2.9.txt.gz myFile.vcf > myFile.annotated.vcf
```

### Building dbNSFP (for developers)

!!! info
    Users do **NOT** need to do this, since a pre-indexed database can be downloaded from SnpSift's site (see previous sub-section).
    These instructions are mostly for developers.

You can also create dbNSFP files yourself, downloading the files from [DbNsfp](https://sites.google.com/site/jpopgen/dbNSFP) site.
Two files are required:

* A block-gzipped database file
* The corresponding tabix index for the database file.

Creating a file that SnpSift can use is simple, just follow this guideline:
```
# Download dbNSFP database
$ wget http://dbnsfp.houstonbioinformatics.org/dbNSFPzip/dbNSFP2.9.zip

# Uncompress
$ unzip dbNSFP2.9.zip

# Create a single file version
$ (head -n 1 dbNSFP2.9_variant.chr1 ; cat dbNSFP2.9_variant.chr* | grep -v "^#" ) > dbNSFP2.9.txt

# Compress using block-gzip algorithm
bgzip dbNSFP2.9.txt

# Create tabix index
tabix -s 1 -b 2 -e 2 dbNSFP2.9.txt.gz
```

**Building dbNSFP for hg19/GRCh37 using dbNSFP 3.X:**

Latest dbNSFP versions (3.X) are based on GRCh38/hg38 genomic coordinates.
In order to use the latest dbNSFP databses with GRCh37/hg19 genome versions you need to create a new dbNSFP file with the right coordinates.
Fortunately, dbNSFP 3.X provides GRCh37/hg19 coordinates, so we only need to swap coordinates and sort by genomic position.
You can easily do this by using the `dbNSFP_sort.pl` script ([you can find it here](https://raw.githubusercontent.com/pcingola/SnpEff/master/scripts_build/dbNSFP_sort.pl)) by running something like the following command lines:
```
# Set to your downloaded dbNSFP version
version="3.2a"

# Replace coordinates by columns 7 and 8 (hg19 coordinates) and sort by those coordinates
cat dbNSFP${version}_variant.chr* \
    | $HOME/snpEff/scripts_build/dbNSFP_sort.pl 7 8 \
    > dbNSFP${version}_hg19.txt

# Compress and index
bgzip dbNSFP${version}_hg19.txt
tabix -s 1 -b 2 -e 2 dbNSFP${version}_hg19.txt.gz
```

# SnpSift phastCons

Annotate using PhastCons conservation scores.

!!! info
    You must download PhastCons files [here](http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/).

!!! info
    You also need a chromosome size file, which can be created using `samtools faidx`, or you can download it from [here](../adds/genome.fai).

Full example.
Most of the example deals with downloading and installing PhastCons database, which is done only once.
The real annotation process is done in the last line.
```
# Create a dir for PhastCons database
cd ~/snpEff
mkdir -p db/phastCons/

# Download all PhastCons files
cd db/phastCons/
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr1.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr2.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr3.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr4.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr5.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr6.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr7.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr8.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr9.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr10.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr11.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr12.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr13.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr14.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr15.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr16.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr17.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr18.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr19.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr20.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr21.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr22.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrM.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrX.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrY.phastCons100way.wigFix.gz

# Create a chromosome size file and name it "genome.fai"
samtools faidx path/to/genome/hg19.fa.gz
cp path/to/genome/hg19.fa.gz.fai ./genome.fai

# Now we are ready to annotate
java -Xmx8g -jar SnpSift.jar phastCons ~/snpEff/db/phastCons file.vcf > file.phastCons.vcf
```

You can annotate intervals using BED files and `-bed` command line option.
In the output BED formatted intervals, the score column (fifth column), is the average conservation score of all bases within the interval.

It is possible to extract sub-intervals having at least 'minScore' conservation score and 'len' length by using `-minScore score` and `-extract len` command line options.
For instance, the following command:

    java -jar SnpSift.jar phastCons -minScore 0.8 -extract 10 -bed path/to/phastCons/dir input.bed
extracts all subintervals from each line in `input.bed`, that has at least `10` bases length and a conservation score of `0.8`

# SnpSift: Frequently Asked Questions

# Corrupted database VCF files: ClinVar

Some VCF files used as annotation databases can be non-compliant.

Most notably, some ClinVar versions have illegal VCF values, which will make downstream analysis tools, such as `SnpSift` to report the errors.

For example, if you look into the file:

```
$ curl -s ftp://ftp.ncbi.nlm.nih.gov/pub/clinvar/vcf_GRCh37/clinvar.vcf.gz | gunzip -c | grep "&base" | head -n 1

13	32890543	125955	G	A	.	.	ALLELEID=131493;CLNDISDB=MedGen:C2675520,OMIM:612555;CLNDN=Breast-ovarian_cancer,_familial_2;CLNHGVS=NC_000013.10:g.32890543G>A;CLNREVSTAT=no_assertion_criteria_provided;CLNSIG=Uncertain_significance;CLNVC=single_nucleotide_variant;CLNVCSO=SO:0001483;CLNVI=Breast_Cancer_Information_Core__(BRCA2):190-16&base_change=G_to_A;GENEINFO=BRCA2:675;MC=SO:0001627|intron_variant;ORIGIN=1;RS=276174799
```

As you can see, the "CLNVI" is:

```
CLNVI=Breast_Cancer_Information_Core__(BRCA2):190-16&base_change=G_to_A
```

This means that the CLNVI contains an illegal `'='` character.
The VCF specification clearly states that the equal sign is not allowed:

```
  Reference: https://samtools.github.io/hts-specs/VCFv4.3.pdf
  Section 1.2: "Character encoding, non-printable characters and characters with special meaning"

    Characters with special meaning (such as field delimiters ’;’ in INFO or ’:’ FORMAT fields) must be represented
    using the capitalized percent encoding:
      %3A : (colon)
      %3B ; (semicolon)
      %3D = (equal sign)
      ...
```

Furthermore, section 1.6.1.8 specifies:

```
  INFO - additional information: (String, no semi-colons or equals-signs permitted; commas are permitted only
  as delimiters for lists of values; characters with special meaning can be encoded using the percent encoding, see
  Section 1.2; space characters are allowed) 
```

#### Finding all ClinVar problems

An easy way to find many of the problems in the VCF file is to use the `SnpSift checkVcf` command:

```
$ java -jar SnpSift.jar vcfCheck clinvar.vcf.gz 2>&1 | head
...WARNING: Malformed VCF entryfile '/home/pcingola/Downloads/clinvar.vcf.gz', line 3655:
	Entry  : 1	25717365	17708	C	C	.	.	ALLELEID=32747;CLNDISDB=.;CLNDN=RH_E/e_POLYMORPHISM;CLNHGVS=NC_000001.10:g.25717365C=;CLNREVSTAT=no_assertion_criteria_provided;CLNSIG=Benign;CLNVC=single_nucleotide_variant;CLNVCSO=SO:0001483;CLNVI=OMIM_Allelic_Variant:111700.0001;GENEINFO=RHCE:6006;MC=SO:0001627|intron_variant,SO:0001819|synonymous_variant;ORIGIN=1;RS=609320
	Errors :
		INFO filed 'CLNHGVS' has an invalid value 'NC_000001.10:g.25717365C=' (no spaces, tabs, '=' or ';' are allowed)

WARNING: Malformed VCF entryfile '/home/pcingola/Downloads/clinvar.vcf.gz', line 3657:
	Entry  : 1	25735202	242743	G	G	.	.	ALLELEID=38411;CLNHGVS=NC_000001.10:g.25735202G=;CLNREVSTAT=no_interpretation_for_the_single_variant;CLNVC=single_nucleotide_variant;CLNVCSO=SO:0001483;CLNVI=OMIM_Allelic_Variant:111700.0002;GENEINFO=RHCE:6006;MC=SO:0001819|synonymous_variant;ORIGIN=1;RS=676785;SSR=1;CLNDISDBINCL=.;CLNDNINCL=RH_C/c_POLYMORPHISM;CLNSIGINCL=17709:Benign
	Errors :
		INFO filed 'CLNHGVS' has an invalid value 'NC_000001.10:g.25735202G=' (no spaces, tabs, '=' or ';' are allowed)
```

OK, it looks like there are quite a few problems, let's count them:

```
$ java -jar SnpSift.jar vcfCheck ~/Downloads/clinvar.vcf.gz 2>&1 | grep WARN | wc -l
1793
```

Well, there seems to be 1793 lines VCF with some sort of problem.
Let's see how to fix them.

### Fixing ClinVar's VCF database

So, you need to fix ClinVar by either: 

1. Remove the offending fields from the VCF file
1. Fix the character coding for the offending values

#### Option 1: Remove the offending fields

This is the easiest way to fix ClinVar's VCF file.
First, let's find the corrupted fields:
```
$ java -jar SnpSift.jar vcfCheck clinvar.vcf.gz 2>&1 | grep "INFO field" | cut -f 2 -d "'" | sort | uniq -c
    212 CLNHGVS
   1583 CLNVI
```
OK, there are 212 lines with corrupted `CLNHGVS` fields and 1583 lines with corrupted `CLNVI` fields.
Let's create a new database without those fields

```
$ java -jar SnpSift.jar rmInfo clinvar.vcf.gz CLNHGVS CLNVI > clinvar.fixed_1.vcf
00:00:00	Reading STDIN
00:00:03	Done

# Let's also compress and index the new file so we can use it as a database
$ bgzip clinvar.fixed_1.vcf 
$ tabix clinvar.fixed_1.vcf.gz 
```

Now we can re-check the new file to make sure it's OK.
```
$ java -jar SnpSift.jar vcfCheck clinvar.fixed_1.vcf.gz 
....................................................................................................
100000	....................................................................................................
200000	..................................................................................................
```
Everything seems OK.

#### Option 2: Fix the encoding

Here we need to fix the encoding of the fields.
We know (see previous section) that the problematic fields are `CLNVI` and `CLNHGVS`, so what exactly are the problems?

```
$ java -jar SnpSift.jar vcfCheck clinvar.vcf.gz 2>&1 | grep "INFO field" | grep CLNVI | head
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):190-16&base_change=G_to_A' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):190-12&base_change=del_TCT' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):190-5&base_change=del_T' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):190-7&base_change=T_to_C' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):195&base_change=T_to_C' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):203&base_change=G_to_A' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):203&base_change=G_to_C' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):203&base_change=G_to_T' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):214&base_change=A_to_C' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNVI' has an invalid value 'Breast_Cancer_Information_Core__(BRCA2):215&base_change=T_to_C' (no spaces, tabs, '=' or ';' are allowed)
```
OK, this one seems easy: All we need to do is change `&base_change=` to `&base_change%3D`
This can be done with a simple `sed` command:

```
$ zcat clinvar.vcf.gz | sed 's/\&base_change=/\&base_change%3D/g'
```

How about the other field?
```
$ java -jar SnpSift.jar vcfCheck clinvar.vcf.gz 2>&1 | grep "INFO field" | grep CLNHGVS | head
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.25717365C=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.25735202G=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.25735306T=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.25735331G=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.94578548T=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.98348885G=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.100672060T=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.114377568A=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.161599571T=' (no spaces, tabs, '=' or ';' are allowed)
		INFO field 'CLNHGVS' has an invalid value 'NC_000001.10:g.161599643T=' (no spaces, tabs, '=' or ';' are allowed)
```

This is essentially the same, but we need four `sed` commands (one for each base):
```
$ zcat clinvar.vcf.gz \
    | sed 's/A=;/A%3D;/' \
    | sed 's/C=;/C%3D;/' \
    | sed 's/G=;/G%3D;/' \
    | sed 's/T=;/T%3D;/'
```

**The fix:**

Now, let's put the two previously explained fixes together:
```
$ zcat clinvar.vcf.gz \
    | sed 's/\&base_change=/\&base_change%3D/g' \
    | sed 's/A=;/A%3D;/' \
    | sed 's/C=;/C%3D;/' \
    | sed 's/G=;/G%3D;/' \
    | sed 's/T=;/T%3D;/' \
    > clinvar.fixed.vcf

# Let's also compress and index the new file so we can use it as a database
$ bgzip clinvar.fixed.vcf 
$ tabix clinvar.fixed.vcf.gz 
```

We re-check the new
```
$ java -jar SnpSift.jar vcfCheck clinvar.fixed.vcf.gz 
....................................................................................................
100000	....................................................................................................
200000	..................................................................................................
```
OK, we are done.

# SnpSift Extract Fields

Extract fields from a VCF file to a TXT, tab separated format, that you can easily load in R, XLS, etc.

### Typical usage

You can also use sub-fields and genotype fields / sub-fields such as:

* Standard VCF fields:
    * `CHROM`
    * `POS`
    * `ID`
    * `REF`
    * `ALT`
    * `FILTER`
* INFO fields:
    * `AF`
    * `AC`
    * `DP`
    * `MQ`
    * etc. (any info field available)
* SnpEff 'ANN' fields:
    * `ANN[*].ALLELE` (alias GENOTYPE)
    * `ANN[*].EFFECT` (alias ANNOTATION): Effect in Sequence ontology terms (e.g. 'missense_variant', 'synonymous_variant', 'stop_gained', etc.)
    * `ANN[*].IMPACT:` { HIGH, MODERATE, LOW, MODIFIER }
    * `ANN[*].GENE:` Gene name (e.g. 'PSD3')
    * `ANN[*].GENEID:` Gene ID
    * `ANN[*].FEATURE`
    * `ANN[*].FEATUREID` (alias TRID: Transcript ID)
    * `ANN[*].BIOTYPE:` Biotype, as described by the annotations (e.g. 'protein_coding')
    * `ANN[*].RANK:` Exon or Intron rank (i.e. exon number in a transcript)
    * `ANN[*].HGVS_C` (alias HGVS_DNA, CODON): Variant in HGVS (DNA) notation
    * `ANN[*].HGVS_P` (alias HGVS, HGVS_PROT, AA): Variant in HGVS (protein) notation
    * `ANN[*].CDNA_POS` (alias POS_CDNA)
    * `ANN[*].CDNA_LEN` (alias LEN_CDNA)
    * `ANN[*].CDS_POS` (alias POS_CDS)
    * `ANN[*].CDS_LEN` (alias LEN_CDS)
    * `ANN[*].AA_POS` (alias POS_AA)
    * `ANN[*].AA_LEN` (alias LEN_AA)
    * `ANN[*].DISTANCE`
    * `ANN[*].ERRORS` (alias WARNING, INFOS)
* SnpEff 'EFF' fields (this is for older SnpEff/SnpSift versions, new version use 'ANN' field):
    * `EFF[*].EFFECT`
    * `EFF[*].IMPACT`
    * `EFF[*].FUNCLASS`
    * `EFF[*].CODON`
    * `EFF[*].AA`
    * `EFF[*].AA_LEN`
    * `EFF[*].GENE`
    * `EFF[*].BIOTYPE`
    * `EFF[*].CODING`
    * `EFF[*].TRID`
    * `EFF[*].RANK`

    !!! info
        You can combine `vcfEffOnePerLine.pl` script with `SnpSift extractFields` if you want to have each effect in a separate line.

* SnpEff 'LOF' fields:
    * `LOF[*].GENE`
    * `LOF[*].GENEID`
    * `LOF[*].NUMTR`
    * `LOF[*].PERC`
* SnpEff' NMD' fields:
    * `NMD[*].GENE`
    * `NMD[*].GENEID`
    * `NMD[*].NUMTR`
    * `NMD[*].PERC`

!!! warning
    When using multiple indexes you must remember to use quotes and escape the character in the command line (e.g. `"ANN[*].EFFECT"`).
    Otherwise, the shell would parse the asterisk changing the expression and producing unexpected results.

!!! info
    You can use command line option `-s` to specify multiple field separator and `-e` to specify how to represent empty fields.


### Example 1: Extracting chromosome, position, ID and allele frequency

```
$ java -jar SnpSift.jar extractFields s.vcf CHROM POS ID AF | head
#CHROM        POS        ID            AF
1             69134                    0.086
1             69496      rs150690004   0.001
1             69511      rs75062661    0.983
1             69569                    0.538
1             721559                   0.001
1             721757                   0.011
1             846854     rs111957712   0.003
1             865584     rs148711625   0.001
1             865625     rs146327803   0.001
```

### Example 2: Extracting genotype fields

    $ java -jar SnpSift.jar extractFields file.vcf "CHROM" "POS" "ID" "THETA" "GEN[0].GL[1]" "GEN[1].GL" "GEN[3].GL[*]" "GEN[*].GT"

This means to extract:

* `CHROM` `POS` `ID`: regular fields (as in the previous example)
* `THETA` : This one is from INFO
* `GEN[0].GL[1]` : Second likelihood from first genotype
* `GEN[1].GL` : The whole GL fields (all entries without separating them)
* `GEN[3].GL[*]` : All likelihoods form genotype 3 (this time they will be tab separated, as opposed to the previous one).
* `GEN[*].GT` : Genotype subfields (GT) from ALL samples (tab separated).

The result will look something like:
```
#CHROM  POS     ID              THETA   GEN[0].GL[1]    GEN[1].GL               GEN[3].GL[*]            GEN[*].GT
1       10583   rs58108140      0.0046  -0.47           -0.24,-0.44,-1.16       -0.48   -0.48   -0.48   0|0     0|0     0|0     0|1     0|0     0|1     0|0     0|0     0|1
1       10611   rs189107123     0.0077  -0.48           -0.24,-0.44,-1.16       -0.48   -0.48   -0.48   0|0     0|1     0|0     0|0     0|0     0|0     0|0     0|0     0|0
1       13302   rs180734498     0.0048  -0.58           -2.45,-0.00,-5.00       -0.48   -0.48   -0.48   0|0     0|1     0|0     0|0     0|0     1|0     0|0     0|1     0|0
1       13327   rs144762171     0.0204  -1.11           -1.97,-0.01,-2.51       -0.48   -0.48   -0.48   0|0     0|1     0|0     0|0     0|0     1|0     0|0     0|0     0|0
1       13957   rs201747181     0.0100  0               0,0,0                   0       0       0       0|0     0|1     0|0     0|0     0|0     0|0     0|0     0|0     0|0
1       13980   rs151276478     0.0139  -0.48           -0.48,-0.48,-0.48       -0.48   -0.48   -0.48   0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0
1       30923   rs140337953     0.0162  -0.61           -0.10,-0.69,-2.81       -0.48   -0.48   -0.48   1|1     0|0     0|0     1|1     1|0     0|0     1|1     1|0     1|1
1       46402   rs199681827     0.0121  0               0,0,0                   0       0       0       0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0
1       47190   rs200430748     0.0153  0               0,0,0                   0       0       0       0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0     0|0
```

### Example 3: Extracting fields with multiple values in a friendlier format

You can use command line option `-s` to specify multiple field separator and `-e` to specify how to represent empty fields.

    $ java -jar SnpSift.jar extractFields -s "," -e "." test.chr22.ann.vcf CHROM POS REF ALT "EFF[*].EFFECT" "EFF[*].AA"

Notice how we separate same fields using "," instead of the default tab using the option `-s ","`, and we use "." for empty fields (option `-e "."`).

The results is:
```
$ java -jar SnpSift.jar extractFields -s "," -e "." examples/test.chr22.ann.vcf CHROM POS REF ALT "ANN[*].EFFECT" "ANN[*].HGVS_P"
#CHROM	POS	REF	ALT	ANN[*].EFFECT	ANN[*].HGVS_P
22	17071756	T	C	3_prime_UTR_variant,downstream_gene_variant	.,.
22	17072035	C	T	missense_variant,downstream_gene_variant	p.Gly469Glu,.
22	17072258	C	A	missense_variant,downstream_gene_variant	p.Gly395Cys,.
22	17072674	G	A	missense_variant,downstream_gene_variant	p.Pro256Leu,.
22	17072747	T	C	missense_variant,downstream_gene_variant	p.Met232Val,.
22	17072781	C	T	synonymous_variant,downstream_gene_variant	p.Pro220Pro,.
22	17073043	C	T	missense_variant,downstream_gene_variant	p.Arg133Gln,.
22	17073066	A	G	synonymous_variant,downstream_gene_variant	p.Ala125Ala,.
22	17073119	C	T	missense_variant,downstream_gene_variant	p.Val108Met,.
```

### Example 4: Extracting effects, one per line

In order to extract effects, you can simply do something like this (notice that there are multiple columns per line because there are multiple effects per variant):
```
$ java -jar SnpSift.jar extractFields examples/test.chr22.ann.vcf CHROM POS REF ALT "ANN[*].EFFECT"
#CHROM	POS	REF	ALT	ANN[*].EFFECT
22	17071756	T	C	3_prime_UTR_variant	downstream_gene_variant
22	17072035	C	T	missense_variant	downstream_gene_variant
22	17072258	C	A	missense_variant	downstream_gene_variant
22	17072674	G	A	missense_variant	downstream_gene_variant
22	17072747	T	C	missense_variant	downstream_gene_variant
22	17072781	C	T	synonymous_variant	downstream_gene_variant
22	17073043	C	T	missense_variant	downstream_gene_variant
22	17073066	A	G	synonymous_variant	downstream_gene_variant
22	17073119	C	T	missense_variant	downstream_gene_variant
```
Note that since some variant have more than one effect, there can be more than one "EFFECT" column.

If we prefer to have one effect per line, then we can use the `vcfEffOnePerLine.pl` provided with SnpEff distribution
```
$ cat examples/test.chr22.ann.vcf \
    | ./scripts/vcfEffOnePerLine.pl \
    | java -jar SnpSift.jar extractFields - CHROM POS REF ALT "ANN[*].EFFECT" \

#CHROM	POS	REF	ALT	ANN[*].EFFECT
22	17071756	T	C	3_prime_UTR_variant
22	17071756	T	C	downstream_gene_variant
22	17072035	C	T	missense_variant
22	17072035	C	T	downstream_gene_variant
22	17072258	C	A	missense_variant
22	17072258	C	A	downstream_gene_variant
22	17072674	G	A	missense_variant
22	17072674	G	A	downstream_gene_variant
22	17072747	T	C	missense_variant
```
Now we obtain one effect per line, while all other parameters in the line are repeated across mutiple lines (e.g. there are two chr22:17071756 lines, one for each variant annotation).

!!! info
    Note that in SnpSift, we used `-` as input file name, which denotes STDIN.

### Example 5: Extracting genotype using genotype name instead of genotype number

As of SnpSift version 4.1A, you can use the genotype name in expressions:

```
$ java -jar SnpSift.jar extractFields examples/1kg.head_chr1.vcf.gz CHROM POS REF ALT "GEN[HG00096].DS" "GEN[HG00097].DS"
#CHROM    POS      REF  ALT    GEN[HG00096].DS    GEN[HG00097].DS
1         10583    G    A      0.2                 0.15
1         10611    C    G      0.05                0.75
1         13302    C    T      0.05                1.0
1         13327    G    C      0.0                 0.95
1         13957    TC   T      0.05                0.65
1         13980    T    C      0.05                0.6
1         30923    G    T      1.75                0.35
1         46402    C    CTGT   0.05                0.15
1         47190    G    GA     0.15                0.0
```

### Example 6: Extracting non alphanumeric field names

!!! warning
    `SnpSift extractFields` can get confused if the VCF field has non-alphanumeric charaters in the name (e.g. `dbNSFP_GERP++_RS` has two "+" signs).
    A quick fix, it so is to change the field names in the VCF file.

Here is an example:
```
# Change field names in VCF
$ cat kath.vcf | sed "s/dbNSFP_GERP++/dbNSFP_GERP/g" > kath.gerp.vcf

# Use new names to extract fields
$ java -jar SnpSift.jar  extractFields kath.gerp.vcf CHROM POS REF ALT dbNSFP_GERP_RS dbNSFP_GERP_NS
#CHROM	POS	REF	ALT	dbNSFP_GERP_RS
1	142827044	G	A		
2	132914561	G	A		
7	151933217	C	A		
7	151933251	T	C		
7	151933302	T	C		
7	151945101	G	C	-0.892
7	151945167	G	T		
7	151962176	T	A		
7	151970672	A	T		
7	151970856	T	A	3.71
18	14183638	G	C		
18	14183710	A	G		
18	14542909	G	A		
18	14543039	T	C	-0.942
```

# Running SnpEff

We show some basic examples how to use SnpEff.

### Basic example: Installing SnpEff

Obviously the first step to use the program is to install it (for details, take a look at the [download page](download.md).
You have to download the core program and then uncompress the ZIP file.
In Windows systems, you can just double click and copy the contents of the ZIP file to wherever you want the program installed.
If you have a Unix or a Mac system, the command line would be:

```
# Download using wget
$ wget https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip

# If you prefer to use 'curl' instead of 'wget', you can type:
#     curl -L https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip > snpEff_latest_core.zip

# Install
$ unzip snpEff_latest_core.zip
```

### Basic example: Annotate using SnpEff

Let's assume you have a VCF file and you want to annotate the variants in that file.
An example file is provided in `examples/test.chr22.vcf` (this data is from the 1000 Genomes project, so the reference genome is the human genome GRCh37).

You can annotate the file by running the following command (as an input, we use a Variant Call Format (VCF) file available in SnpEff's `examples` directory).

```
$ java -Xmx8g -jar snpEff.jar GRCh37.75 examples/test.chr22.vcf > test.chr22.ann.vcf

# Here is how the output looks like
$ head examples/test.chr22.ann.vcf
##SnpEffVersion="4.1 (build 2015-01-07), by Pablo Cingolani"
##SnpEffCmd="SnpEff  GRCh37.75 examples/test.chr22.vcf "
##INFO=<ID=ANN,Number=.,Type=String,Description="Functional annotations: 'Allele | Annotation | Annotation_Impact | Gene_Name | Gene_ID | Feature_Type | Feature_ID | Transcript_BioType | Rank | HGVS.c | HGVS.p | cDNA.pos / cDNA.length | CDS.pos / CDS.length | AA.pos / AA.length | Distance | ERRORS / WARNINGS / INFO' ">
##INFO=<ID=LOF,Number=.,Type=String,Description="Predicted loss of function effects for this variant. Format: 'Gene_Name | Gene_ID | Number_of_transcripts_in_gene | Percent_of_transcripts_affected' ">
##INFO=<ID=NMD,Number=.,Type=String,Description="Predicted nonsense mediated decay effects for this variant. Format: 'Gene_Name | Gene_ID | Number_of_transcripts_in_gene | Percent_of_transcripts_affected' ">
#CHROM	POS	ID	REF	ALT	QUAL	FILTER	INFO
22	17071756	.	T	C	.	.	ANN=C|3_prime_UTR_variant|MODIFIER|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.*11A>G|||||11|,C|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397A>G|||||4223|
22	17072035	.	C	T	.	.   ANN=T|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.1406G>A|p.Gly469Glu|1666/2034|1406/1674|469/557||,T|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>A|||||3944|
22	17072258	.	C	A	.	.	ANN=A|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.1183G>T|p.Gly395Cys|1443/2034|1183/1674|395/557||,A|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>T|||||3721|
22	17072674	.	G	A	.	.	ANN=A|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.767C>T|p.Pro256Leu|1027/2034|767/1674|256/557||,A|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397C>T|||||3305|
```

As you can see, SnpEff added functional annotations in the `ANN` info field (eigth column in the VCF output file).

Details about the 'ANN' field format can be found in the [ANN Field](se_inputoutput.md#ann-field-vcf-output-files) section and in [VCF annotation about standard 'ANN' field](adds/VCFannotationformat_v1.0.pdf).
Note: Older SnpEff version used 'EFF' field (details about the 'EFF' field format can be found in the [EFF Field](se_inputoutput.md#eff-field-vcf-output-files) section).

You can also annotate using the "verbose" mode (command line option `-v`), this makes SnpEff to show a lot of information which can be useful for debugging.

Here output is edited for brevity:

```
$ java -Xmx8g -jar snpEff.jar -v GRCh37.75 examples/test.chr22.vcf > test.chr22.ann.vcf
00:00:00.000	Reading configuration file 'snpEff.config'. Genome: 'GRCh37.75'
00:00:00.434	done
00:00:00.434	Reading database for genome version 'GRCh37.75' from file '/home/pcingola/snpEff_v4_0/./data/GRCh37.75/snpEffectPredictor.bin' (this might take a while)
00:00:00.434	Database not installed
    Attempting to download and install database 'GRCh37.75'
00:00:00.435	Reading configuration file 'snpEff.config'. Genome: 'GRCh37.75'
00:00:00.653	done
00:00:00.654	Downloading database for 'GRCh37.75'
00:00:00.655	Connecting to http://downloads.sourceforge.net/project/snpeff/databases/v4_0/snpEff_v4_0_GRCh37.75.zip
00:00:01.721	Local file name: 'snpEff_v4_0_GRCh37.75.zip'
.............................................
00:01:31.595	Download finished. Total 177705174 bytes.
00:01:31.597	Extracting file 'data/GRCh37.75/motif.bin' to '/home/pcingola/snpEff_v4_0/./data/GRCh37.75/motif.bin'
00:01:31.597	Creating local directory: '/home/pcingola/snpEff_v4_0/./data/GRCh37.75'
00:01:31.652	Extracting file 'data/GRCh37.75/nextProt.bin'
00:01:31.707	Extracting file 'data/GRCh37.75/pwms.bin'
00:01:31.707	Extracting file 'data/GRCh37.75/regulation_CD4.bin'
...
00:01:32.038	Extracting file 'data/GRCh37.75/snpEffectPredictor.bin'
00:01:32.881	Unzip: OK
00:01:32.881	Done
00:01:32.881	Database installed.
00:01:58.779	done
00:01:58.813	Reading NextProt database from file '/home/pcingola/snpEff_v4_0/./data/GRCh37.75/nextProt.bin'
00:02:01.448	NextProt database: 523361 markers loaded.
00:02:01.448	Adding transcript info to NextProt markers.
00:02:02.180	NextProt database: 706289 markers added.
00:02:02.181	Loading Motifs and PWMs
00:02:02.181		Loading PWMs from : /home/pcingola/snpEff_v4_0/./data/GRCh37.75/pwms.bin
00:02:02.203		Loading Motifs from file '/home/pcingola/snpEff_v4_0/./data/GRCh37.75/motif.bin'
00:02:02.973		Motif database: 284122 markers loaded.
00:02:02.973	Building interval forest
00:02:41.857	done.
00:02:41.858	Genome stats :
#-----------------------------------------------
# Genome name                : 'Homo_sapiens'
# Genome version             : 'GRCh37.75'
# Has protein coding info    : true
# Genes                      : 63677
# Protein coding genes       : 23172
#-----------------------------------------------
# Transcripts                : 215170
# Avg. transcripts per gene  : 3.38
#-----------------------------------------------
# Checked transcripts        :
#               AA sequences : 104254 ( 114.79% )
#              DNA sequences : 179360 ( 83.36% )
#-----------------------------------------------
# Protein coding transcripts : 90818
#              Length errors :  14349 ( 15.80% )
#  STOP codons in CDS errors :     39 ( 0.04% )
#         START codon errors :   8721 ( 9.60% )
#        STOP codon warnings :  21788 ( 23.99% )
#              UTR sequences :  87724 ( 40.77% )
#               Total Errors :  21336 ( 23.49% )
#-----------------------------------------------
# Cds                        : 792087
# Exons                      : 1306656
# Exons with sequence        : 1306656
# Exons without sequence     : 0
# Avg. exons per transcript  : 6.07
# WARNING!                   : Mitochondrion chromosome 'MT' does not have a mitochondrion codon table (codon table = 'Standard'). You should update the config file.
#-----------------------------------------------
# Number of chromosomes      : 297
# Chromosomes names [sizes]  :
#		'HG1292_PATCH' [250051446]
#		'HG1287_PATCH' [249964560]
#		'HG1473_PATCH' [249272860]
#		'HG1471_PATCH' [249269426]
#		'HSCHR1_1_CTG31' [249267852]
#		'HSCHR1_2_CTG31' [249266025]
#		'HSCHR1_3_CTG31' [249262108]
#		'HG999_2_PATCH' [249259300]
#		'HG989_PATCH' [249257867]
#		'HG999_1_PATCH' [249257505]
#		'HG1472_PATCH' [249251918]
#		'1' [249250621]
#		'HG1293_PATCH' [249140837]
#		'HG686_PATCH' [243297375]
#		'HSCHR2_1_CTG12' [243216362]
#		'HSCHR2_2_CTG12' [243205453]
#		'HSCHR2_1_CTG1' [243205406]
#		'HG953_PATCH' [243199374]
#		'2' [243199373]
.....
.....
#-----------------------------------------------

00:02:59.416	Predicting variants

WARNINGS: Some warning were detected
Warning type	Number of warnings
WARNING_TRANSCRIPT_INCOMPLETE	8215
WARNING_TRANSCRIPT_NO_START_CODON	3483


00:03:04.327	Creating summary file: snpEff_summary.html
00:03:04.891	Creating genes file: snpEff_genes.txt
00:03:17.334	done.
00:03:17.336	Logging
00:03:18.337	Checking for updates...
```

Notice how SnpEff automatically downloads and installs the database.
Next time SnpEff will use the local version, so the installation step is only done once.

The annotated variants will be in the new file "test.chr22.ann.vcf".

!!! warning
    SnpEff creates a file called "snpEff_summary.html" showing basic statistics about the analyzed variants.
    Take a quick look at it.

!!! info
    We used the java parameter -Xmx8g to increase the memory available to the Java Virtual Machine to 4G.
    SnpEff's human genome database is large and it has to be loaded into memory.
    If your computer doesn't have at least 4G of memory, you probably won't be able to run this example.

!!! info
    If you are running SnpEff from a directory different than the one it was installed, you will have to specify where the config file is.
    This is done using the '-c' command line option:

        java -Xmx8g -jar snpEff.jar -c path/to/snpEff/snpEff.config -v GRCh37.75 test.chr22.vcf > test.chr22.ann.vcf

### Detailed examples

Take a look at several detailed examples in our [examples page](examples.md).

### Specify a configuration file

Sometimes you need to specify the path to the config file.
For instance, when you run SnpEff from a different directory than your install directory, you have to
specify where the config file is located using the '-c' command line option.

    java -Xmx8g path/to/snpEff/snpEff.jar -c path/to/snpEff/snpEff.config GRCh37.75 path/to/snps.vcf

!!! info
    Since version 4.1B, you can use the `-configOption` command line option to override any value in the config file

### Java memory options

By default the amount of memory set by a java process is set too low.
If you don't assign more memory to the process, you will most likely have an "OutOfMemory" error.

You should set the amount of memory in your java virtual machine to, at least, 2 Gb.
This can be easily done using the Java command line option `-Xmx`.
E.g. In this example I use 4Gb:

    # Run using 4 Gb of memory
    java -Xmx8g snpEff.jar hg19 path/to/your/files/snps.vcf

Note: There is no space between `-Xmx` and `4G`.

### Running SnpEff in the Cloud

You can run SnpEff in a "the Cloud" exactly the same way as running it on your local computer.
You should not have any problems at all.

Here is an example of installing it and running it on an Amazon EC2 instance (virtual machine):

```
$ ssh -i ./aws_amazon/pcingola_aws.pem ec2-user@ec2-54-234-14-244.compute-1.amazonaws.com

       __|  __|_  )
       _|  (     /   Amazon Linux AMI
      ___|\___|___|


[ec2-user@ip-10-2-202-163 ~]$ wget https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip
[ec2-user@ip-10-2-202-163 ~]$ unzip snpEff_latest_core.zip
[ec2-user@ip-10-2-202-163 ~]$ cd snpEff/
[ec2-user@ip-10-2-202-163 snpEff]$ java -jar snpEff.jar download -v hg19
00:00:00.000    Downloading database for 'hg19'
...
00:00:36.340    Done
[ec2-user@ip-10-2-202-163 snpEff]$ java -Xmx8g -jar snpEff.jar dump -v hg19 > /dev/null
00:00:00.000    Reading database for genome 'hg19' (this might take a while)
00:00:20.688    done
00:00:20.688    Building interval forest
00:00:33.110    Done.
```
As you can see, it's very simple.

### Loading the database

One of the first thins SnpEff has to do is to load the database.
Usually it takes from a few seconds to a couple of minutes, depending on database size.
Complex databases, like human, require more time to load.
After the database is loaded, SnpEff can analyze thousands of variants per second.

### Command line vs Web interface

In order to run SnpEff you need to be comfortable running command from a command line terminal.
If you are not, then it is probably a good idea to ask you systems administrator to install a [Galaxy](http://usegalaxy.org) server and use the web interface.
You can also use the open Galaxy server, but functionality may be limited and SnpEff versions may not be updated frequently.

# Output summary files

SnpEff creates an additional output file showing overall statistics.
This "stats" file is an HTML file which can be opened using a web browser.
It can also be created as a CSV file, for easier parsing or manipulation.
You can find an example of a 'stats' file [here](../adds/1kg.html).

## Summary file options

By default, SnpEff performs some statistics and saves them to the `snpEff_summary.html` on the same directory where snpEff is being executed.
You can see the file, by opening it in your browser. SnpEff also creates a "Genes Statistics" file (`snpEff_genes.txt`) with gene-level statistics in tabular (tab-separated) format.

There are some command line options related to the statistics:

- `-stats <file>`: You can change the default name and location of the HTML file. This also changes the name and location of the "genes" (TXT) file.
- `-noStats`: Do not calculate statisticsm, or create stats (summary) files
- `-csvStats <file>`: Create the statistics file in CSV format with the specified name.

!!! info
    The "Genes statistics" file path is by default the directory where SnpEff is executed and called `snpEff_genes.txt`. If you change the summary file name / path by either using `-stats` or `csvStats` command line, the "Genes statistics" file path will be the same directory as the summary file and the file name is the same "base name" plus a `".genes.txt"`.


## Summary report

The summary report consist of several sections:

- [Main summary table](#main-summary-table)
- Variant rate by chromosome: A table of number of variants and variants rate per chromosome
- [Variants by type](#variants-by-type)
- Number of variants by impact: A count and percentage of variants by [impact](./inputoutput.md#impact-prediction)
- Number of variants by functional class: A count and percentage of variants by [functional class](./inputoutput.md#functional-class)
- [Number of variants by annotation](#annotations--region)
- Quality histogram: Variant Quality histogram, i.e. a histogram of the VCF's  `QUAL` field
- InDel length histogram: Length of `INS` and `DEL` variants
- Base variant table: Table of SNV variants changes
- Transition vs transversions (ts/tv): Transition vs transversions table, split into "known" and all variants (known variants are the ones with non-empty `ID` field).
- Allele frequency: Allele frequency histogram
- Allele Count: Allele count histogram
- Codon change table: A table of all codon changes counts
- Amino acid change table: A table of all amino acid changes counts
- Chromosome variants plots: Plots of number of variants for each chromosome location
- Details by gene: Link to "Genes Statistics" file

## Main summary table

The main summary table contains basic information about the SnpEff run and some overall statistics:

| Table Entry                         | Note  |
| ------------------------------------| ----- | 
| Genome                              | Genome name and version, as specified in the command line | 
| Date                                | Date and time when the analysis was performed |
| SnpEff version                      | SnpEff version |
| Command line arguments              | Command line arguments and options used to annotate |
| Warnings                            | Number of [WARNING](./inputoutput.md#errors-and-warnings) annotation messages (i.e. `WARNING` messages in the ANN field) |
| Errors                              | Number of [ERROR](./inputoutput.md#errors-and-warnings) annotation messages (i.e. `ERROR` messages in the ANN field) |
| Number of lines (input file)        | Number of lines in the input file, excluding comment / header lines |
| Number of variants (before filter)  | Number of variants in the input file. Note that this can differ from the number of lines; e.g. VCF allows for [multiple variants per line](./faq.md#counting-variants-vs-lines-in-a-vcf-file) and [IUPAC expansion](./faq#iupac-expansion). |
| Number of not variants              | Number of non-variants, e.g. if the `REF` and `ALT` fields are the same |
| Number of variants processed        | Number of variants processed. This can be different than the number of variants due to filtering and non-variants entries. |
| Number of known variants            | Variants that have a non-empty `ID` field. |
| Number of multi-allelic VCF entries | Variants that have mode then two alleles. Most variants have only two alleles: `REF` and one `ALT`. Multi-allelic variants have multiple `ALT` entries. |
| Number of annotations               | Total number of variant annotations. Note that this is typically [higher than the number of variant](./faq.md#counting-variants-vs-annotations) |
| Genome total length                 | Total genome length (in bases) |
| Genome effective length             | Total length of the chromosomes (in bases). This only counts chromosomes that had varinats |
| Variant rate                        | Number of variants per genomic length: `Number of variants` / `Genome effeective length`|


!!! warning
    The number of input lines, number of variants, and number of annotation are different counts and typically are not equal, [see details in this FAQ](./faq.md#number-of-variants-in-vcf-and-html-summary-do-not-match)

### Variants by type

This table contains a list of the number of variants, grouped by variant type:

| Type       | Note |
| ---------- | ---- |
| `SNP`      | SNP / SNV is a single nucleotide variant, e.g. 'A -> G' |
| `MNP`      | MNP / MNV is a multiple nucleotide variant, e.g. 'AC -> GT' |
| `INS`      | Insertion, e.g. 'A -> AT' |
| `DEL`      | Deletion, e.g. 'AT -> A' |
| `MIXED`    | A mixed vairant is a combination of SNP / MNP / INS / DEL, for example ' |
| `INV`      | An inversion of reference sequence |
| `DUP`      | A duplication is a region of elevated copy number relative to the reference |
| `BND`      | An arbitrary rearrangement |
| `INTERVAL` | An interval marke, e.g. an interval from a BED file |


### Histograms

E.g.: In the stats file, you can see coverage histogram plots like this one:

![](../images/coverage_hitogram.png)

### Annotations & Region

SnpEff annotates variants using ["functional annotaions"](./inputoutput.md#variant-annotaiton-details), e.g. `NON_SYNONYMOUS_CODING`, `STOP_GAINED`, etc..
These variants affect regions of the genome (e.g. `EXON`, `INTRON`).
The two tables count how many effects for each type and for each region exists.

E.g.: In an `EXON` region, you can have all the following effect types: `NON_SYNONYMOUS_CODING`, `SYNONYMOUS_CODING`, `FRAME_SHIFT`, `STOP_GAINED`, etc.

The complicated part is that some annotaitons affect a region that has the same name (yes, I know, this is confusing).

E.g.: In a `UTR_5_PRIME` region you can have `UTR_5_PRIME` and `START_GAINED` effect type.

This means that the number of both tables are not exactly the same, because the labels don't mean the same.
See the next figure as an example:

![type_vs_region](../images/type_vs_region.png){: .center}

So the number of effects that affect a UTR_5_PRIME *region* is 206. Of those, 57 are effects *type* `START_GAINED` and 149 are effects *type* `UTR_5_PRIME`.

How exactly are effect *type* and effect *region* related? See the following table:

Effect Type                                    | Region
---------------------------------------------- | ------
`NONE`, `CHROMOSOME`, `CUSTOM`, `CDS`          | `NONE`
`INTERGENIC`, `INTERGENIC_CONSERVED`           | `INTERGENIC`
`UPSTREAM`                                     | `UPSTREAM`
`UTR_5_PRIME`, `UTR_5_DELETED`, `START_GAINED` | `UTR_5_PRIME`
`SPLICE_SITE_ACCEPTOR`                         | `SPLICE_SITE_ACCEPTOR`
`SPLICE_SITE_DONOR`                            | `SPLICE_SITE_DONOR`
`SPLICE_SITE_REGION`                           | `SPLICE_SITE_REGION`
`INTRAGENIC`, `START_LOST`, `SYNONYMOUS_START`, `NON_SYNONYMOUS_START`, `GENE`, `TRANSCRIPT` | `EXON` or `NONE`
`EXON`, `EXON_DELETED`, `NON_SYNONYMOUS_CODING`, `SYNONYMOUS_CODING`, `FRAME_SHIFT`, `CODON_CHANGE`, `CODON_INSERTION`, `CODON_CHANGE_PLUS_CODON_INSERTION`, `CODON_DELETION`, `CODON_CHANGE_PLUS_CODON_DELETION`, `STOP_GAINED`, `SYNONYMOUS_STOP`, ` STOP_LOST`, `RARE_AMINO_ACID` | `EXON`
`INTRON`, `INTRON_CONSERVED`                   | `INTRON`
`UTR_3_PRIME`, `UTR_3_DELETED`                 | `UTR_3_PRIME`
`DOWNSTREAM`                                   | `DOWNSTREAM`
`REGULATION`                                   | `REGULATION`

### Gene statistics

SnpEff also generates a TXT (tab separated) file having counts of number of variants affecting each transcript and gene.
By default, the file name is `snpEff_genes.txt`, but it can be changed using the `-stats` command line option.

Here is an example of this file:
```
$ head snpEff_genes.txt
# The following table is formatted as tab separated values.
#GeneName	GeneId	TranscriptId	BioType	variants_impact_HIGH	variants_impact_LOW	variants_impact_MODERATE	variants_impact_MODIFIER	variants_effect_3_prime_UTR_variant	variants_effect_5_prime_UTR_premature_start_codon_gain_variant	variants_effect_5_prime_UTR_variant	variants_effect_downstream_gene_variant	variants_effect_intron_variant	variants_effect_missense_variant	variants_effect_non_coding_exon_variant	variants_effect_splice_acceptor_variant	variants_effect_splice_donor_variant	variants_effect_splice_region_variant	variants_effect_start_lost	variants_effect_stop_gained	variants_effect_stop_lost	variants_effect_synonymous_variant	variants_effect_upstream_gene_variant	bases_affected_DOWNSTREAM	total_score_DOWNSTREAM	length_DOWNSTREAM	bases_affected_EXON	total_score_EXON	length_EXON	bases_affected_INTRON	total_score_INTRON	length_INTRON	bases_affected_SPLICE_SITE_ACCEPTOR	total_score_SPLICE_SITE_ACCEPTOR	length_SPLICE_SITE_ACCEPTOR	bases_affected_SPLICE_SITE_DONOR	total_score_SPLICE_SITE_DONOR	length_SPLICE_SITE_DONOR	bases_affected_SPLICE_SITE_REGION	total_score_SPLICE_SITE_REGION	length_SPLICE_SITE_REGION	bases_affected_TRANSCRIPT	total_score_TRANSCRIPT	length_TRANSCRIPT	bases_affected_UPSTREAM	total_score_UPSTREAM	length_UPSTREAM	bases_affected_UTR_3_PRIME	total_score_UTR_3_PRIME	length_UTR_3_PRIME	bases_affected_UTR_5_PRIME	total_score_UTR_5_PRIME	length_UTR_5_PRIME
AC000029.1	ENSG00000221069	ENST00000408142	miRNA	0	0	0	2	0	0	0	2	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
AC000068.5	ENSG00000185065	ENST00000431090	antisense	0	0	0	1	0	0	0	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0
AC000081.2	ENSG00000230194	ENST00000433141	processed_pseudogene	0	0	0	8	0	0	0	3	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	5	0	5000	0	0
AC000089.3	ENSG00000235776	ENST00000424559	processed_pseudogene	0	0	0	1	0	0	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0
AC002472.1	ENSG00000269103	ENST00000547793	protein_coding	0	0	0	6	0	0	0	5	0	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	1	0	5000	0	0
AC002472.11	ENSG00000226872	ENST00000450652	antisense	0	0	0	13	0	0	0	5	2	0	0	0	0	0	0	5000	0	0	0	2	0	11199	0	0	0	0	0	0	0	0	0	0	0	0	6	0	5000	0	0
AC002472.13	ENSG00000187905	ENST00000342608	protein_coding	0	1	6	1	0	0	0	0	1	6	0	0	0	1	0	116	1	0	934	0	0	0	0	0	0	1	0	3	0	0	0	0	0	0	0	0	0	0	0
AC002472.13	ENSG00000187905	ENST00000442047	protein_coding	0	1	6	1	0	0	0	0	1	6	0	0	0	1	0	116	1	0	934	0	0	0	0	0	0	1	0	3	0	0	0	0	0	0	0	0	0	0	0
```

The columns in this table are:

Column name        | Meaning
------------------ | ---------------
GeneName           | Gene name (usually HUGO)
GeneId             | Gene's ID
TranscriptId       | Transcript's ID
BioType            | Transcript's bio-type (if available)
&nbsp;             | **The following column is repeated for each impact {HIGH, MODERATE, LOW, MODIFIER}**
variants_impact_*  | Count number of variants for each impact category
&nbsp;             | **The following column is repeated for each annotated effect (e.g. missense_variant, synonymous_variant, stop_lost, etc.)**
variants_effect_*  | Count number of variants for each effect type
&nbsp;             | **The following columns are repeated for several genomic regions (DOWNSTREAM, EXON, INTRON, UPSTREAM, etc.)**
bases_affected_*   | Number of bases that variants overlap genomic region
total_score_*      | Sum of scores overlapping this genomic region. Note: Scores are only available when input files are type 'BED' (e.g. when annotating ChipSeq experiments)
length_*           | Genomic region length

# Integration: GATK and Galaxy

SnpEff is integrated with other tools commonly used in sequencing data analysis pipelines.
Most notably [Galaxy](http://galaxyproject.org/) and Broad Institute's Genome Analysis Toolkit ([GATK](http://www.broadinstitute.org/gatk/)) projects support SnpEff.
By using standards, such as VCF, SnpEff makes it easy to integrate with other programs.

### Integration: GATK

In order to make sure SnpEff and GATK understand each other, you must activate GATK compatibility in SnpEff by using the `-o gatk` command line option.
The reason for using '-o gatk' is that, even though both GATK and SnpEff use VCF format, SnpEff has recently updated the `EFF` sub-field format and this might cause some trouble (since GATK still uses the original version).

!!! warning
    GATK only picks one effect.
    Indeed, the GATK team decided to only report the effect having the highest impact.
    This was done intentionally for the sake of brevity, in a 'less is more' spirit.
    You can get the full effect by using snpEff independently, instead of using it within GATK framework.

Script example: In this example we combine SnpEff and GATK's VariantAnnotator (you can find this script in `snpEff/scripts/` directory of the distribution)
```
#!/bin/sh

#-------------------------------------------------------------------------------
# Files
#-------------------------------------------------------------------------------

in=$1                                                   # Input VCF file
eff=`dirname $in`/`basename $in .vcf`.ann.vcf        # SnpEff annotated VCF file
out=`dirname $in`/`basename $in .vcf`.gatk.vcf          # Output VCF file (annotated by GATK)

ref=$HOME/snpEff/data/genomes/hg19.fa                   # Reference genome file
dict=`dirname $ref`/`basename $ref .fa`.dict            # Reference genome: Dictionary file

#-------------------------------------------------------------------------------
# Path to programs and libraries
#-------------------------------------------------------------------------------

gatk=$HOME/tools/gatk/GenomeAnalysisTK.jar
picard=$HOME/tools/picard/
snpeff=$HOME/snpEff/snpEff.jar

#-------------------------------------------------------------------------------
# Main
#-------------------------------------------------------------------------------

# Create genome index file
echo
echo "Indexing Genome reference FASTA file: $ref"
samtools faidx $ref

# Create dictionary
echo
echo "Creating Genome reference dictionary file: $dict"
java -jar $picard/CreateSequenceDictionary.jar R= $ref O= $dict

# Annotate
echo
echo "Annotate using SnpEff"
echo "    Input file  : $in"
echo "    Output file : $eff"
java -Xmx8g -jar $snpeff -c $HOME/snpEff/snpEff.config -v -o gatk hg19 $in > $eff

# Use GATK
echo
echo "Annotating using GATK's VariantAnnotator:"
echo "    Input file  : $in"
echo "    Output file : $out"
java -Xmx8g -jar $gatk \
    -T VariantAnnotator \
    -R $ref \
    -A SnpEff \
    --variant $in \
    --snpEffFile $eff \
    -L $in \
    -o $out
```

!!! warning
    **Important:** In order for this to work, GATK requires that the Genome Reference file should have the chromosomes in karotyping order
    (largest to smallest chromosomes, followed by the X, Y, and MT). Your VCF file should also respect that order.

Now we can use the script:
```
$ ~/snpEff/scripts/gatk.sh zzz.vcf

Indexing Genome reference FASTA file: /home/pcingola/snpEff/data/genomes/hg19.fa

Creating Genome reference dictionary file: /home/pcingola/snpEff/data/genomes/hg19.dict
[Fri Apr 12 11:23:12 EDT 2013] net.sf.picard.sam.CreateSequenceDictionary REFERENCE=/home/pcingola/snpEff/data/genomes/hg19.fa OUTPUT=/home/pcingola/snpEff/data/genomes/hg19.dict    TRUNCATE_NAMES_AT_WHITESPACE=true NUM_SEQUENCES=2147483647 VERBOSITY=INFO QUIET=false VALIDATION_STRINGENCY=STRICT COMPRESSION_LEVEL=5 MAX_RECORDS_IN_RAM=500000 CREATE_INDEX=false CREATE_MD5_FILE=false
[Fri Apr 12 11:23:12 EDT 2013] Executing as pcingola@localhost.localdomain on Linux 3.6.11-4.fc16.x86_64 amd64; OpenJDK 64-Bit Server VM 1.6.0_24-b24; Picard version: 1.89(1408)
[Fri Apr 12 11:23:12 EDT 2013] net.sf.picard.sam.CreateSequenceDictionary done. Elapsed time: 0.00 minutes.
Runtime.totalMemory()=141164544
To get help, see http://picard.sourceforge.net/index.shtml#GettingHelp
Exception in thread "main" net.sf.picard.PicardException: /home/pcingola/snpEff/data/genomes/hg19.dict already exists.  Delete this file and try again, or specify a different output file.
        at net.sf.picard.sam.CreateSequenceDictionary.doWork(CreateSequenceDictionary.java:114)
        at net.sf.picard.cmdline.CommandLineProgram.instanceMain(CommandLineProgram.java:177)
        at net.sf.picard.sam.CreateSequenceDictionary.main(CreateSequenceDictionary.java:93)

Annotate using SnpEff
    Input file  : zzz.vcf
    Output file : ./zzz.ann.vcf
00:00:00.000	Reading configuration file '/home/pcingola/snpEff/snpEff.config'
00:00:00.173	done
00:00:00.173	Reading database for genome version 'hg19' from file '/home/pcingola//snpEff/data/hg19/snpEffectPredictor.bin' (this might take a while)
00:00:11.860	done
00:00:11.885	Building interval forest
00:00:17.755	done.
00:00:18.391	Genome stats :
# Genome name                : 'Homo_sapiens (USCS)'
# Genome version             : 'hg19'
# Has protein coding info    : true
# Genes                      : 25933
# Protein coding genes       : 20652
# Transcripts                : 44253
# Avg. transcripts per gene  : 1.71
# Protein coding transcripts : 36332
# Cds                        : 365442
# Exons                      : 429543
# Exons with sequence        : 409789
# Exons without sequence     : 19754
# Avg. exons per transcript  : 9.71
# Number of chromosomes      : 50
# Chromosomes names [sizes]  : '1' [249250621]	'2' [243199373]	'3' [198022430]	'4' [191154276]	'5' [180915260]	'6' [171115067]	'7' [159138663]	'X' [155270560]	'8' [146364022]	'9' [141213431]	'10' [135534747]	'11' [135006516]	'12' [133851895]	'13' [115169878]	'14' [107349540]	'15' [102531392]	'16' [90354753]	'17' [81195210]	'18' [78077248]	'20' [63025520]	'Y' [59373566]	'19' [59128983]	'22' [51304566]	'21' [48129895]	'6_ssto_hap7' [4905564]	'6_mcf_hap5' [4764535]	'6_cox_hap2' [4734611]	'6_mann_hap4' [4679971]	'6_qbl_hap6' [4609904]	'6_dbb_hap3' [4572120]	'6_apd_hap1' [4383650]	'17_ctg5_hap1' [1574839]	'4_ctg9_hap1' [582546]	'Un_gl000220' [156152]	'19_gl000209_random' [145745]	'Un_gl000213' [139339]	'17_gl000205_random' [119732]	'Un_gl000223' [119730]	'4_gl000194_random' [115071]	'Un_gl000228' [114676]	'Un_gl000219' [99642]	'Un_gl000218' [97454]	'Un_gl000211' [93165]	'Un_gl000222' [89310]	'4_gl000193_random' [88375]	'7_gl000195_random' [86719]	'1_gl000192_random' [79327]	'Un_gl000212' [60768]	'1_gl000191_random' [50281]	'M' [16571]	
00:00:18.391	Predicting variants
00:00:20.267	Creating summary file: snpEff_summary.html
00:00:20.847	Creating genes file: snpEff_genes.txt
00:00:25.026	done.
00:00:25.036	Logging
00:00:26.037	Checking for updates...

Annotating using GATK's VariantAnnotator:
    Input file  : zzz.vcf
    Output file : ./zzz.gatk.vcf
INFO  11:23:41,316 ArgumentTypeDescriptor - Dynamically determined type of zzz.vcf to be VCF 
INFO  11:23:41,343 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,344 HelpFormatter - The Genome Analysis Toolkit (GATK) v2.4-9-g532efad, Compiled 2013/03/19 07:35:36 
INFO  11:23:41,344 HelpFormatter - Copyright (c) 2010 The Broad Institute 
INFO  11:23:41,344 HelpFormatter - For support and documentation go to http://www.broadinstitute.org/gatk 
INFO  11:23:41,347 HelpFormatter - Program Args: -T VariantAnnotator -R /home/pcingola/snpEff/data/genomes/hg19.fa -A SnpEff --variant zzz.vcf --snpEffFile ./zzz.ann.vcf -L zzz.vcf -o ./zzz.gatk.vcf 
INFO  11:23:41,347 HelpFormatter - Date/Time: 2013/04/12 11:23:41 
INFO  11:23:41,348 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,348 HelpFormatter - -------------------------------------------------------------------------------- 
INFO  11:23:41,353 ArgumentTypeDescriptor - Dynamically determined type of zzz.vcf to be VCF 
INFO  11:23:41,356 ArgumentTypeDescriptor - Dynamically determined type of ./zzz.ann.vcf to be VCF 
INFO  11:23:41,399 GenomeAnalysisEngine - Strictness is SILENT 
INFO  11:23:41,466 GenomeAnalysisEngine - Downsampling Settings: Method: BY_SAMPLE, Target Coverage: 1000 
INFO  11:23:41,480 RMDTrackBuilder - Loading Tribble index from disk for file zzz.vcf 
INFO  11:23:41,503 RMDTrackBuilder - Loading Tribble index from disk for file ./zzz.ann.vcf 
WARN  11:23:41,505 RMDTrackBuilder - Index file /data/pcingola/Documents/projects/snpEff/gatk_test/./zzz.ann.vcf.idx is out of date (index older than input file), deleting and updating the index file 
INFO  11:23:41,506 RMDTrackBuilder - Creating Tribble index in memory for file ./zzz.ann.vcf 
INFO  11:23:41,914 RMDTrackBuilder - Writing Tribble index to disk for file /data/pcingola/Documents/projects/snpEff/gatk_test/./zzz.ann.vcf.idx 
INFO  11:23:42,076 IntervalUtils - Processing 33411 bp from intervals 
INFO  11:23:42,125 GenomeAnalysisEngine - Creating shard strategy for 0 BAM files 
INFO  11:23:42,134 GenomeAnalysisEngine - Done creating shard strategy 
INFO  11:23:42,134 ProgressMeter - [INITIALIZATION COMPLETE; STARTING PROCESSING] 
INFO  11:23:42,135 ProgressMeter -        Location processed.sites  runtime per.1M.sites completed total.runtime remaining 
INFO  11:23:49,268 VariantAnnotator - Processed 9966 loci.

INFO  11:23:49,280 ProgressMeter -            done        3.34e+04    7.0 s        3.6 m    100.0%         7.0 s     0.0 s 
INFO  11:23:49,280 ProgressMeter - Total runtime 7.15 secs, 0.12 min, 0.00 hours 
INFO  11:23:49,953 GATKRunReport - Uploaded run statistics report to AWS S3 
```

### Integration: Galaxy

In order to install SnpEff in your own Galaxy server, you can use the `galaxy/*.xml` files provided in the main distribution.

This is a screen capture from a Galaxy server (click to enlarge):

[![](images/snpEff_galaxy_small.png)](images/snpEff_galaxy.png){: .center}

Installing SnpEff in a Galaxy server:
```
# Set variable to snpEff install dir (we only use it for this install script)
export snpEffDir="$HOME/snpEff"

# Go to your galaxy 'tools' dir
cd galaxy-dist/tools

# Create a directory and copy the XML config files from SnpEff's distribution
mkdir snpEff
cd snpEff/
cp $snpEffDir/galaxy/* .

# Create links to JAR files
ln -s $snpEffDir/snpEff.jar
ln -s $snpEffDir/SnpSift.jar

# Link to config file
ln -s $snpEffDir/snpEff.config

# Allow scripts execution
chmod a+x *.{pl,sh}

# Copy genomes information
cd ../..
cp $snpEffDir/galaxy/tool-data/snpEff_genomes.loc tool-data/

# Edit Galaxy's tool_conf.xml and add all the tools
vi tool_conf.xml

-------------------- Begin: Edit tool_conf.xml --------------------
<!-- 
    Add this section to tool_conf.xml file in your galaxy distribution

    Note: The following lines should be added at the end of the 
          file, right before "</toolbox>" line
-->
<section name="snpEff tools" id="snpEff_tools">
    <tool file="snpEff/snpEff.xml" />
    <tool file="snpEff/snpEff_download.xml" />
    <tool file="snpEff/snpSift_annotate.xml" />
    <tool file="snpEff/snpSift_caseControl.xml" />
    <tool file="snpEff/snpSift_filter.xml" />
    <tool file="snpEff/snpSift_int.xml" />
</section>
-------------------- End: Edit tool_conf.xml --------------------

# Run galaxy and check that the new menus appear
./run.sh
```

# SnpSift Intersect

This command intersects several intervals files (e.g. BED, BigBed, TXT) and produces a result of all intersections.

A typical usage example is to create a consensus of peaks from several Chip-Seq experiments.

Algorithm: This command creates one interval forest for each input file.
For every interval in all input files, finds all intervals that intersect at least `minOverlap` bases (default 1 base).
If there are at least `cluster` number of intersecting intervals it creates a consensus interval from the intersections (or `union`) of all intervals found.
The consensus interval, if any, is shown as result.

Command line options:
```
$ java -jar SnpSift.jar intersect
SnpSift version 1.9d (build 2013-04-26), by Pablo Cingolani
Usage: java -jar SnpSift.jar [options] file_1.bed file_2.bed ... file_N.bed
Options:
        -minOverlap <num> : Minimum number of bases that two intervals have to overlap. Default : 0
        -cluster <num>    : An interval has to intersect at least 'num' intervals (from other files) to be considered. Default: 0
        -intersect        : Report the intersection of all intervals. Default: false
        -union            : Report the union of all intervals. Default: true
```

# Xiangyi Lu Donate

##  In memory of Dr. Xiangyi Lu

[Click here to donate](https://giving.wayne.edu/donate/medicine)

![](images/xiangy.jpg){: .right}

On October 22, 2017, Xiangyi Lu, a co-author on the SnpEff and SnpSift papers, died of ovarian cancer after a three year struggle.

Douglas Ruden, Xiangyi's husband and senior author on the papers, has requested that a non-mandatory gift of at least $10 for using SnpEff or SnpSift be donated to WSU to honor Xiangyi Lu.

All gifts will go to a newly named fund, the **"Xiangyi Lu Graduate Student Fellowship in Bioinformatics Fund."** with the goal of raising $1 million, in order to permanently endow one graduate student research position in bioinformatics every year.

## How to donate

* Visit [Wayne State University donation site](https://giving.wayne.edu/donate/medicine)
* Choose the amount that you would like to donate
* Click on the designation box and click on the option "Other"
* In the next box, enter: IMO Dr. Xiangyi Lu
* At the bottom of the page, click on "Give Now."


**Donation page example:**

[![](images/donate_Xiangyi_howto.png)](https://giving.wayne.edu/donate/medicine)

# Output summary Files

SnpEff creates an additional output file showing overall statistics.
This "stats" file is an HTML file which can be opened using a web browser.
You can find an example of a 'stats' file [here](adds/1kg.html).

### HTML summary (snpEff_summary.html)

The program performs some statistics and saves them to the file 'snpEff_summary.html' on the
directory where snpEff is being executed. You can see the file, by opening it in your browser.

!!! info
    You can change the default location by using the `-stats` command line option. This also changes the location of the TXT summary file.

!!! info
    Summary can be create in CSV format using command line option `-csvStats`. This allows easy downstream processing.

E.g.: In the stats file, you can see coverage histogram plots like this one:

![](http://chart.apis.google.com/chart?cht=bvg&chbh=8,4,2&chs=800x300&chxt=y,y,x,x&chg=11.0,40.0,3,2&chxp=1,50.0|3,50.0&chtt=Coverage+histogram&chxr=0,1.0,409.0|1,0.0,100.0|3,0.0,100.0&chxl=1:|Count|2:|1||||||||||11||||||||||21||||||||||31||||||||||41||||||||||51||||||||||61||||||||||76||||||||||3:|Coverage&chd=e:DNBSEfGaI9MKRSWZfXnrlwmZuE1wvW630e6O..638y3r7g8JsKxRlHgAkeZmY9XCR7PXRSOuOFMzNcIUJmHrHrFIFIFxEfCkDNDNBSBSB7BSB7BSApApApBSBSApAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA)

**"Effects by type" vs "Effects by region"**

SnpEff annotates variants.
Variants produce effect of difference "types" (e.g. NON_SYNONYMOUS_CODING, STOP_GAINED).
These variants affect regions of the genome (e.g. EXON, INTRON).
The two tables count how many effects for each type and for each region exists.

E.g.: In an EXON region, you can have all the following effect types: NON_SYNONYMOUS_CODING, SYNONYMOUS_CODING, FRAME_SHIFT, STOP_GAINED, etc.

The complicated part is that some effect types affect a region that has the same name (yes, I know, this is confusing).

E.g.: In a UTR_5_PRIME region you can have UTR_5_PRIME and START_GAINED effect type.

This means that the number of both tables are not exactly the same, because the labels don't mean the same.
See the next figure as an example:

![type_vs_region](images/type_vs_region.png){: .center}

So the number of effects that affect a UTR_5_PRIME *region* is 206. Of those, 57 are effects *type* START_GAINED and 149 are effects *type* UTR_5_PRIME.

How exactly are effect *type* and effect *region* related? See the following table:

Effect Type                                  | Region
-------------------------------------------- | ------
NONE<br>CHROMOSOME<br>CUSTOM<br>CDS          | NONE
INTERGENIC<br>INTERGENIC_CONSERVED           | INTERGENIC
UPSTREAM                                     | UPSTREAM
UTR_5_PRIME<br>UTR_5_DELETED<br>START_GAINED | UTR_5_PRIME
SPLICE_SITE_ACCEPTOR                         | SPLICE_SITE_ACCEPTOR
SPLICE_SITE_DONOR                            | SPLICE_SITE_DONOR
SPLICE_SITE_REGION                           | SPLICE_SITE_REGION
INTRAGENIC<br>START_LOST<br>SYNONYMOUS_START<br>NON_SYNONYMOUS_START<br>GENE<br>TRANSCRIPT | EXON or NONE
EXON<br>EXON_DELETED<br>NON_SYNONYMOUS_CODING<br>SYNONYMOUS_CODING<br>FRAME_SHIFT<br>CODON_CHANGE<br>CODON_INSERTION<br>CODON_CHANGE_PLUS_CODON_INSERTION<br>CODON_DELETION<br>CODON_CHANGE_PLUS_CODON_DELETION<br>STOP_GAINED<br>SYNONYMOUS_STOP<br> STOP_LOST<br>RARE_AMINO_ACID | EXON
INTRON<br>INTRON_CONSERVED                   | INTRON
UTR_3_PRIME<br>UTR_3_DELETED                 | UTR_3_PRIME
DOWNSTREAM                                   | DOWNSTREAM
REGULATION                                   | REGULATION

### Gene counts summary (snpEff_genes.txt)

SnpEff also generates a TXT (tab separated) file having counts of number of variants affecting each transcript and gene.
By default, the file name is `snpEff_genes.txt`, but it can be changed using the `-stats` command line option.

Here is an example of this file:
```
$ head snpEff_genes.txt
# The following table is formatted as tab separated values.
#GeneName	GeneId	TranscriptId	BioType	variants_impact_HIGH	variants_impact_LOW	variants_impact_MODERATE	variants_impact_MODIFIER	variants_effect_3_prime_UTR_variant	variants_effect_5_prime_UTR_premature_start_codon_gain_variant	variants_effect_5_prime_UTR_variant	variants_effect_downstream_gene_variant	variants_effect_intron_variant	variants_effect_missense_variant	variants_effect_non_coding_exon_variant	variants_effect_splice_acceptor_variant	variants_effect_splice_donor_variant	variants_effect_splice_region_variant	variants_effect_start_lost	variants_effect_stop_gained	variants_effect_stop_lost	variants_effect_synonymous_variant	variants_effect_upstream_gene_variant	bases_affected_DOWNSTREAM	total_score_DOWNSTREAM	length_DOWNSTREAM	bases_affected_EXON	total_score_EXON	length_EXON	bases_affected_INTRON	total_score_INTRON	length_INTRON	bases_affected_SPLICE_SITE_ACCEPTOR	total_score_SPLICE_SITE_ACCEPTOR	length_SPLICE_SITE_ACCEPTOR	bases_affected_SPLICE_SITE_DONOR	total_score_SPLICE_SITE_DONOR	length_SPLICE_SITE_DONOR	bases_affected_SPLICE_SITE_REGION	total_score_SPLICE_SITE_REGION	length_SPLICE_SITE_REGION	bases_affected_TRANSCRIPT	total_score_TRANSCRIPT	length_TRANSCRIPT	bases_affected_UPSTREAM	total_score_UPSTREAM	length_UPSTREAM	bases_affected_UTR_3_PRIME	total_score_UTR_3_PRIME	length_UTR_3_PRIME	bases_affected_UTR_5_PRIME	total_score_UTR_5_PRIME	length_UTR_5_PRIME
AC000029.1	ENSG00000221069	ENST00000408142	miRNA	0	0	0	2	0	0	0	2	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
AC000068.5	ENSG00000185065	ENST00000431090	antisense	0	0	0	1	0	0	0	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0
AC000081.2	ENSG00000230194	ENST00000433141	processed_pseudogene	0	0	0	8	0	0	0	3	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	5	0	5000	0	0
AC000089.3	ENSG00000235776	ENST00000424559	processed_pseudogene	0	0	0	1	0	0	0	0	0	0	0	0	0	0	5000	0	0	0	0	0	0
AC002472.1	ENSG00000269103	ENST00000547793	protein_coding	0	0	0	6	0	0	0	5	0	0	0	0	0	0	0	5000	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	1	0	5000	0	0
AC002472.11	ENSG00000226872	ENST00000450652	antisense	0	0	0	13	0	0	0	5	2	0	0	0	0	0	0	5000	0	0	0	2	0	11199	0	0	0	0	0	0	0	0	0	0	0	0	6	0	5000	0	0
AC002472.13	ENSG00000187905	ENST00000342608	protein_coding	0	1	6	1	0	0	0	0	1	6	0	0	0	1	0	116	1	0	934	0	0	0	0	0	0	1	0	3	0	0	0	0	0	0	0	0	0	0	0
AC002472.13	ENSG00000187905	ENST00000442047	protein_coding	0	1	6	1	0	0	0	0	1	6	0	0	0	1	0	116	1	0	934	0	0	0	0	0	0	1	0	3	0	0	0	0	0	0	0	0	0	0	0
```

The columns in this table are:

Column name        | Meaning
------------------ | ---------------
GeneName           | Gene name (usually HUGO)
GeneId             | Gene's ID
TranscriptId       | Transcript's ID
BioType            | Transcript's bio-type (if available)
&nbsp;             | **The following column is repeated for each impact {HIGH, MODERATE, LOW, MODIFIER}**
variants_impact_*  | Count number of variants for each impact category
&nbsp;             | **The following column is repeated for each annotated effect (e.g. missense_variant, synonymous_variant, stop_lost, etc.)**
 variants_effect_* | Count number of variants for each effect type
&nbsp;             | **The following columns are repeated for several genomic regions (DOWNSTREAM, EXON, INTRON, UPSTREAM, etc.)**
bases_affected_*   | Number of bases that variants overlap genomic region
total_score_*      | Sum of scores overlapping this genomic region. Note: Scores are only available when input files are type 'BED' (e.g. when annotating ChipSeq experiments)
length_*           | Genomic region length

# VCF format:
	- Parse header
	- Pedigree (cancer)

# Output formatter
	- vcf
		- "normal"
		- gatk
		- oicr
		- classic
		- LOF / NMD
		- Custom fields
	- bed
	- json


### Variants

### VariantsEffects
	- Cancer
		- Needs all variants for comparisson
	- LOF (infered from VariantsEffects)
	- NMD (infered from VariantsEffects)

	- Dependent effects: The impact depeneds on previous effects (e.g. `NON_SYN` vs `SYN`)
		- Interactions: Protein interaction, interaction site, etc.
		- NextProt
			- Highly conserved
			- Phosphorilation site

# SnpSift VcfCheck

Perform some basic check ups on VCF files to spot common problems.

`SnpSift vcfCheck` checks for some common problems where VCF files are not following the specification.
Given that many common VCF problems cause analysis tools and pipelines to behave unexpectedly, this command is intended as a simple debugging tool.

E.g.:
```
$ java -jar SnpSift.jar vcfCheck bad.vcf

WARNING: Malformed VCF entryfile 'bad.vcf', line 7:
        Entry  : 3	148885779	.	A	ATT,AT	999.0	PASS	UK10KWES_AC=0,0;MDV=94
        Errors :
                INFO filed 'UK10KWES_AC' has 'Number=1' in header, but it contains '2' elements.
                Cannot find header for INFO field 'MDV'

WARNING: Malformed VCF entryfile 'bad.vcf', line 14:
        Entry  : 3	148890104	.	TCA	T	.	.	.
        Errors :
                File is not sorted: Position '3:148890104' after position '3:148890105'

```

# Human Genomes

There are several version of the human genome supported by SnpEff

Here we explain the subtle differences between each version:


### Who is who

Here is a brief explanation of who are the key releases of the Human Genome (all quotes are from their respective web sites, at the time I created this page):

**[Ensembl](http://www.ebi.ac.uk/):**:
- *“Ensembl creates, integrates and distributes reference datasets and analysis tools that enable genomics. We are based at EMBL-EBI (European Molecular Biology Laboratory, European Bioinformatics Institute)”*
- *“Ensembl transcripts displayed on our website are products of the Ensembl automatic gene annotation system (a collection of gene annotation pipelines), termed the Ensembl annotation process. All Ensembl transcripts are based on experimental evidence and thus the automated pipeline relies on the mRNAs and protein sequences deposited into public databases from the scientific community. Manually-curated transcripts are produced by the HAVANA group.”*


**[RefSeq:](https://www.ncbi.nlm.nih.gov/refseq/)**
- Provided by NCBI (National Center for Biotechnology Information)
- *“The Reference Sequence (RefSeq) collection provides a comprehensive, integrated, non-redundant, well-annotated set of sequences, including genomic DNA, transcripts, and proteins”*


**[Gencode](https://www.gencodegenes.org/):**
- *“The goal of the GENCODE project is to identify and classify all gene features in the human and mouse genomes with high accuracy based on biological evidence, and to release these annotations for the benefit of biomedical research and genome interpretation.”*
- *“The GENCODE annotation is made by merging the manual gene annotation produced by the Ensembl-Havana team and the Ensembl-genebuild automated gene annotation. … The GENCODE releases coincide with the Ensembl releases…. In practical terms, the GENCODE annotation is essentially identical to the Ensembl annotation.”*

**[GRCh]([https://www.ncbi.nlm.nih.gov/grc/human])**: Genome Reference Consortium (human)


### Human Genome versions

Which Human genome version correspond to which genome names:

- GRCh38.mane.0.93.ensembl: Human genome GRCh38, using MANE transcripts v0.93, Ensembl IDs. See MANE below for details.

- GRCh38.mane.0.93.refseq: Human genome GRCh38, using MANE transcripts v0.93, RefSeq IDs. See MANE below for details.

- GRCh38.*NN* (e.g. GRCh38.104): These are genome annotations from ENSEMBL, created from GRCh38/hg38 reference genome sequence.

- GRCh37.*NN* (e.g. GRCh37.75): These are the genome annotations from ENSEMBL, created from GRCh37/hg19 reference genome sequence. **WARNING:** Ensembl stopped releasing genomes based on GRCh37/hg19 on February 2014.

- GRCh38.p*NN* (e.g. GRCh38.p13): These are RefSeq transcripts from NCBI mapped to GRCh38/hg38 reference genome sequence

- GRCh37.p*NN* (e.g. GRCh37.p13): These are RefSeq transcripts from NCBI mapped to GRCh38/hg19 reference genome sequence

- hg38: UCSC genome with RefSeq transcripts mapped to GRCh38/hg38 reference genome sequence

- hg19: UCSC genome with RefSeq transcripts mapped to GRCh37/hg19 reference genome sequence

- hg38kg: UCSC genome with KnownGenes transcripts mapped to GRCh38/hg38 reference genome sequence

- hg19kg: UCSC genome with KnownGenes transcripts mapped to GRCh37/hg19 reference genome sequence


### Important considerations

There are some things you need to consider when looking at genomic variants results.

- **Do not mix genome versions.** It is important not to confuse different genome versions when comparing results. For example, if you use SnpEff to annotate variants using GRCh38.103 (from ENSEMBL) and then look at the variant using UCSC's genome browser (which uses RefSeq transcripts) there might be differences because your are using different transcripts set, thus the variant annotations may not match.

- **Canonical is ill-defined:** Everybody has a different definition of what a canonical transcript is (see details in the next section).

- **HGSV requires realignment**: HGVS "sometimes" recommends to shift the variants "right" respect to the transcript, whereas VCF specification requires to always shift left respect to he genome. This can catch off guard many scientist who are unaware of this side effect of using HGVS notation and wonder why the variant annotation software is reporting some variants as if they were aligned to "another location". In order to warn the users that such realignment occurred, an `INFO_REALIGN_3_PRIME` message is added to annotation in the VCF entry.


### Important considerations: RefSeq

These are some considerations to keep in mind while working with RefSeq transcripts, this includes SnpEff genomes hg19, hg38, GRCh38.p13, GRCh37.p13, etc.

- **RefSeq transcripts may NOT match the reference genome.** This is a surprise for a lot of people, but RefSeq was designed as a consensus of transcript sequences as opposed as predicted from the reference genome. As a result a RefSeq transcript may not match the reference genome.

- **RefSeq transcripts differ ~5% respect to the reference genome.** This is a consequence of the previous item. Between 3% to 7% of the transcripts in RefSeq do not exactly match the reference genome, thus the proteins inferred from the genomic CDSs sequences are different than the "real" RefSeq CDS sequences. Most of the time, the difference (if any) is only one amino acid in the whole protein, but sometimes the difference is much larger.

- **Variant annotations using RefSeq may not be precise at the exact loci where the RefSeq transcript doesn't match the genome reference.** This is yet another consequence of the previous items, but since the transcript do not match the reference genome, and variant annotations are based on the reference genome, the variant annotaion predictions might be off at those genomic loci.

- **NCBI's gene IDs are just gene names, simetime with '_1', '_2', ..., etc.** Gene IDs from NCBI genomes (e.g. GRCh38.p13) are just gene names. If a gene is mapped to multiple genomic loci, then the same gene name is used and string is added to make it unique ('_1', for the first duplicate, '_2' for the second and so on). For example, here are the gene IDs for gene 'KIR3DL3' (note the last line is 'KIR3DL3_46', so there are 47 loci for this gene):

```
# Note: Results edited for readability
$ grep "gene\t" GCF_000001405.39_GRCh38.p13_genomic.gtf | grep KIR3DL3
NC_000019.10    BestRefSeq  gene    54724442    54736632    .   +   .   gene_id "KIR3DL3"; ...
NW_016107300.1  BestRefSeq  gene    26066   38262   .   +   .   gene_id "KIR3DL3_1"; ...
NW_016107301.1  BestRefSeq  gene    26066   38253   .   +   .   gene_id "KIR3DL3_2"; ...
NW_016107302.1  BestRefSeq  gene    26075   38226   .   +   .   gene_id "KIR3DL3_3"; ...
NW_016107303.1  BestRefSeq  gene    26066   38222   .   +   .   gene_id "KIR3DL3_4"; ...
NW_016107304.1  BestRefSeq  gene    26066   38255   .   +   .   gene_id "KIR3DL3_5"; ...
NW_016107305.1  BestRefSeq  gene    26072   38219   .   +   .   gene_id "KIR3DL3_6"; ...
...
NT_187686.1 BestRefSeq  gene    177446  189666  .   -   .   gene_id "KIR3DL3_44"; ...
NT_187687.1 BestRefSeq  gene    132277  144472  .   -   .   gene_id "KIR3DL3_45"; ...
NT_113949.2 BestRefSeq  gene    139138  151310  .   -   .   gene_id "KIR3DL3_46"; ...
```

- **UCSC transcripts (hg19/hg38) are not unique.** Transcript IDs might not be unique. Many assume that IDs are unique, but this is not always true to UCSC's genomic files.

- **A UCSC transcripts (hg19/hg38) can map to multiple loci.** A transcript from hg19/hg39 can map to multiple genomic loci, this is a consequence of transcripts IDs not being unique. For example, transcript NR_110738.1 is mapped to 123 loci:


```
$ cat hg38.refseq | cut -f 2 | sort | uniq -c | sort -rn | head
 123 NR_110738.1
  92 NR_110737.1
  92 NM_014218.3
  91 NM_001368251.1
  71 NM_001281972.2
  54 NM_001291696.1
  54 NM_001281971.2
  53 NM_014513.2
  53 NM_001360171.1
  52 NM_014512.1
 ```


### Canonical transcripts

You need to be careful because the definition of "Canonical trnascript" changes for each data source and sometimes for each genome version.

The definition used by SnpEff is: *“The canonical transcript is defined as either the longest CDS, if the gene has translated transcripts, or the longest cDNA.”* (Ref: https://www.ncbi.nlm.nih.gov/pmc/articles/PMC2686571)

Just to show that there are subtle differences, here some of the definitions Canonical from some prominent genomic sources:

**Ensembl** (Ref: http://useast.ensembl.org/Help/Glossary)

1. Longest CCDS translation with no stop codons
1. longest Ensembl/Havana merged translation with no stop codons
1. longest translation with no stop codons.
1. If no translation, choose the longest non-protein-coding transcript.
1. Note: “…does not necessarily reflect the most biologically relevant transcript of a gene”

**UCSC** (Ref: https://genome.ucsc.edu/FAQ/FAQgenes.html)

1. hg19: “Generally, this is the longest isoform.”
1. hg38: “The canonical transcript is chosen using the APPRIS principal transcript when available. If no APPRIS tag exists for any transcript associated with the cluster, then a transcript in the BASIC set is chosen. If no BASIC transcript exists, then the longest isoform is used”.

**UniProt** (Ref: https://www.uniprot.org/help/canonical_and_isoforms)

1. It is the most prevalent.
1. It is the most similar to orthologous sequences found in other species.
1. By virtue of its length or amino acid composition, it allows the clearest description of domains, isoforms, genetic variation, post-translational modifications, etc.
1. In the absence of any information, we choose the longest sequence.


As you can see these definitions do not match and obviously these differences could affect your analysis.


### MANE

MANE stands for "Matched Annotation from NCBI and EMBL-EBI".
Both NCBI and ENSEMBL have been joining efforts in this new initiative to provide a joint transcript set compatible with both.

MANE started in 2018, to converge into a common set of transcripts that has desirable characteristics:

- contains one well-supported transcript per protein-coding locus,
- perfectly align to the reference genome,
- has 100\% match between RefSeq and ENSEMBL (including coding sequence and UTRs),
- has been manually curated by both groups,
- is versioned and largely stable.
- includes additional transcripts (i.e. more than one per gene) required to report variants of clinical interest, and
- will become the default transcripts shown in Genome Browsers.


As of this writing, version 0.93 was released in January 2021.
Furthermore, the upcoming ENSEMBL release 104 is expected to switch the definition of "Canonical Transcript" to favor MANE transcripts.

References:

- https://www.ncbi.nlm.nih.gov/refseq/MANE/
- https://www.ensembl.info/tag/mane/
- https://useast.ensembl.org/info/genome/genebuild/mane.html

# SnpSift Vcf2Tped

Convert from VCF to PLINK's TPED file format.

The `vcf2tped` command uses a VCF and a TFAP file as input, creating a TPED and a consolidated TFAM as outputs.

Command line options are:
```
$ java -jar SnpSift.jar vcf2tped
SnpSift version 1.9d (build 2013-04-26), by Pablo Cingolani
Usage: java -jar SnpSift.jar vcf2tped [options] file.tfam file.vcf outputName
Options:
        -f             : Force. Overwrite new files if they exist. Default: false
        -onlySnp       : Use only SNPs when converting VCF to TPED. Default: false
        -onlyBiAllelic : Use only bi-allelic variants. Default: false
        -useMissing    : Use entries with missing genotypes (otherwise they are filtered out). Default: false
        -useMissingRef : Use entries with missing genotypes marking them as 'reference' instead of 'missing'. Default: false
Parameters:
        file.tfam      : File with genotypes and groups information (in PLINK's TFAM format)
        file.vcf       : A VCF file (variants and genotype data)
        outputName     : Base name for the new TPED and TFAM files.
```

`vcf2tped` command supports the following features:

* Output a TPED file:
    * Only samples present in both the input TFAM and the input VCF files are in the output TPED.
    * Bi-allelic filter: `-onlyBiAllelic` option filters out non bi-allelic variants.
    * Non SNP variants (InDels, MNPs, etc):
        * InDels and other non-SNP variants are converted for "fake" SNPs (some programs have problems handling non-SNP variants).
        * `-onlySnp` option filters out non SNP variants.
    * Missing variants:
        * Variants having missing data are filtered out by default.
        * `-useMissing` uses missing variants in TPED file.
        * `-useMissingRef` Converts missing variants to reference genotype.
* Output TFAM file:
    * Only samples present in both the input TFAM and the input VCF files are in the output TFAM.
    * Samples are re-ordered to have the same order as the VCF file

# SnpSift GT

Compress genotype calls, reducing the overall size of the VCF file.

This is intended for compressing very large VCF in very large sequencing projects (e.g. thousands of samples).

!!! info
    For instance, we've reduced 1Tb (1,000 Gb) VCF file to roughly 1Gb in a project that has over 10,000 samples.

The underlying idea is quite simple.
In large re-sequencing projects most of the variants are singletons.
This means that most variants are present in only one of the samples.
For those variants, you have thousands of samples that are homozygous reference (i.e. genotype entry is "0/0") and one that is a variant (e.g. '0/1' or '1/1').

A trivial way to compress these VCF entries is just to state which sample has non-reference information.
Intuitively, this is similar to the way used to represent sparse matrices (only store non-zero elements).

`SnpSift gt` creates three INFO fields. These three files are composed of comma separated indexes of samples having:

* HE: Indicated heterozygous variants (i.e. '0/1').
* HO: Indicated homozygous variants (i.e. '1/1').
* NA: Indicated missing genotype data (i.e. './.').

You can use `-u` command line option to uncompress.

E.g.:
```
$ cat test.vcf
#CHROM  POS     ID  REF  ALT  QUAL  FILTER  INFO  FORMAT  Sample_1  Sample_2  Sample_3  Sample_4  Sample_5  Sample_6  Sample_7  Sample_8  Sample_9  Sample_10  Sample_11  Sample_12  Sample_13  Sample_14  Sample_15
1       861276  .   A    G    .     PASS    AC=1  GT      0/0       1/1       0/0       0/0       0/0       0/0       0/0       0/0       0/0       0/0        0/0        0/0        0/0        0/0        0/0

#---
# Compress genotypes
#---
$ java -jar SnpSift.jar gt test.vcf | tee test.gt.vcf
##INFO=<ID=HO,Number=.,Type=Integer,Description="List of sample indexes having homozygous ALT genotypes">
##INFO=<ID=HE,Number=.,Type=Integer,Description="List of sample indexes having heterozygous ALT genotypes">
##INFO=<ID=NA,Number=.,Type=Integer,Description="List of sample indexes having missing genotypes">
#CHROM  POS     ID  REF  ALT  QUAL  FILTER  INFO        FORMAT  Sample_1  Sample_2  Sample_3  Sample_4  Sample_5  Sample_6  Sample_7  Sample_8  Sample_9  Sample_10  Sample_11  Sample_12  Sample_13  Sample_14  Sample_15
1       861276  .   A    G    .     PASS    AC=1;HO=1

#---
# Uncompress genotypes (command line option '-u')
#---
$ java -jar SnpSift.jar gt -u test.gt.vcf
#CHROM  POS     ID  REF  ALT  QUAL  FILTER  INFO  FORMAT  Sample_1  Sample_2  Sample_3  Sample_4  Sample_5  Sample_6  Sample_7  Sample_8  Sample_9  Sample_10  Sample_11  Sample_12  Sample_13  Sample_14  Sample_15
1       861276  .   A    G    .     PASS    AC=1  GT      0/0       1/1       0/0       0/0       0/0       0/0       0/0       0/0       0/0       0/0        0/0        0/0        0/0        0/0        0/0
```

!!! warning
    This is lossy compression. Note that only GT informations is compressed, all other information in genotype field is lost.

# SnpSift

**SnpSift** is a toolbox that allows you to filter and manipulate annotated files.

Once your genomic variants have been annotated, you need to filter them out in order to find the "interesting / relevant variants".
Given the large data files, this is not a trivial task (e.g. you cannot load all the variants into XLS spreadsheet).
SnpSift helps to perform this VCF file manipulation and filtering required at this stage in data processing pipelines.

### Download and install

SnpSift is part of SnpEff main distribution, so please click on [here](../download.md) and follow the instructions on how to download and install SnpEff.

### SnpSift utilities

SnpSift is a collection of tools to manipulate VCF (variant call format) files.

Some examples of what you can do:

Operation              | Meaning
---------------------- | --------
**Filter**             | You can filter using arbitrary expressions, for instance `"(QUAL > 30) | (exists INDEL) | ( countHet() < 2 )"`. The actual expressions can be quite complex, so it allows for a lot of flexibility.
**Annotate**           | You can add 'ID' and INFO fields from another "VCF database" (e.g.  typically dbSnp database in VCF format).
**CaseControl**        | You can compare how many variants are in 'case' and in 'control' groups. Also calculates p-values (Fisher exact test).
**Intervals**          | Filter variants that intersect with intervals.
**Intervals (intidx)** | Filter variants that intersect with intervals. Index the VCF file using memory mapped I/O to speed up the search. This is intended for huge VCF files and a small number of intervals to retrieve.
**Join**               | Join by generic genomic regions (intersecting or closest).
**RmRefGen**           | Remove reference genotype (i.e. replace '0/0' genotypes by '.')
**TsTv**               | Calculate transition to transversion ratio.
**Extract fields**     | Extract fields from a VCF file to a TXT (tab separated) format.
**Variant type**       | Adds SNP/MNP/INS/DEL to info field. It also adds "HOM/HET" if there is only one sample.
**GWAS Catalog**       | Annotate using GWAS Catalog.
**DbNSFP**             | Annotate using dbNSFP: The dbNSFP is an integrated database of functional predictions from multiple algorithms (SIFT, Polyphen2, LRT and MutationTaster, PhyloP and GERP++, etc.)
**SplitChr**           | Split a VCF file by chromosome

### Citing SnpSift

In order to cite SnpSift, please use the following [example](../index.md#citing-snpsift).

### Source code

The project is hosted at [GitHub](https://github.com/pcingola/SnpEff).

# SnpSift Split

Simply split (or join) VCF files.
Allows to create one file per chromosome or one file every N lines.

A typical usage for this command is to:

1. Split very large VCF files `SnpSift split huge.vcf`
2. Perform some CPU intensive processing in parallel using several computers or cores
3. Join the resulting VCF files `SnpSift split -j huge.000.vcf huge.001.vcf huge.002.vcf ...  > huge.out.vcf`.

E.g.: Splitting a VCF having human variants:

    java -jar SnpSift.jar split myHugeVcf.vcf.gz

Will create files myHugeVcf.1.vcf, myHugeVcf.2.vcf, ... , myHugeVcf.22.vcf, myHugeVcf.X.vcf, myHugeVcf.Y.vcf

You can also specify '-l' command line option to split the file every N lines.

E.g.: Split a VCF file every 10,000 lines:

    java -jar SnpSift.jar split -l 10000 myHugeVcf.vcf.gz

Will create files myHugeVcf.001.vcf, myHugeVcf.002.vcf, ...

!!! info
    VCF header will be added to each file, so resulting files will be more than 10,000 lines.

You can use `-j` (join) command line option to join a set of VCF files.

    java -jar SnpSift.jar split -j huge.000.vcf huge.001.vcf huge.002.vcf ...  > huge.out.vcf

# SnpEff: Frequently Asked Questions

## Error and Warning messages

SnpEff defines several messages in roughly 3 categories:

- INFO: An informative message
- WARNING: A problem in the reference genome definition that **MAY** result in an incorrect variant annotation
- ERROR: A problem in the reference genome definition that **WILL ALMOST CERTAINLY** result in an incorrect variant annotation

**INFO_REALIGN_3_PRIME**

The variant has been realigned to the most 3-prime position within the transcript.

This is usually done to comply with HGVS specification to always report the most 3-prime annotation. While VCF requires to realign to the left-most of the reference genome, HGSV requires to realign to the most 3-prime. These two specifications are contradicting in some cases, so in order to comply with HGSV, sometimes a local realignment is required.

IMPORTANT: This message is just indicating that a realignment was performed, so ** when this INFO message is present, the original coordinates from the VCF file are not exactly the same as the coordinates used to calculate the variant annotation **

**WARNING_SEQUENCE_NOT_AVAILABLE**

The exon does not have reference sequence information.
The annotation may not be calculated (e.g. incomplete transcripts).

**WARNING_REF_DOES_NOT_MATCH_GENOME**

The genome reference does not match the variant's reference.

For example, if the VCF file indicates that the reference at a certain location is 'A', while SnpEff's database indicates that the reference should be 'C', this WARNING would be added.

Under normal circumstances, there should be none of these warnings (or at most a handful).

IMPORTANT: If too many of these warnings are seen, this indicates a severe problem (version mismatch between your VCF files and the reference genome). A typical case when too many of these warning are seen is when trying to annotate using a different genome than the one used for alignment (e.g. reads are aligned to hg19 but variants are annotated to using hg38)

**WARNING_TRANSCRIPT_INCOMPLETE**

The number of coding bases is NOT multiple of 3, so there is missing information for at least one codon.
This indicates an error in the reference genome gene and/or transcript definition.
This could happen in genomes that are not well understood.

**WARNING_TRANSCRIPT_MULTIPLE_STOP_CODONS**

Multiple STOP codons found in a CDS.
There should be only one STOP codon at the end of the transcript, but in this case, the transcript has multiple STOP codons, which is unlikely to be real.

This usually indicates an error on the reference genome (or database).
Could for, for example, indicating frame errors in the reference genome for one or more exons in this transcript.

**WARNING_TRANSCRIPT_NO_START_CODON**

Start codon does not match any 'start' codon in the CodonTable.

This usually indicates an error on the reference genome (or database) but could be also due to a misconfigured codon table for the genome. You should check that the codon table is properly set in `snpEff.config`

**WARNING_TRANSCRIPT_NO_STOP_CODON**

Stop codon does not match any 'stop' codon in the CodonTable.

This usually indicates an error on the reference genome (or database) but could be also due to a misconfigured codon table for the genome. You should check that the codon table is properly set in `snpEff.config`

**ERROR_CHROMOSOME_NOT_FOUND**

Chromosome name not found. Typically due to mismatch in chromosome naming conventions between variants file and database, but can be a more several problems (different reference genome).

See more details (here)[https://github.com/pcingola/SnpEff/wiki/ERROR_CHROMOSOME_NOT_FOUND]

**ERROR_OUT_OF_CHROMOSOME_RANGE**

Variant's genomic position is outside chromosome's range.

Simple, the variant coordinate is outside the reference genome chromosome's length.

IMPORTANT: If too many of these warnings are seen, this indicates a severe problem (version mismatch between your VCF files and the reference genome). A typical case when too many of these warning are seen is when trying to annotate using a different genome than the one used for alignment (e.g. reads are aligned to hg19 but variants are annotated to using hg38)

**ERROR_OUT_OF_EXON**

An exonic variant is falling outside the exon.

**ERROR_MISSING_CDS_SEQUENCE**

Missing coding sequence information.
In this case, the full variant annotation cannot be calculated due to missing CDS information.

This usually indicates an error on the reference genome (or database).



## ERROR_CHROMOSOME_NOT_FOUND: Details

The error is due to a difference between the chromosome names in input VCF file and the chromosome names in SnpEff's database.

Chromosome does not exist in the reference database. Typically this means that there is a mismatch between the chromosome names in your input file and the chromosome names used in the reference genome to build SnpEff's database.

!!! warning
	This error could be caused because you are trying to annotate using a reference genome that is different than the one you used for sequence alignment. Obviously doing this makes no sense and the annotation information you'll get will be garbage. That's why SnpEff shows you an error message.

**Solution**

Sometimes SnpEff database matches the reference genome for your organism, and it's just that the chromosome names are changed. In this case, you can fix the error by changing the chromosome names in your input file.

!!! info
	You can see the chromosome names used by SnpEff's database by using `-v` (verbose) option. SnpEff will show a line like this one:

```
$ java -Xmx4g -jar snpEff.jar -v genomeName my.vcf > my.ann.vcf
...
...
# Chromosomes names [sizes]  : '1' [249250621] '2' [243199373]
...
...
```

!!! info
	You can see the chromosome names in your input VCF file using a command like this one

```
cat input.vcf | grep -v "^#" | cut -f 1 | uniq
```

Once you know the names of the input file and the name used by SnpEff's database, you can adjust the chromosome name using a simple sed command. For example, if you input file's chromosome name is `INPUT_CHR_NAME` and the name in SnpEff's database is `SNPEFF_CHR_NAME`, you could use the following command:

```
cat input.vcf | sed "s/^INPUT_CHR_NAME/SNPEFF_CHR_NAME/" > input_updated_chr.vcf
```



## How to building an NCBI genome (GenBank file)

When building a database with SnpEff if your genomic reference is in NCBI, there is a script that might help you build the database.

The script is `buildDbNcbi.sh` and is located in snpEff's scripts directory.
It takes only one argument, which is the NCBI's ID.

**Example: Salmonella enterica**

In this example, we build the database for _"Salmonella enterica subsp. enterica serovar Typhi str. P-stx-12"_ having accession ID CP003278.1

```
$ cd ~/snpEff

# Note: Output edited for brevity
$ ./scripts/buildDbNcbi.sh CP003278.1
Downloading genome CP003278.1
  % Total    % Received % Xferd  Average Speed   Time    Time     Time  Current
                                 Dload  Upload   Total   Spent    Left  Speed
100 10.2M    0 10.2M    0     0  3627k      0 --:--:--  0:00:02 --:--:-- 3627k
00:00:00	SnpEff version SnpEff 4.3p (build 2017-07-28 14:02), by Pablo Cingolani
00:00:00	Command: 'build'
00:00:00	Building database for 'CP003278.1'
00:00:00	Reading configuration file 'snpEff.config'. Genome: 'CP003278.1'
00:00:00	Reading config file: /home/pcingola/workspace/SnpEff/snpEff.config
00:00:00	done
Chromosome: 'CP003278'	length: 4768352

	Create exons from CDS (if needed): ..................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................
	Exons created for 4690 transcripts.

...
00:00:01	Reading proteins from file '/home/pcingola/workspace/SnpEff/./data/CP003278.1/genes.gbk'...
00:00:01	done (4690 Proteins).
00:00:01	Comparing Proteins...
	Labels:
		'+' : OK
		'.' : Missing
		'*' : Error
	+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
...
	+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	Protein check:	CP003278.1	OK: 4690	Not found: 0	Errors: 0	Error percentage: 0.0%
00:00:02	Saving database
...
00:00:04	Done.
```


## Creating a protein sequence FASTA file

SnpEff `ann` command has a command line option called `-fastaProt` that tells SnpEff to output the "original" and "resulting" protein sequences for each variant into a FASTA file.

This means that for each variant, the output FASTA file will have an entry with protein sequence resulting from applying that variant to the reference sequence.

Here is an example:
```
$ cat z.vcf
17  39684602    .   C   T   .   .   .

$ java -Xmx6g -jar snpEff.jar ann -fastaProt z.prot.fa GRCh38.mane.1.2.ensembl z.vcf > z.ann.vcf
```

The resulting fasta file `z.prot.fa` looks like this (lines edited for readibility):

Notice the difference in the protemic sequeces ('VAF**A**WVS' -> 'VAF**T**WVS')
```
>ENST00000300658.9, gene: PGAP3, protein_id: ENSP00000300658.4, reference
MAGL....VAFAWVS...
>ENST00000300658.9, gene: PGAP3, protein_id: ENSP00000300658.4, variant:q 17:39684602-39684602, ref:'C', alt:'T', HGVS.p: p.Ala143Thr
MAGL....VAFTWVS...
```

When given the command line option `-fastaProtNoRef`, no reference sequence is written to the output FASTA protein sequences file.


## Genome reference

Having a standard reference sequence is the key to establish comparisons and analysis.
In order to compare DNA from different individuals (or samples), we need a *reference genome sequence* and *genomic annotations*.

Alignment and annotations must be based on the exact same reference genome sequence.
Variants are called based on the reference genome, thus variant annotations must be performed using same reference genome.
For instance, performing variant calling respect to hg19 and then performing variant annotations using hg38 genome, would result in completely erroneous results.

Oftentimes lack of consistency between SnpEff annotations and genome coordinated from other data sources (e.g. a genome browser or other online databases) are due to the fact that there is a difference in genome reference versions.
For example, maybe the VCF file was annotated using SnpEff's `GRCh38.99` database, but you are looking at an `hg38` genome browser (both reference are human, version 38, but different transcript versions).


## Genome reference data sources

SnpEff genome databases are built from genomic data sources, such as Ensembl, RefSeq, NCBI, UCSC, etc.

To find which data source was used, sometimes the information is provided in the `snpEff.config` file, under the `genome_name.reference` entry.

**Example 1: GRCh37.75**

If you are looking for the `GRCh37.75` genome, you can search for the entry in `snpEff.conf` file:

```
$ grep -A 1 GRCh37.75 snpEff.config
GRCh37.75.genome : Homo_sapiens
GRCh37.75.reference : ftp://ftp.ensembl.org/pub/release-75/gtf/
```
 As you can see, the genome data is from Ensembl, release 75 (as expected).

**Example 2: hg19**

If you are looking for the `hg19` genome, you can also search for the entry in `snpEff.conf` file:

```
$ grep -i hg19.genome snpEff.config
hg19.genome : Homo_sapiens (USCS)
...
```

In this case, there is no `hg19.reference` entry, but the genome name clearly states that the database was retrieved from UCSC (having RefSeq).
Which exact sub-version is this hg19?
Well, unfortunately, UCSC does not keep track of sub-versions.
A rule of the thumb is that the database is retrieved before it is built, so you can look at the date/time from the snpEff database:

```
$ ls -al data/hg19/snpEffectPredictor.bin
-rw-r--r-- 1 pcingola pcingola 52630202 Mar 19 08:27 data/hg19/snpEffectPredictor.bin
```

So this`hg19` database was retrieved from UCSC around on March 19th.

**Example 3: Salmonella_enterica**

Sometimes the information is in the genome's `reference` entry is not enough to determine which exact version was used, but the `snpEff.config` file provides some additional information in the comments
For example, let's say we'd like to find the data source for `Salmonella_enterica` genome

If we edit the `snpEff.config` and find the entry for Salmonella_enterica, we see something like this:
```
Salmonella_enterica.genome : Salmonella_enterica
Salmonella_enterica.reference : ftp.ensemblgenomes.org
```

OK, it is from Ensembl, but which version?
If you scroll up in the config file, you'll see a comment like this:

```
#---
# ENSEMBL BFMPP release 32
#---
```

Here `ENSEMBL BFMPP` stands for Endembl Bacteria, Fungi, Metazoa, Plants and Protists.
So the comment is indicating that this is Ensembl's release 32.



## Number of variants in VCF and HTML summary do not match

First of all, SnpEff is probably giving you the right numbers, the mismatch might not be a bug, but a simple interpretation issue.

### Counting variants vs lines in a VCF file

It is important to remember that the VCF format specification allows having multiple variants in a single line.
For example, here is a VCF line with multiple variants:

```
#CHROM  POS         ID  REF  ALT       QUAL  FILTER  INFO
chr2    115032192   .   G    GT,GTT    30    PASS    ...
```

In this case, the `ALT` field has more than one value separated by comma.
This means that the line contains two variants: 

- `G -> GT` 
- `G -> GTT`

So counting the number of non-comment lines in the VCF file will not give you the exact number of variants (it does give a lower bound on the number of variants).

### Counting variants vs annotations

Also, a single variant can have more than one annotation, due to:

- Multiple transcripts (isoforms) of a gene (e.g. the human genome has on average 8.8 transcrips per gene)
- Multiple (overlapping) genes in the genomic location of the variant.
- A variant spanning multiple genes (e.g. a translocation, large deletion, etc.)

So counting the number of variants is not equivalent to counting the number of annotations.
SnpEff does consider all these factors when counting the variants and annotations for the summary HTML.

### IUPAC expansion

Sometimes either the `REF` or `ALT` fields have [IUPAC/IUB](https://en.wikipedia.org/wiki/Nucleic_acid_notation) bases.
A common example is when you see an `N` character, which means that the base could be any of `{A, C, G, T}`.
There are several IUPAC characters, please see details in [IUPAC degenarate base symbols table](https://en.wikipedia.org/wiki/Nucleic_acid_notation).

In case of having IUPAC symbols in either the `REF` and/or `ALT` fields, SnpEff will expand them into different variants.
This means that entries with ambiguous symbols will be tranformed into all possible combinations of variants using the IUPAC notation.

!!! info
	You can disable the 'IUPAC/IUB expand' behaviour by using the `-noexpandiub` command line option.


For example, consider the following VCF line:

```
#CHROM  POS         ID  REF  ALT  QUAL  FILTER  INFO
chr1    102947631   .   T    N    30    PASS    ...
```

In this case the ambiguous variant `T -> N` will be expanded into three variants: 

- `T -> A`
- `T -> C`
- `T -> G`

!!! warning
	If the number of degenerate symbols increases, the number of variants expanded will increase exponentiallly.
	Currently SnpEff will not expand more than `MAX_IUB_BASES=10` bases


### Typical counting mistakes

Many people who claim that there is a mismatch between the number of variants in the summary (HTML) file and the number of variants in the VCF file, are just making mistakes when counting the variants because they forget one or more of these previously discussed items.

The most typical mistake is counting the number of non-comment Lines in a VCF file:

```
# This does NOT give the exact number of variants (only a lower bound on the number of variants)
grep -v '^#' myfile.vcf | wc -l
```

Another typical scenario is, when people are "counting missense variants" using something like this:

```
grep missense file.vcf | wc -l
```

This is counting _"lines in a VCF file that have at least one missense variants"_, as opposed to counting _"missense annotations"_ and, as mentioned previously, the number of lines in a VCF file is not the same as the number of annotations or the number of variants.


## SnpEff taking too long

Usually SnpEff runs within minutes.
Unless you are analyzing extremely large files with thousands (or hundreds of thousands) of samples.
But even in those cases SnpEff is efficient and it doesn't take too long.

There are several things you should do to optimize:

1. Run with "-v" option to check progress
1. Use enough memory in your Java process (see "How much memory should I use" FAQ)
1. You can disable the HTML report (command line option `-noStats`). The report is usually quite time consuming, particularly if the number of samples in the VCF is large



## How much memory should I use

How much memory to use is very specifcic to your project / application, but here are some guidelines:
- Default 8 GB: Typically 8G of memory is enough for analyzing a human genome (i.e. `java -Xmx8G -jar snpEff.jar ... ~)
- Medium 16 GB: It is rare that for single sample VCF file annotations more than 8G is required, but for some large genomes and/or VCF with too many samples, you might need more memory.
- Very large 128GB: It is extremely uncommon for SnpEff to require over 128GB of RAM for annotating with SnpEff, but it might happen on very large projects.



## Multiple version of RefSeq transcripts

When using RefSeq transcripts, for instance in the human genome versions `hg38` or `hg19`, can lead to some confusion due to multiply mapped transcripts.

**Example: `NM_001135865.1` from hg38**

From the original RefSeq data, you can see that there are actually four mappings of NM_001135865.1:
```
# Note: Output edited for readbility
$ zgrep NM_001135865.1 ~/snpEff/data/hg38/genes.refseq.gz

751 NM_001135865.1  chr16   -   21834582    21857657    21834717    21857378    11  ...
756 NM_001135865.1  chr16   +   22513522    22536520    22513801    22536385    7   ...
597 NM_001135865.1  chr16_KV880768v1_fix    +   1679394 1702742 1679673 1702607 11  ...
589 NM_001135865.1  chr16_KV880768v1_fix    -   568516  591514  568651  591235  7   ...
```

!!! warning
	To make matters even worse, not only `NM_001135865.1` maps twice to regions in `chr16`, but also one is mapped in the forward strand and the other on the reverse strand (notice the `+` and `-` signs)

How do you know which of the four `NM_001135865.1` version is SnpEff refering to?
When there are multiple mappings for a transcipt SnpEff will make sure each mapping is uniquely identified by appending a number to the original transcript ID.

So the transcript IDs are named (notice that the first one is not changed):

- `NM_001135865.1`
- `NM_001135865.1.2`
- `NM_001135865.1.3`
- `NM_001135865.1.4`

Even though they are mapped to different chromosomes and strands in `chr16`, the protein sequence will be very similar (that's why RefSeq has multiple mappings of the same transcript).


!!! info
	You can get details of each transcript using the SnpEff `show` command (e.g. `java -jar snpEff.jar show ...`)

We can analyse the difference, for instance `NM_001135865.1` and `NM_001135865.1.4` are mapped to `chr16`.
If you look at the protein sequences you'll notice that there is one small difference in amino acid 138 ('G' vs 'V'):

```
$ java -jar snpEff.jar show NM_001135865.1 NM_001135865.1.4 | tee show.txt
# Note: Output edited for readability
#
# Scroll right to see the difference ------>>>                                                                                                           | AA 138
#                                                                                                                                                        |
/Users/kqrw311/snpEff/issue_284$                                                                                                                         |
Showing genes and transcripts using zero-based coordinates                                                                                               |
Transcript (codon table: Standard ) :   16:22513522-22536519, strand: +, id:NM_001135865.1, Protein, DNA check                                           |
    ...                                                                                                                                                  |
    Protein :   MVKLSIVLTPQFLSHDQGQLTKELQQHVKSVTCPCEYLRKVINTLADHHHRGTDFGGSPWLHVIIAFPTSYKVVITLWIVYLWVSLLKTIFWSRNGHDGSTDVQQRAWRSNRRRQEGLRSICMHTKKRVSSFRGNKIGLKDVITLRRHVETKVRAKIRKRKVTTKINHHDKINGKRKTARKQKMFQRAQELRRRAEDYHKCKIPPSARKALCNWVRMA...
    ...                                                                                                                                                  | NM_001135865.1 has a 'G'
                                                                                                                                                         |
Transcript (codon table: Standard ) :   16:21834582-21857656, strand: -, id:NM_001135865.1.4, Protein                                                    |
    ...                                                                                                                                                  |
    Protein :   MVKLSIVLTPQFLSHDQGQLTKELQQHVKSVTCPCEYLRKVINTLADHHHRGTDFGGSPWLHVIIAFPTSYKVVITLWIVYLWVSLLKTIFWSRNGHDGSTDVQQRAWRSNRRRQEGLRSICMHTKKRVSSFRGNKIVLKDVITLRRHVETKVRAKIRKRKVTTKINHHDKINGKRKTARKQKMFQRAQELRRRAEDYHKCKIPPSARKALCNWVRMA...
    ...                                                                                                                                                  | NM_001135865.1.4 has a 'V'

```


## Cannot build database: `ERROR: Database check failed.`

When building databases, SnpEff will attempt to check the database against a CDS FASTA file and a Protein FASTA file.
Please see details in ['Building databases', section 'Step 3: Checking the database'](./build_db.md#step-3-checking-the-database)

If neither a CDS FASTA file nor a Protein FASTA file is provided, this check will fail and SnpEff will refuse to save the database, by showing error message like this one:

```
ERROR: CDS check file './data/MY_GENOME/cds.fa' not found.
ERROR: Protein check file './data/MY_GENOME/protein.fa' not found.
ERROR: Database check failed.
```

To disable these checks, you need to specify *BOTH* commmand line options `-noCheckCds -noCheckProtein`.

If you are using SnpEff or SnpSift, please cite our work.

## Citing SnpEff

You can find the paper [here](adds/SnpEff_paper.pdf).

In order to cite SnpSift, please use the following reference:

!!! quote
    "A program for annotating and predicting the effects of single nucleotide polymorphisms, SnpEff: SNPs in the genome of Drosophila melanogaster strain w1118; iso-2; iso-3.", Cingolani P, Platts A, Wang le L, Coon M, Nguyen T, Wang L, Land SJ, Lu X, Ruden DM. Fly (Austin). 2012 Apr-Jun;6(2):80-92.  PMID: 22728672

BibTex entry:
```
@article{cingolani2012program,
title={A program for annotating and predicting the effects of single nucleotide polymorphisms, SnpEff: SNPs in the genome of Drosophila melanogaster strain w1118; iso-2; iso-3},
author={Cingolani, P. and Platts, A. and Coon, M. and Nguyen, T. and Wang, L. and Land, S.J. and Lu, X. and Ruden, D.M.},
journal={Fly},
volume={6},
number={2},
pages={80-92},
year={2012}
}
```

## Citing SnpSift

You can find the paper [here](adds/SnpSift_paper.pdf).

In order to cite SnpSift, please use the following reference:

!!! quote
    "Using Drosophila melanogaster as a model for genotoxic chemical mutational studies with a new program, SnpSift", Cingolani, P., et. al., Frontiers in Genetics, 3, 2012.

BibTex entry:
```
@article{cingolani2012using,
title={Using Drosophila melanogaster as a model for genotoxic chemical mutational studies with a new program, SnpSift},
author={Cingolani, P. and Patel, V.M. and Coon, M. and Nguyen, T. and Land, S.J. and Ruden, D.M. and Lu, X.},
journal={Frontiers in Genetics},
volume={3},
year={2012},
publisher={Frontiers Media SA}
}
```

# SnpEff

**SnpEff** is a variant annotation and effect prediction tool.
It annotates and predicts the effects of genetic variants (such as amino acid changes).

### Download &amp; Install

Download and installing SnpEff it pretty easy, take a look at the [download page](../download.md).

### Building from source

Take a look at the ["Source code"](../download.md#source-code) section.

### SnpEff Summary

A typical SnpEff use case would be:

* Input:
    The inputs are predicted variants (SNPs, insertions, deletions and MNPs).
    The input file is usually obtained as a result of a sequencing experiment, and it is usually in variant call format (VCF).
* Output:
    SnpEff analyzes the input variants.
    It annotates the variants and calculates the effects they produce on known genes (e.g. amino acid changes).
    A list of effects and annotations that SnpEff can calculate can be found [here](inputoutput.md#effect-prediction-details).

**Variants**

By genetic variant we mean difference between a genome and a "reference" genome.
As an example, imagine we are sequencing a "sample".
Here "sample" can mean anything that you are interested in studying, from a cell culture, to a mouse or a cancer patient.

It is a standard procedure to compare your sample sequences against the corresponding "reference genome".
For instance you may compare the cancer patient genome against the "reference genome".

In a typical sequencing experiment, you will find many places in the genome where your sample differs from the reference genome.
These are called "genomic variants" or just "variants".

Typically, variants are categorized as follows:

Type  | What is means                    | Example
----- | -------------------------------- | -----------------------------
SNP   | Single-Nucleotide Polymorphism   | Reference = 'A', Sample = 'C'
Ins   | Insertion                        | Reference = 'A', Sample = 'AGT'
Del   | Deletion                         | Reference = 'AC', Sample = 'C'
MNP   | Multiple-nucleotide polymorphism | Reference = 'ATA', Sample = 'GTC'
MIXED | Multiple-nucleotide and an InDel | Reference = 'ATA', Sample = 'GTCAGT'

This is not a comprehensive list, it is just to give you an idea.

**Annotations**

So, you have a huge file describing all the differences between your sample and the reference genome.
But you want to know more about these variants than just their genetic coordinates.
E.g.: Are they in a gene? In an exon? Do they change protein coding? Do they cause premature stop codons?

SnpEff can help you answer all these questions.
The process of adding this information about the variants is called "Annotation".

SnpEff provides several degrees of annotations, from simple (e.g. which gene is each variant affecting) to extremely complex annotations
(e.g. will this non-coding variant affect the expression of a gene?).
It should be noted that the more complex the annotations, the more it relies in computational predictions.
Such computational predictions can be incorrect, so results from SnpEff (or any prediction algorithm) cannot be trusted blindly,
they must be analyzed and independently validated by corresponding wet-lab experiments.

### Citing

If you are using SnpEff or SnpSift, please cite our work as shown [here](../index.md#citing-snpeff). Thank you!

### SnpEff Features

The following table shows the main SnpEff features:

Feature                  | Comment
------------------------ | ----------------------
Local install            | SnpEff can be installed in your local computer or servers. <br> Local installations are preferred for processing genomic data. <br> As opposed to remote web-based services, running a program locally has many advantages: <ul><li> There no need to upload huge genomic dataset. </li><li> Processing doesn't depend on availability or processing capacity of remote servers. </li><li> Service continuity: no need to worry if a remote service will be maintained in the future. </li><li> Security and confidentiality issues of uploading data to third party servers are not a problem. </li><li> Avoid legal problems of processing clinical data on "outside" servers. </li></ul>
Multi platform           | SnpEff is written in Java. It runs on Unix / Linux, OS.X and Windows.
Simple installation      | Installation is as simple as downloading a ZIP file and double clicking on it.
Genomes                  | Human genome, as well as all model organisms are supported. <br>Over 2,500 genomes are supported, which includes most mammalian, plant, bacterial and fungal genomes with published genomic data.
Speed                    | SnpEff is really fast. It can annotate up to 1,000,000 variants per minute.
GATK&Galaxy integration  | SnpEff can be easily integrated with [GATK](http://www.broadinstitute.org/gatk/) and [Galaxy](http://galaxyproject.org/) pipelines.
GUI                      | Web based user interface via Galaxy project
Input and Output formats | SnpEff accepts input files in the following format:<ul><li> `VCF` format, which is the de-facto standard for sequencing variants.</li><li>`BED` format: To annotate enrichment experiments (e.g. ChIP-Seq peaks) or other genomic data.</li></ul>
Variants supported       | SnpEff can annotate SNPs, MNPs, insertions and deletions. Support for mixed variants and structural variants is available (although sometimes limited).
Effect supported         | Many effects are calculated: such as SYNONYMOUS_CODING, NON_SYNONYMOUS_CODING, FRAME_SHIFT, STOP_GAINED just to name a few.
Variant impact           | SnpEff provides a simple assessment of the putative impact of the variant (e.g. HIGH, MODERATE or LOW impact).
Cancer tissue analysis   | Somatic vs Germline mutations can be calculated on the fly. This is very useful for the cancer researcher community.
Loss of Function (LOF) assessment       | SnpEff can estimate if a variant is deemed to have a loss of function on the protein.
Nonsense mediate decay (NMD) assessment | Some mutations may cause mRNA to be degraded thus not translated into a protein. <br>NMD analysis marks mutations that are estimated to trigger nonsense mediated decay.
HGVS notation            | SnpEff can provide output in HGVS notation, which is quite popular in clinical and translation research environments.
User annotations         | A user can provide custom annotations (by means of BED files).
Public databases         | SnpEff can annotate using publicly available data from well known databases, for instance:<ul><li>**ENCODE** datasets are supported by SnpEff (by means of BigWig files provided by ENCODE project).</li><li>**Epigenome Roadmap** provides data-sets that can be used with SnpEff.</li><li>**TFBS** Transcription factor binding site predictions can be annotated. Motif data used in this annotations is generates by `Jaspar` and `ENSEBML` projects</li><li>**NextProt** database can be used to annotate protein domains as well as important functional sites in a protein (e.g. phosphorilation site)</li></ul>
Common variants (dbSnp)  | Annotating "common" variants from **dbSnp** and **1,000 Genomes** can be easily done (see `SnpSift annotate`).
Gwas catalog             | Support for GWAS catalog annotations (see `SnpSift gwasCat`)
Conservation scores      | PhastCons conservation score annotations support (see `SnpSift phastCons`)
DbNsfp                   | A comprehensive database providing many annotations and scores, such as: `SIFT`, `Polyphen2` ,`GERP++`, `PhyloP`, `MutationTaster`, `SiPhy`, `Interpro`, `Haploinsufficiency`, etc. (via SnpSift).<br>See `SnpSift dbnsfp` for details.
Non-coding annotations   | Regulatory and non-coding annotations are supported for different tissues and cell lines. Annotations supported include PolII,H3K27ac, H3K4me2, H3K4me3, H3K27me3, CTCF, H3K36me3, just to name a few.
Gene Sets annotations    | Gene sets (MSigDb, GO, BioCarta, KEGG, Reactome, etc.) can be used to annotate via `SnpSift geneSets` command.


###  Databases

In order to produce the annotations, SnpEff requires a database.
We build these databases using information from trusted resources.

!!! info
    By default SnpEff downloads and installs databases automatically (since version 4.0)

Currently, there are pre-built database for over 20,000 reference genomes.
This means that most cases are covered.

In some very rare occasions, people need to build a database for an organism not currently supported (e.g. the genome is not publicly available).
In most cases, this can be done and there is a [section](build_db.md) of this manual teaching how to build your own SnpEff database.

Which databases are supported? You can find out all the supported databases by running the `databases` command:

```
java -jar snpEff.jar databases | less
```

This command shows the database name, genome name and source data (where was the genome reference data obtained from).
Keep in mind that many times I use ENSEMBL reference genomes, so the name would be `GRCh37` instead of `hg19`, or `GRCm38` instead
of `mm10`, and so on.

**Example: Finding a database:** So, let's say you want to find out the name of the latest mouse (Mus.Musculus) database.
You can runs something like this:

```
java -jar snpEff.jar databases | grep -i musculus

129S1_SvImJ_v1.99                                           	Mus_musculus_129s1svimj                                     	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_129S1_SvImJ_v1.99.zip
AKR_J_v1.99                                                 	Mus_musculus_akrj                                           	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_AKR_J_v1.99.zip
A_J_v1.99                                                   	Mus_musculus_aj                                             	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_A_J_v1.99.zip
BALB_cJ_v1.99                                               	Mus_musculus_balbcj                                         	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_BALB_cJ_v1.99.zip
C3H_HeJ_v1.99                                               	Mus_musculus_c3hhej                                         	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_C3H_HeJ_v1.99.zip
C57BL_6NJ_v1.99                                             	Mus_musculus_c57bl6nj                                       	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_C57BL_6NJ_v1.99.zip
CAST_EiJ_v1.99                                              	Mus_musculus_casteij                                        	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_CAST_EiJ_v1.99.zip
CBA_J_v1.99                                                 	Mus_musculus_cbaj                                           	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_CBA_J_v1.99.zip
DBA_2J_v1.99                                                	Mus_musculus_dba2j                                          	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_DBA_2J_v1.99.zip
FVB_NJ_v1.99                                                	Mus_musculus_fvbnj                                          	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_FVB_NJ_v1.99.zip
GRCm38.75                                                   	Mus_musculus                                                	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.75.zip
GRCm38.99                                                   	Mus_musculus                                                	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.99.zip
LP_J_v1.99                                                  	Mus_musculus_lpj                                            	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_LP_J_v1.99.zip
NOD_ShiLtJ_v1.99                                            	Mus_musculus_nodshiltj                                      	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_NOD_ShiLtJ_v1.99.zip
NZO_HlLtJ_v1.99                                             	Mus_musculus_nzohlltj                                       	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_NZO_HlLtJ_v1.99.zip
PWK_PhJ_v1.99                                               	Mus_musculus_pwkphj                                         	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_PWK_PhJ_v1.99.zip
WSB_EiJ_v1.99                                               	Mus_musculus_wsbeij                                         	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_WSB_EiJ_v1.99.zip
testMm37.61                                                 	Mus_musculus                                                	          	                              	https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_testMm37.61.zip
```

At the time of writing this, you have 10 options (obviously this will change in the future).
Some are databases are GRCm version 37 (i.e. mm9) and some are version 38 (i.e. mm10).
Since it is generally better to use the latest release, you should probably pick `GRCm38.74`.
Again, this is an example of the version numbers at the time of writing this paragraph, in the future there will be other releases and you
should update to the corresponding version.

**Unsupported reference genomes:** If your reference genome of interest is not supported yet (i.e. there is no database available),
you can build a database yourself (see [Building databases](build_db.md)).
If you have problems adding you own organism, send the issue to SnpEff repository and I'll do my best to help you out.

# SnpSift Annotate

Annotate using fields from another VCF file (e.g. dbSnp, 1000 Genomes projects, ClinVar, ExAC, etc.).

### Typical usage

This is typically used to annotate IDs and INFO fields from a 'database' VCF file (e.g. dbSnp).
Here is an example:

    java -jar SnpSift.jar annotate dbSnp132.vcf variants.vcf > variants_annotated.vcf

Important: `SnpSift annotate` command has different strategies depending on the input VCF file:

* **Uncomressed VCF** If the file is not compressed, it created an index in memory to optimize search. This assumes that both the database and the input VCF files are sorted by position, since it is required by the VCF standard (chromosome sort order can differ between files).
* **Compressed, Tabix indexed** It uses the tabix index to speed up annotations.
* **Compressed, NOT Tabix indexed** It loads the entire 'database' VCF file into memory, which may be slow or even impractical for large 'database' VCF files.  This allows to annotate using unsorted VCF files.

Note:

* By default it adds ALL database INFO fields.
* You can use the `-info` command line option if you only want select only a subset of fields from db.vcf file.
* You can use the `-id` command line option if you only want to add ID fields (no INFO fields will be added).
* Using the `-exists` command line option, you can annotate entries that exists in the 'database' file.

!!! info
    DbSnp in VCF format can be downloaded [here](ftp://ftp.ncbi.nih.gov/snp/organisms/human_9606/VCF/00-All.vcf.gz) (GRCh38 coordinates).
    For other versions, check [this link](ftp://ftp.ncbi.nih.gov/snp/organisms/).

### Example 1: Annotating `ID` from dbSnp

```
$ cat test.chr22.vcf
#CHROM  POS         ID           REF  ALT  QUAL   FILTER  INFO
22      16157571    .            T    G    0.0    FAIL    NS=53
22      16346045    .            T    C    0.0    FAIL    NS=244
22      16350245    .            C    A    0.0    FAIL    NS=192
22      17054103    .            G    A    0.0    PASS    NS=404
22      17071906    .            A    T    0.0    PASS    NS=464
22      17072347    .            C    T    0.0    PASS    NS=464
22      17072394    .            C    G    0.0    PASS    NS=463
22      17072411    .            G    T    0.0    PASS    NS=464

$ java -jar SnpSift.jar annotate -id db/dbSnp/dbSnp137.20120616.vcf test.chr22.vcf
#CHROM  POS         ID           REF  ALT  QUAL   FILTER  INFO
22      16157571    .            T    G    0.0    FAIL    NS=53
22      16346045    rs56234788   T    C    0.0    FAIL    NS=244
22      16350245    rs2905295    C    A    0.0    FAIL    NS=192
22      17054103    rs4008588    G    A    0.0    PASS    NS=404
22      17071906    .            A    T    0.0    PASS    NS=464
22      17072347    rs139948519  C    T    0.0    PASS    NS=464
22      17072394    .            C    G    0.0    PASS    NS=463
22      17072411    rs41277596   G    T    0.0    PASS    NS=464
```

### Example 2: Annotating `ID` and all `INFO` fields from dbSnp
(VCF headers not shown for brevity):
```
$ cat test.chr22.vcf
#CHROM  POS         ID           REF  ALT  QUAL   FILTER  INFO
22      16157571    .            T    G    0.0    FAIL    NS=53
22      16346045    .            T    C    0.0    FAIL    NS=244
22      16350245    .            C    A    0.0    FAIL    NS=192
22      17054103    .            G    A    0.0    PASS    NS=404
22      17071906    .            A    T    0.0    PASS    NS=464
22      17072347    .            C    T    0.0    PASS    NS=464
22      17072394    .            C    G    0.0    PASS    NS=463
22      17072411    .            G    T    0.0    PASS    NS=464

$ java -jar SnpSift.jar annotate db/dbSnp/dbSnp137.20120616.vcf test.chr22.vcf
#CHROM  POS         ID           REF  ALT  QUAL   FILTER  INFO
22      16157571    .            T    G    0.0    FAIL    NS=53
22      16346045    rs56234788   T    C    0.0    FAIL    NS=244;RSPOS=16346045;GMAF=0.162248628884826;dbSNPBuildID=129;SSR=0;SAO=0;VP=050100000000000100000100;WGT=0;VC=SNV;SLO;GNO
22      16350245    rs2905295    C    A    0.0    FAIL    NS=192;RSPOS=16350245;GMAF=0.230804387568556;dbSNPBuildID=101;SSR=1;SAO=0;VP=050000000000000100000140;WGT=0;VC=SNV;GNO
22      17054103    rs4008588    G    A    0.0    PASS    NS=404;RSPOS=17054103;GMAF=0.123400365630713;dbSNPBuildID=108;SSR=0;SAO=0;VP=050100000000070010000100;WGT=0;VC=SNV;SLO;VLD;G5A;G5;KGPilot123
22      17071906    .            A    T    0.0    PASS    NS=464
22      17072347    rs139948519  C    T    0.0    PASS    NS=464;RSPOS=17072347;dbSNPBuildID=134;SSR=0;SAO=0;VP=050200000004040010000100;WGT=0;VC=SNV;S3D;ASP;VLD;KGPilot123
22      17072394    .            C    G    0.0    PASS    NS=463
22      17072411    rs41277596   G    T    0.0    PASS    NS=464;RSPOS=17072411;GMAF=0.00411334552102377;dbSNPBuildID=127;SSR=0;SAO=0;VP=050200000008040010000100;GENEINFO=CCT8L2:150160;WGT=0;VC=SNV;S3D;CFL;VLD;KGPilot123
```

# SnpEff&SnpSift

Genomic variant annotations and functional effect prediction toolbox.

[Download SnpEff](https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip){: .button}

Important: This version implements the [VCF annotation standard 'ANN' field](adds/VCFannotationformat_v1.0.pdf).

Latest version 4.3T (2017-11-24)

Requires Java 1.8


## [ClinEff](http://www.dnaminer.com/)

[Professional version](http://www.dnaminer.com/) of SnpEff & SnpSift suites. [ClinEff](http://www.dnaminer.com/) is considered more stable thus suitable for Clinical and Production operations, whereas SnpEff/SnpSfit is designed for Research and Academic usage.

Features:

* Compliance support (CLIA and CAP)
* Long Term Support
* Prioritized bug fixes and feature development
* Customized databases and annotation pipelines
* Integration with open, private and proprietary databases
* Privacy: Tickets, issues, pipeline-specific analysis


## SnpEff

Genetic variant annotation and functional effect prediction toolbox. It annotates and predicts the effects of genetic variants on genes and proteins (such as amino acid changes).

Features:

* Supports over **38,000 genomes**.
* Standard **ANN** annotation format
* **Cancer** variants analysis
* **GATK** compatible (`-o gatk`)
* **HGVS** notation
* **Sequence Ontology** standardized terms


##  SnpSift

SnpSift annotates genomic variants using databases, filters, and manipulates genomic annotated variants.

Once you annotated your files using SnpEff, you can use SnpSift to help you filter large genomic datasets in order to find the most significant variants for your experiment.

[View details](ss_introduction.md){: .button}

##  Version 4.3

Features:

* Significant improvements in translocations annotations
* Improvements in large structural variant annotations
* Protein-Protein interaction loci annotations (from PDB)

[View details](features.md){: .button}

## Paper & Citing

If you are using SnpEff or SnpSift in an research or academic environment, please cite our [papers](adds/SnpEff_paper.pdf).

[View details](citing.md){: .button}

## Who uses SnpEff?

Users of SnpEff include most major research an academic institutions, as well as pharmaceutical companies and clinical sequencing projects.

[View details](users_of_snpeff.md){: .button}

## Galaxy & GATK

SnpEff is integrated with other tools commonly used in sequencing data analysis pipelines.

Most notably [Galaxy](http://galaxyproject.org/) and [GATK](http://www.broadinstitute.org/gatk/) projects support SnpEff.

[View details](se_integration.md){: .button}

##  In memory of Dr. Xiangyi Lu: [Please donate](xiangyi_lu_donate.md)
![](images/xiangy_small.jpg){: .right}
On October 22, 2017, Xiangyi Lu, a co-author on the SnpEff and SnpSift papers, died of ovarian cancer after a three year struggle.
Douglas Ruden, Xiangyi's husband and senior author on the papers, has requested that a non-mandatory gift of at least $10 for using
SnpEff or SnpSift be donated to WSU to honor Xiangyi Lu. All gifts will go to a newly named fund, the "Xiangyi Lu Graduate Student Fellowship in Bioinformatics Fund."
with the goal of raising $1 million, in order to permanently endow one graduate student research position in bioinformatics every year.

# About

## About

This project is maintained by [**Pablo Cingolani**](http://www.linkedin.com/in/pablocingolani)

## Acknowledgements

Acknowledgements and special thanks to (in order of appearance):

* Adrian Platts (McGill): tons of feedback, feature suggestions, test cases, etc.
* Doug Ruden (WSU): feedback, features request, debugging.
* Louis Letourneau (McGill / Genome Quebec): bug fixes, features suggestions, etc.
* Dave OConnor (UW-Madison): feature suggestions, HIV genome.
* Denis Reshetov (Rogaev lab): VCF output support and debugging on GTF parsing.
* Louis Letourneau (McGill / Genome Quebec): Maven project.
* Mark DePristo, Eric Banks &amp; David Rozen (Broad): VCF parsing and VCF output.
* Jonathan Fresnedo (University of California, Davis): P.Persica genome support.
* **GATK:** integration was performed by Broad's Genome Analysis Team: David Rozen, Eric Banks and Mark DePristo
* Arno Velds (NKI: Netherlands Cancer Institute): Annomalities in ENSEMBL annotation files that led to '-onlyCoding = auto' development, as well as "rogue transcript filters".
* Giulio Genovese: ENSEMBL annotation problems, fixing and improving "rogue transcript" problem.
* Louis Letourneau (McGill / Genome Quebec): dbNSFP implementation
* Peter Briggs (Manchester University) : Improved Galaxy interface and wrappers.
* Jim Johnson (Minnesota Supercomputing Institute, University of Minnesota): SnpSift improvements and bugfixes.
* Davide Cittaro (Center for Translational Genomics and Bioinformatics, Ospedale San Raffaele): Debugging and beta-testing for both SnpEff & SnpSift. Helped to debug many interoperability, compatibility and format specification issues. <br>
* Louis Letourneau (McGill / Genome Quebec): Cancer effects, HSGV notation, etc.
* Sarmady, Mahdi (Children's hospital of Philadelphia): hg19 using transcript version from UCSC.
* Leipzig, Jeremy &amp; Sarmady, Mahdi (Children's hospital of Philadelphia): HGVS notation
* Jinghua (Frank) Feng  (University of Adelaide) : Losts of feedback, debugging and improvements in SnpSift annotations.
* Andrea Mafficini (University of Verona, Italy) : Support for dbNSFP 2.1
* Jim Johnson (Minnesota Supercomputing Institute, University of Minnesota): SnpSift 'rmFilter' bugfix.
* Brad Chapman (Harvad): HomeBrew (HomeBrew-Science) support and bash wrapper.
* Marco Cusumano-Towner &amp;  Eugene Brevdo (SVBio): Insertions in reverse strand bug report and bugfix.
* Uma Devi (U. Virginia), Karen Eilbeck (U. Utah) &amp; Nicole Marie Ruiz (U. Utah): Sequence Ontology, made right.
* Ryan Calhoun (Apistry): SnpSift annotate, tabix index bug.

## Contact information

<strong>[Pablo Cingolani](http://www.linkedin.com/in/pablocingolani).</strong>

## Downloading SnpEff &amp; SnpSift

SnpEff and SnpSift are bundled together.

> [Download SnpEff](https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip)

> Old versions [here](https://sourceforge.net/projects/snpeff/files/).


### License

SnpEff is open source, released as "MIT".

### System requirements

SnpEff requires that you have Java v1.11 or later installed (any modern operating system has it).

The amount of memory used can vary significantly depending on genome size and data analysis type you are doing.
For large genomes, such as the human genome, you'll probably need at least 4Gb of memory.


## Installing SnpEff

Installing SnpEff is very easy, you just have to uncompress the ZIP file.

**How to install using command line (unix systems)**

It is better if you install SnpEff in `snpEff` directory in your home directory (`$HOME/snpEff` in unix systems).
```
# Go to home dir
cd

# Download latest version
wget https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip

# Unzip file
unzip snpEff_latest_core.zip
```

### Configuration
In most cases you **DO NOT** need to configure anything.

The only configuration file is `snpEff.config`.
Most configuration parameters, are explained in the comments in the same config file, so I won't repeat the explanation here :-)

Usually you do NOT need to change the configuration.
Some peoeple may need to change the location of the databases (`data.dir` parameter).
By default, this parameter points to the `data` directory where you installed the tool (i.e. in unix systems, this is `./data`).
If you want to change this, you can edit the `snpEff.config` file and change the `data_dir` entry:
```
#---
# Databases are stored here
# E.g.: Information for 'hg19' is stored in data_dir/hg19/
#
# You can use tilde ('~') as first character to refer to your home directory.
# Also, a non-absolute path will be relative to config's file dir
#
#---
data.dir = ./data/
```

## Downloading SnpEff databases

In order to perform annotations, SnpEff automatically downloads and installs genomic database.

!!! info
    By default SnpEff automatically downloads and installs the database for you, so you don't need to do it manually.

Databases can be downloaded in three different ways:

* The easiest way is to let SnpEff download and install databases automatically
* You can pre-install databases manually using the `SnpEff download` command (once SnpEff is installed).
      E.g. to download the human genome database:

         java -jar snpEff.jar download GRCh38.76

      Note: Current human genome version at the time of writing is GRCh38.76.

## Available databases
There are over 20,000 databases available.

A list of databases is available in snpEff.config file.
You can also see all available databases by running the following command (once SnpEff has been installed):

    java -jar snpEff.jar databases

## Source code

### Getting the source
The source code is in GitHub (although we keep the binary distribution is at SourceForge).
Here is the `git` command to check out the development version of the code:

```
# Get SnpEff
git clone https://github.com/pcingola/SnpEff.git

# Get SnpSift as well
git clone https://github.com/pcingola/SnpSift.git
```
###  Building from the source
Most libraries should be install using Maven, so you just need to run `mvn` command.

* Java (JDK)
* ANT
* Maven

Some libraries are not available through maven, so you have to install them into via Maven manually (these libraries are in `SnpEff/lib`)
```
# Go to 'lib' dir
cd SnpEff/lib

# Antlr
mvn install:install-file \
    -Dfile=antlr-4.5.1-complete.jar \
    -DgroupId=org.antlr \
    -DartifactId=antlr \
    -Dversion=4.5.1 \
    -Dpackaging=jar

# BioJava core
mvn install:install-file \
    -Dfile=biojava3-core-3.0.7.jar \
    -DgroupId=org.biojava \
    -DartifactId=biojava3-core \
    -Dversion=3.0.7 \
    -Dpackaging=jar

# BioJava structure
mvn install:install-file \
    -Dfile=biojava3-structure-3.0.7.jar \
    -DgroupId=org.biojava \
    -DartifactId=biojava3-structure \
    -Dversion=3.0.7 \
    -Dpackaging=jar
```
Once the libraries are installed, you can use `make.sh` to build the code
```
cd $HOME/snpEff

# Create link to scripts_build directory if it doesn't exist
ln -s $HOME/workspace/SnpEff/scripts_build

# Invoke the build script
./scripts_build/make.sh
```

### Installing test cases
Test cases require special "test cases databases and genome", you can find them here:

```
# Install test databases in SnpEff's development directory (not the soruce code dir!)
cd $HOME/snpEff

# Download databases and genome for test cases
wget https://snpeff.blob.core.windows.net/databases/test_cases.tgz

# Uncompress
tar -xvzf test_cases.tgz

# Go to Eclipse's workspace directory (where the source code is)
cd $HOME/workspace/SnpEff

# Create a link to the 'data' dir, so that we can run test cases within Eclipse
ln -s $HOME/snpEff/data

# Add data dir to 'gitignore'
echo "/data" >> .gitignore
```

# SnpSift filter

SnpSift filter is one of the most useful SnpSift commands.
Using SnpSift filter you can filter VCF files using arbitrary expressions, for instance `"(QUAL > 30) | (exists INDEL) | ( countHet() > 2 )"`. The actual expressions can be quite complex, so it allows for a lot of flexibility.

### Typical usage

Some examples for the impatient:

* I want to filter out samples with quality less than 30:

        cat variants.vcf | java -jar SnpSift.jar filter " ( QUAL >= 30 )" > filtered.vcf

* ...but we also want InDels that have quality 20 or more:

        cat variants.vcf | java -jar SnpSift.jar filter "(( exists INDEL ) & (QUAL >= 20)) | (QUAL >= 30 )" > filtered.vcf

* ...or any homozygous variant present in more than 3 samples:

        cat variants.vcf | java -jar SnpSift.jar filter "(countHom() > 3) | (( exists INDEL ) & (QUAL >= 20)) | (QUAL >= 30 )" > filtered.vcf

* ...or any heterozygous sample with coverage 25 or more:

        cat variants.vcf | java -jar SnpSift.jar filter "((countHet() > 0) && (DP >= 25)) | (countHom() > 3) | (( exists INDEL ) & (QUAL >= 20)) | (QUAL >= 30 )" > filtered.vcf

* I want to keep samples where the genotype for the first sample is homozygous variant and the genotype for the second sample is reference:

        cat variants.vcf | java -jar SnpSift.jar filter "isHom( GEN[0] ) & isVariant( GEN[0] ) & isRef( GEN[1] )" > filtered.vcf

* I want to keep samples where the ID matches a set defined in a file:

        cat variants.vcf | java -jar SnpSift.jar filter --set my_rs.txt "ID in SET[0]" > filtered.vcf

    and the file my_rs.txt has one string per line, e.g.:

        rs58108140
        rs71262674
        rs71262673

You can combine any conditions you want using boolean operators.

### Command line options
```
Usage: java -jar SnpSift.jar filter [options] 'expression' [input.vcf]
Options:
	-a|--addFilter   : Add a string to FILTER VCF field if 'expression' is true. Default: '' (none)
	-e|--exprFile    : Read expression from a file
	-f|--file        : VCF input file. Default: STDIN
	-i|--filterId    : ID for this filter (##FILTER tag in header and FILTER VCF field). Default: 'SnpSift'
	-n|--inverse     : Inverse. Show lines that do not match filter expression
	-p|--pass        : Use 'PASS' field instead of filtering out VCF entries
	-r|--rmFilter    : Remove a string from FILTER VCF field if 'expression' is true (and 'str' is in the field). Default: '' (none)
	-s|--set         : Create a SET using 'file'
	--errMissing     : Error is a field is missing. Default: false
	--format         : SnpEff format version: {2, 3}. Default: Auto
	--galaxy         : Used from Galaxy (expressions have been sanitized).
```

### Variables

All VCF fields can be used as variables names, as long as they are declared in the VCF header OR they are "standard" VCF fields (as defined by the VCF 4.1 specification).

* **Fields** names: "CHROM, POS, ID, REF, ALT, QUAL or FILTER". Examples:

    * Any variant in chromosome 1:

            "( CHROM = 'chr1' )"

    * Variants between two positions:

            "( POS > 123456 ) & ( POS < 654321 )"

    * Has an ID and it matches the regulat expression 'rs':

            "(exists ID) & ( ID =~ 'rs' )"

    * The reference is 'A':

            "( REF = 'A' )"

    * The alternative is 'T':

            "( ALT = 'T' )"

    * Quality over 30:

            "( QUAL > 30 )"

    * Filter value is either 'PASS' or it is missing:

            "( na FILTER ) | (FILTER = 'PASS')"

* **INFO field** names in the INFO field. E.g. if the info field has "DP=48;AF1=0;..." you can use something like:

        "( DP > 10 ) & ( AF1 = 0 )"

### Multiple valued fields and variables

When variables have multiple values, you can access individual values as if it was an array.

* **Multiple value** info fields (comma separated) can be accessed using an index. E.g. If the INFO field has "CI95=0.04167,0.5417" you can use an expression such as:

        "( CI95[0] > 0.1 ) & (CI95[1] <= 0.3)"

* **Multiple indexes** You may test multiple indexed fields using 'ANY' or 'ALL' as index. In the examples we assume the INFO field has "CI95=0.04167,0.5417"

    **ANY** or **\***: If you use 'ANY' as index, the expression will be true if any field satisfies the expression.

    So, for instance, the following expressions:

        "( CI95[ANY] > 0.1 )"
    or:

        "( CI95[*] > 0.1 )"

    are equivalent to (in this case, there are only two values in the array):

        "( CI95[0] > 0.1 ) | ( CI95[1] > 0.1 )"

    **ALL** or **?**: If you use 'ALL' as index, the expression will be true if all field satisfy the expression.

    So, for instance, the following expressions:

        "( CI95[ALL] > 0.1 )"
        "( CI95[?] > 0.1 )"

    are equivalent to (in this case, there are only two values in the array):

        "( CI95[0] > 0.1 ) & ( CI95[1] > 0.1 )"


### Genotype fields

Vcf genotype fields can be accessed individually using array notation.

* **Genotype fields** are accessed using an index (sample number) followed by a variable name. E.g. If the genotypes are `GT:PL:GQ    1/1:255,66,0:63    0/1:245,0,255:99`
    You can write something like:

        "( GEN[0].GQ > 60 ) & ( GEN[1].GQ > 90 )"

    You may use an asterisk to represent 'ANY' field:

        "( GEN[*].GQ > 60 )"

* **Genotype multiple fields** are accessed using an index (sample number) followed by a variable name and then another index. E.g. If the genotypes are `GT:PL:GQ    1/1:255,66,0:63    0/1:245,0,255:99`
    You can write something like:

        "( GEN[0].PL[2] = 0 )"
    You may use an asterisk to represent 'ANY' field:

        "( GEN[0].PL[*] = 0 )"
    ...or even:

        "( GEN[*].PL[*] = 0 )"

!!! info
    You can create an expression using sample names instead of genotype numbers.
    E.g.

        $ java -jar SnpSift.jar filter "( GEN[HG00096].DS > 0.2 ) & ( GEN[HG00097].DS > 0.5 )" examples/1kg.head_chr1.vcf.gz


### Sets

Sets are defined by the '-s' (or '--set') command line option. Each file must have one string per line.
They are named based on the order used in the command line (e.g. the first one is `SET[0]`, the second one is `SET[1]`, etc.)

Example: You can write something like (assuming your command line was "-s set1.txt -s set2.txt -s set3.txt"):

    "( ID in SET[2] )"

### SnpEff 'ANN' fields

SnpEff annotations are parsed, so you can access individual sub-fields:

Effect fields (from SnpEff) are accessed using an index (effect number) followed by a sub-field name.

Available `ANN` sub-fields are (for details, take a look at the [specification](../adds/VCFannotationformat_v1.0.pdf)):

* `ALLELE` (alias GENOTYPE)
* `EFFECT` (alias ANNOTATION): Effect in Sequence ontology terms (e.g. 'missense_variant', 'synonymous_variant', 'stop_gained', etc.)
* `IMPACT`: { HIGH, MODERATE, LOW, MODIFIER }
* `GENE`: Gene name (e.g. 'PSD3')
* `GENEID`: Gene ID
* `FEATURE`
* `FEATUREID` (alias TRID: Transcript ID)
* `BIOTYPE`: Biotype, as described by the annotations (e.g. 'protein_coding')
* `RANK`: Exon or Intron rank (i.e. exon number in a transcript)
* `HGVS_C` (alias HGVS_DNA, CODON): Variant in HGVS (DNA) notation
* `HGVS_P` (alias HGVS, HGVS_PROT, AA): Variant in HGVS (protein) notation
* `CDNA_POS` (alias POS_CDNA)
* `CDNA_LEN` (alias LEN_CDNA)
* `CDS_POS` (alias POS_CDS)
* `CDS_LEN` (alias LEN_CDS)
* `AA_POS` (alias POS_AA)
* `AA_LEN` (alias LEN_AA)
* `DISTANCE`
* `ERRORS` (alias WARNING, INFOS)

For example, you may want only the lines where the **first** annotation has `missense_variant` variant:

**Important** According to the specification, there can be more than one EFFECT separated by &amp; (e.g. 'missense_variant&amp;splice_region_variant', thus using `has` operator is better than using equality operator (`=`).
For instance `'missense_variant&splice_region_variant' = 'missense_variant'` is false, whereas  `'missense_variant&splice_region_variant' has 'missense_variant'` is true.

```
$ java -jar SnpSift.jar filter "ANN[0].EFFECT has 'missense_variant'" examples/test.chr22.ann.vcf > test.chr22.ann.filter_missense_first.vcf

# Output example (edited for readability)
$ cat test.chr22.ann.filter_missense_first.vcf
22    17072035    .    C    T    .    .    ANN=T|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.1406G>A|p.Gly469Glu|1666/2034|1406/1674|469/557||,T|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>A|||||3944|
22    17072258    .    C    A    .    .    ANN=A|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.1183G>T|p.Gly395Cys|1443/2034|1183/1674|395/557||,A|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>T|||||3721|
22    17072674    .    G    A    .    .    ANN=A|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.767C>T|p.Pro256Leu|1027/2034|767/1674|256/557||,A|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397C>T|||||3305|
22    17072747    .    T    C    .    .    ANN=C|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.694A>G|p.Met232Val|954/2034|694/1674|232/557||,C|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397A>G|||||3232|
22    17073043    .    C    T    .    .    ANN=T|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.398G>A|p.Arg133Gln|658/2034|398/1674|133/557||,T|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>A|||||2936|
22    17073119    .    C    T    .    .    ANN=T|missense_variant|MODERATE|CCT8L2|ENSG00000198445|transcript|ENST00000359963|protein_coding|1/1|c.322G>A|p.Val108Met|582/2034|322/1674|108/557||,T|downstream_gene_variant|MODIFIER|FABP5P11|ENSG00000240122|transcript|ENST00000430910|processed_pseudogene||n.*397G>A|||||2860|
```

...but this probably doesn't make much sense. What you may really want are lines where **ANY** effect to be `missense_variant`:
```
$ java -jar SnpSift.jar filter "ANN[*].EFFECT has 'missense_variant'" examples/test.chr22.ann.vcf > test.chr22.ann.filter_missense_any.vcf

# Output example (edited for readability)
$ cat test.chr22.ann.filter_missense_any.vcf
...
22    24891462    .    G    A    .    .    ANN=A|stop_gained|HIGH|UPB1|ENSG00000100024|transcript|ENST00000413389|protein_coding|2/10|c.59G>A|p.Trp20*|1652/3418|59/951|20/316||
                                              ,A|missense_variant|MODERATE|UPB1|ENSG00000100024|transcript|ENST00000326010|protein_coding|1/10|c.91G>A|p.Gly31Ser|435/2290|91/1155|31/384||
                                              ,A|missense_variant|MODERATE|UPB1|ENSG00000100024|transcript|ENST00000382760|protein_coding|1/4|c.91G>A|p.Gly31Ser|253/1928|91/561|31/186||

22    24896158    .    A    T    .    .    ANN=T|missense_variant|MODERATE|UPB1|ENSG00000100024|transcript|ENST00000326010|protein_coding|2/10|c.188A>T|p.Glu63Val|532/2290|188/1155|63/384||
                                              ,T|missense_variant|MODERATE|UPB1|ENSG00000100024|transcript|ENST00000382760|protein_coding|2/4|c.188A>T|p.Glu63Val|350/1928|188/561|63/186||
```

May be you want only the ones that affect **gene 'TRMT2A'**:
```
$ java -jar SnpSift.jar filter "(ANN[*].EFFECT has 'missense_variant') && (ANN[*].GENE = 'TRMT2A')" examples/test.chr22.ann.vcf > test.chr22.ann.filter_missense_any_TRMT2A.vcf

$ cat test.chr22.ann.filter_missense_any_TRMT2A.vcf
22    20103915    .    C    T    .    .    ANN=T|stop_gained|HIGH|RANBP1|ENSG00000099901|transcript|ENST00000432879|protein_coding|1/3|c.208C>T|p.Arg70*|455/744|208/497|70/164||WARNING_TRANSCRIPT_INCOMPLETE
                                              ,T|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000439169|protein_coding|2/12|c.245G>A|p.Arg82His|561/2473|245/1932|82/643||
                                              ,T|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000252136|protein_coding|2/12|c.245G>A|p.Arg82His|634/2964|245/1878|82/625||
                                              ,T|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000403707|protein_coding|3/13|c.245G>A|p.Arg82His|607/2928|245/1878|82/625||
                                              ,T|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000404751|protein_coding|2/12|c.245G>A|p.Arg82His|584/2498|245/1689|82/562||
                                              ,T|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000445045|protein_coding|2/2|c.209G>A|p.Arg70His|432/582|209/359|70/118||WARNING_TRANSCRIPT_INCOMPLETE
                                              ,...

22    20103925    .    T    C    .    .    ANN=C|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000439169|protein_coding|2/12|c.235A>G|p.Asn79Asp|551/2473|235/1932|79/643||
                                              ,C|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000252136|protein_coding|2/12|c.235A>G|p.Asn79Asp|624/2964|235/1878|79/625||
                                              ,C|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000403707|protein_coding|3/13|c.235A>G|p.Asn79Asp|597/2928|235/1878|79/625||
                                              ,C|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000404751|protein_coding|2/12|c.235A>G|p.Asn79Asp|574/2498|235/1689|79/562||
                                              ,C|missense_variant|MODERATE|RANBP1|ENSG00000099901|transcript|ENST00000432879|protein_coding|1/3|c.218T>C|p.Phe73Ser|465/744|218/497|73/164||WARNING_TRANSCRIPT_INCOMPLETE
                                              ,C|missense_variant|MODERATE|TRMT2A|ENSG00000099899|transcript|ENST00000445045|protein_coding|2/2|c.199A>G|p.Asn67Asp|422/582|199/359|67/118||WARNING_TRANSCRIPT_INCOMPLETE
                                              ,C|splice_region_variant&intron_variant|LOW|RANBP1|ENSG00000099901|transcript|ENST00000430524|protein_coding|1/5|c.-374+7T>C||||||
                                              ,...
```

### SnpEff 'EFF' fields

!!! warning
    This section documents older SnpEff/SnpSift which used 'EFF' INFO field (as opposed to 'ANN' field) or files annotated using SnpEff's `-classic` or `-formatEff` command line options.

SnpEff annotations are parsed, so you can access individual sub-fields:

Effect fields (from SnpEff) are accessed using an index (effect number) followed by a sub-field name.

Available `EFF` sub-fields are:

* `EFFECT`: Effect (e.g. SYNONYMOUS_CODING, NON_SYNONYMOUS_CODING, FRAME_SHIFT, etc.)
* `IMPACT`: { HIGH, MODERATE, LOW, MODIFIER }
* `FUNCLASS`: { NONE, SILENT, MISSENSE, NONSENSE }
* `CODON`: Codon change (e.g. 'ggT/ggG')
* `AA`: Amino acid change (e.g. 'G156')
* `GENE`: Gene name (e.g. 'PSD3')
* `BIOTYPE`: Gene biotype, as described by the annotations (e.g. 'protein_coding')
* `CODING`: Gene is { CODING, NON_CODING }
* `TRID`: Transcript ID
* `RANK`: Exon or Intron rank (i.e. exon number in a transcript)

For example, you may want only the lines where the first effect is a NON_SYNONYMOUS variants:

    "( EFF[0].EFFECT = 'NON_SYNONYMOUS_CODING' )"

...but this probably doesn't make much sense. What you may really want are lines where ANY effect is NON_SYNONYMOUS:

    "( EFF[*].EFFECT = 'NON_SYNONYMOUS_CODING' )"

May be you want only the ones that affect gene 'TCF7L2':

    "( EFF[*].EFFECT = 'NON_SYNONYMOUS_CODING' ) &  ( EFF[*].GENE = 'TCF7L2' )"

### SnpEff 'LOF' and 'NMD' fields

Similarly `LOF` and `NMD` sub-fields are available:

* `LOF.GENE` and NMD.GENE
* `LOF.GENEID` and NMD.GENEID
* `LOF.NUMTR` and NMD.NUMTR
* `LOF.PERC` and NMD.PERC

For instance, if we want to obtain genes having a Loss of Function effect in more than 90% of the transcripts, you can do this:

    $cat test.snpeff.vcf | java -Xmx1G -jar SnpSift.jar filter "(exists LOF[*].PERC) & (LOF[*].PERC > 0.9)"


!!! warning
    We assume that 'test.snpeff.vcf' was annotated with SnpEff using '-lof' command line option.


### Available operands and functions

The following operators and functions are interpreted by `SnpSift filter`:

Operand | Description   | Data type            | Example
------- | ------------- | -------------------- | --------------
 =      | Equality test                     | FLOAT, INT or STRING | (REF **=** 'A')
 &gt;   | Greater than                      | FLOAT or INT         | (DP **&gt;** 20)
 &ge;   | Greater or equal than             | FLOAT or INT | (DP **&ge;** 20)
 &lt;   | Less than                         | FLOAT or INT | (DP **&lt;** 20)
 &le;   | Less or equal than                | FLOAT or INT | (DP **&le;** 20)
 =~     | Match regular expression          | STRING  | (REL **=~** 'AC')
 !~     | Does not match regular expression | STRING  | (REL **!~** 'AC')
 &amp;  | AND operator                      | Boolean | (DP &gt; 20) **&amp;** (REF = 'A')
 \|     | OR operator                       | Boolean | (DP &gt; 20) **\|** (REF = 'A')
 !      | NOT operator                      | Boolean | **!** (DP &gt; 20)
 exists | The variable exists (not missing) | Any     | (**exists** INDEL)
 has    | The right hand side expression is equalt to any of the items in a list consisting of separating the left hand side expression using delimiters: `&`, `+`, `;`, `,`, `:`, `(', ')` ,`[', ']`. <br> Example: If the expression is: ANN\[\*].EFFECT **has** 'missense_variant'.<br> If left hand side (ANN\[\*].EFFECT) has value 'missense_variant&splice_region_variant', then it is transformed to a list: `['missense_variant', 'splice_region_variant']`<br> Since the right hand side ('missense_variant') is in the list, the expression evaluates to 'true' | Any | (ANN\[\*].EFFECT **has** 'missense_variant')

Function   | Description | Data type | Example
---------- | ----------- | --------- | --------
`countHom()` | Count number of homozygous genotypes   | No arguments | (**countHom()** &gt; 0)
`countHet()` | Count number of heterozygous genotypes | No arguments | (**countHet()** &gt; 2)
`countVariant()` | Count number of genotypes that are variants (i.e. not reference 0/0) | No arguments | (**countVariant()** &gt; 5)
`countRef()`     | Count number of genotypes that are NOT variants (i.e. reference 0/0) | No arguments | (**countRef()** &lt; 1)

Genotype <br> Function | Description | Data type | Example
---------------------- | ----------- | --------- | --------
`isHom`     | Is homozygous genotype?   | Genotype | **isHom( GEN\[0] )**
`isHet`     | Is heterozygous genotype? | Genotype | **isHet( GEN\[0] )**
`isVariant` | Is genotype a variant? (i.e. not reference 0/0) | Genotype | **isVariant( GEN\[0] )**
`isRef`     | Is genotype a reference? (i.e. 0/0)             | Genotype | **isRef( GEN\[0] )**

### Using sample names instead of sample numbers

As of version 4.1A, SnpSift allows to use sample names instead of sample numbers.
This allows to create more readable expressions.

Example:

```
$ cat cancer.vcf | java -jar SnpSift.jar filter "GEN[Somatic].GT = '2/1'"
#CHROM  POS    ID   REF  ALT    QUAL  FILTER    INFO    FORMAT    Germline    Somatic
1       69091  .    A    C,G    .     PASS      AC=1    GT        1/0         2/1
```

Note that we used `GEN[Somatic]` instead of `GEN[1]`.

# Usage examples

## Materials

In this protocol we show how to analyze genomic variants using the SnpEff pipeline.

**Computer hardware:** The materials required for this protocol are:

* a computer running a Unix operating system (Linux, OS.X),
* at least 16GB of RAM
* at least 8Gb of free disk space,
* Java
* a reasonably fast internet connection

Users of Windows computers can install CygWin, a free Linux-like environment for Windows, although the precise commands listed in the protocol may need to adapted.

**Software:** We use the SnpEff annotation program and its companion tool SnpSift. These programs can perform annotation, primary impact assessment and variants filtering,
as well as many other tasks beyond the scope of this protocol.
We highly recommend reading their comprehensive documentation available [here](adds/VCFannotationformat_v1.0.pdf).

Before starting the protocol, it is necessary to download and install SnpEff. To do this, open a Unix, Linux or Cygwin shell and execute the following commands:
```
# Move to home directory
cd

# Download and install SnpEff
curl -v -L 'https://snpeff.blob.core.windows.net/versions/snpEff_latest_core.zip' > snpEff_latest_core.zip
unzip snpEff_latest_core.zip
```

**Notes:**

* SnpEff & SnpSift annotation software used in this protocol are under very active development and some command line option may change in the future.
* The standard installation is to add the package in the "$HOME/snpEff" directory (where $HOME is your home directory). To install SnpEff elsewhere, update the "data_dir" parameter in your "snpEff.config" file, as described in the SnpEff documentation.

Once SnpEff is installed, we will enter the following commands to download the pre-built human database (GRCh37.75) that will be used to annotate our data.
```
cd snpEff
java -jar snpEff.jar download -v GRCh37.75
```

A list of pre-built databases for all other species is available by running the following command:

    java -jar snpEff.jar databases

##  Example 1: Coding variants

We show how to use SnpEff & SnpSift to annotate, prioritize and filter coding variants.

**Dataset:** In this genomic annotation example, we use a simulated dataset to show how to find genetic variants of a Mendelian recessive disease, Cystic fibrosis, caused by a high impact coding variant, a nonsense mutation in CFTR gene (G542*).  
The data files come from the publicly available "CEPH_1463" dataset, sequenced by [Complete Genomics](http://www.completegenomics.com/public-data/), and contains sequencing information for a family consisting of 4 grandparents, 2 parents and 11 siblings.

![figure2](images/Cingolani_Figure2.png){: .center}

Although these are healthy individuals, we artificially introduced a known Cystic fibrosis mutation on three siblings (cases) in a manner that was consistent with the underlying haplotype structure.

We now download and un-compress the example data used in this protocol, which, for reasons of space and time, is limited to only chromosome 7 and 17:
```
# Go to SnpEff's dir
cd ~/snpEff

# Download sample data
curl -v -L `https://datasetsnpeff.blob.core.windows.net/dataset/protocols.zip?sv=2019-10-10&st=2020-09-01T00%3A00%3A00Z&se=2050-09-01T00%3A00%3A00Z&si=prod&sr=c&sig=isafOa9tGnYBAvsXFUMDGMTbsG2z%2FShaihzp7JE5dHw%3D` > protocols.zip
unzip protocols.zip
```

The goal in this example is to use SnpEff to find a mutation causing a Mendelian recessive trait. This will be done using a dataset of variant calls for chromosome 7 from a pedigree of 17 healthy individuals, sequenced by Complete Genomics, in which a coding variant causing cystic fibrosis was artificially introduced in three siblings (see Materials). For the purpose of this example, we assume that we do not know the causative variant, but that we know that we are dealing with a Mendelian recessive disorder, where the three siblings are affected (cases), but the 14 parents and grandparents are not (controls).

Genomic variants are usually provided in a VCF file containing variant information of all the samples; storing the variant data in a single VCF file is the standard practice, not only because variant calling algorithms have better accuracy when run on all samples simultaneously, but also because it is much easier to annotate, manipulate and compare individuals when the data is stored and transferred together.
A caveat of this approach is that VCF files can become very large when performing experiments with thousands of samples (from several Gigabytes to Terabytes in size).

In the following protocol, SnpEff will add annotation fields to each variant record in the input VCF file.
We will then use SnpSift, a filtering program to extract the most significant variants having annotations meeting certain criteria.

### Step 1: Primary variant annotation and quality control.

Our first step is to annotate each of the ~500,000 variants contained in the VCF file.
By default, SnpEff adds primary annotations and basic impact assessment for coding and non-coding variants as described above.
SnpEff has several command line options that can be used in this annotation stage and which are described in detail in the [online manual](snpeff/commandline.md).

In this example, we annotate (all these annotations are activated by default when using SnpEff):

* loss of function and nonsense mediated decay predictions;
* protein domain annotations from the curated NextProt database;
* putative transcription factor binding sites from the ENSEMBL 'Regulatory Build' and Jaspar database;
* use HGVS notation for amino acid changes; and
* to create a web page summarizing the annotation results in "ex1.html" (option `-stats`):

        java -Xmx8g -jar snpEff.jar -v -stats ex1.html GRCh37.75 protocols/ex1.vcf > protocols/ex1.ann.vcf

SnpEff produces three output files :

* the HTML file containing summary statistics about the variants and their annotations;
* an annotated VCF file; and
* a text file summarizing the number of variant types per gene.

Creation of the summary files can be de-activated to speed up the program (for example, when the application is used together with Galaxy).
By default, the statistics file "ex1.html" is a standard HTML file that can be opened in any web browser to view quality control (QC) metrics.
It can also be created in comma-separated values format (CSV) to be used by downstream processing programs as part of an automated pipeline.
In our example, the summary file contains basic quality control statistics calculated from the variant file: for our data, the Ts/Ts ratio is close to 2.0 (Figure 1c) and missense / silent ratio is around 1.0 (Figure 1d), both of which are expected for human data (but these numbers may differ for other species).

![figure1](images/Cingolani_Figure1.png){: .center}

Large deviations from the expected values for the organism being sequenced might indicate problems with either the sequencing or variant calling pipelines.
The summary file also contains QC information for the gene annotation used as input.
In this example, 829 warnings (Figure 1a) were identified as a result of possible genomic annotation errors or small inconsistencies identified in the reference genome so we have to be careful analyzing those genes/transcripts.
Other summary statistics are available, such as variant types (Figure 1e), variants effects (Figure 1d and 1g), and primary impacts (Figure 1b and 1g).

### Step 2: Counting variants in case and control subjects.

In the first step of our protocol, SnpEff created a VCF file with half million annotated variants.
Rather than scanning each annotation manually, we will use the SnpSift program to create a filter that will identify a small subset of variants with interesting functional properties.
Since the VCF files used in most sequencing studies are even larger than the one in this example, our overall approach is to start by creating a filter using a very restrictive set of criteria.
If no relevant variant is found using this stringent filter, we will relax the criteria to include variants with lower predicted impact.

In our example, since the pedigree is consistent with a Mendelian recessive disease, so we will first use SnpEff to find high impact variants that are homozygous in cases and either absent or heterozygous in controls.
This provides a very strong genetic argument to select the promising variants and will be used as the first step in our filter.
To do this, we will identify the case and control samples by providing SnpEff with pedigree information using a "TFAM" file (a standard file format used to describe pedigrees).
In our example, the TFAM file ("pedigree.tfam") identifies the three cases (NA12879, NA12885, NA12886), and lists the other family members as controls.
The "caseControl" command instructs the SnpSift program to count the number homozygous non-reference, heterozygous and allele count (number of non-reference alleles in each DNA sample) for both cases and controls groups (running time: ~60 minutes):

```
java -Xmx1g -jar SnpSift.jar \
    caseControl \
    -v \
    -tfam protocols/pedigree.tfam \
    protocols/ex1.ann.vcf \
    > protocols/ex1.ann.cc.vcf
```

This analysis creates an output VCF file ("ex1.ann.cc.vcf") by adding new information to the INFO field for each variant: this includes information such as `Cases=1,1,3` and `Controls=8,6,22` which correspond to the number of homozygous non-reference, heterozygous and total allele counts in cases and controls for each variant.
The program also calculates basic statistics for each variant based on the allele frequencies in the two groups using different models, which can be useful as a starting point for more in-depth statistical analysis.

### Step 3: Filtering variants.

We can use the `SnpSift filter` command to reduce the number of candidate loci base on alleles in cases and controls.
SnpSift filter allows users to create powerful filters that select variants using Boolean expressions containing data from the VCF fields.
The expression we use to filter the VCF file "ex1.ann.vcf" is developed as follows.

We expect all the three cases and none of the controls to be homozygous for the mutation.
This is expressed using the following filter: `(Cases[0] = 3) & (Controls[0] = 0)`
The full command line is:

```
cat protocols/ex1.ann.cc.vcf | java -jar SnpSift.jar filter \
    "(Cases[0] = 3) & (Controls[0] = 0)" \
    > protocols/ex1.filtered.hom.vcf
```

The filtered output file, filtered.hom_cases.vcf, contains over 400 variants satisfying our criteria.
This is still too large to analyze by hand, so can we can add another filter to see if any of these variants is expected to have a high impact.
To identify variants where any of these impacts is classified as either `HIGH` or `MODERATE` we add the condition `(ANN[*].IMPACT = 'HIGH') | (ANN[*].IMPACT = 'MODERATE')`.
The new filtering commands become:

```
cat protocols/ex1.ann.cc.vcf \
    | java -jar SnpSift.jar filter \
    "(Cases[0] = 3) & (Controls[0] = 0) & ((ANN[*].IMPACT = 'HIGH') | (ANN[*].IMPACT = 'MODERATE'))" \
    > protocols/ex1.filtered.vcf
```
After filtering, only two variants satisfy our criteria, one of them is a `stop_gained` loss of function variant, whereas the other one is a `missense_variant` amino acid change.
The first one is a known Cystic fibrosis variant.
```
$ cat protocols/ex1.filtered.vcf     | ./scripts/vcfInfoOnePerLine.pl
7   117227832   .   G    T      .    .
                                AC      14
                                AN      22
                                ANN     T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000003084|protein_coding|12/27|c.1624G>T|p.Gly542*|1756/6128|1624/4443|542/1480||
                                ANN     T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000454343|protein_coding|11/26|c.1441G>T|p.Gly481*|1573/5949|1441/4260|481/1419||
                                ANN     T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000426809|protein_coding|11/26|c.1534G>T|p.Gly512*|1534/4316|1534/4316|512/1437||WARNING_TRANSCRIPT_INCOMPLETE
                                ANN     T|sequence_feature|LOW|CFTR|ENSG00000001626|topological_domain:Cytoplasmic|ENST00000003084|protein_coding||c.1624G>T||||||
                                ANN     T|sequence_feature|LOW|CFTR|ENSG00000001626|domain:ABC_transporter_1|ENST00000003084|protein_coding||c.1624G>T||||||
                                ANN     T|sequence_feature|LOW|CFTR|ENSG00000001626|beta_strand|ENST00000003084|protein_coding|12/27|c.1624G>T||||||
                                ANN     T|sequence_feature|LOW|CFTR|ENSG00000001626|beta_strand|ENST00000454343|protein_coding|11/26|c.1441G>T||||||
                                ANN     T|upstream_gene_variant|MODIFIER|AC000111.5|ENSG00000234001|transcript|ENST00000448200|processed_pseudogene||n.-1C>A|||||1362|
                                ANN     T|downstream_gene_variant|MODIFIER|CFTR|ENSG00000001626|transcript|ENST00000472848|processed_transcript||n.*148G>T|||||29|
                                LOF     (CFTR|ENSG00000001626|11|0.27)
                                NMD     (CFTR|ENSG00000001626|11|0.27)
                                Cases   3
                                Cases   0
                                Cases   6
                                Controls        0
                                Controls        8
                                Controls        8
                                CC_TREND        9.111e-04
                                CC_GENO NaN
                                CC_ALL  4.025e-02
                                CC_DOM  6.061e-03
                                CC_REC  1.000e+00

17    39135205   .    ACA       GCA,GCG .       .
                                AC      16
                                AC      8
                                AN      31
                                ANN     GCG|missense_variant|MODERATE|KRT40|ENSG00000204889|transcript|ENST00000377755|protein_coding||c.1045_1047delTGTinsCGC|p.Cys349Arg|1082/1812|1045/1296|349/431||
                                ANN     GCG|missense_variant|MODERATE|KRT40|ENSG00000204889|transcript|ENST00000398486|protein_coding||c.1045_1047delTGTinsCGC|p.Cys349Arg|1208/1772|1045/1296|349/431||
                                ANN     GCA|synonymous_variant|LOW|KRT40|ENSG00000204889|transcript|ENST00000377755|protein_coding|6/7|c.1047T>C|p.Cys349Cys|1082/1812|1047/1296|349/431||
                                ANN     GCA|synonymous_variant|LOW|KRT40|ENSG00000204889|transcript|ENST00000398486|protein_coding|8/9|c.1047T>C|p.Cys349Cys|1208/1772|1047/1296|349/431||
                                ANN     GCA|sequence_feature|LOW|KRT40|ENSG00000204889|region_of_interest:Coil_2|ENST00000398486|protein_coding|6/9|c.1047T>C||||||
                                ANN     GCG|sequence_feature|LOW|KRT40|ENSG00000204889|region_of_interest:Coil_2|ENST00000398486|protein_coding|7/9|c.1045_1047delTGTinsCGC||||||
                                ANN     GCA|sequence_feature|LOW|KRT40|ENSG00000204889|region_of_interest:Rod|ENST00000398486|protein_coding|3/9|c.1047T>C||||||
                                ANN     GCG|sequence_feature|LOW|KRT40|ENSG00000204889|region_of_interest:Rod|ENST00000398486|protein_coding|3/9|c.1045_1047delTGTinsCGC||||||
                                ANN     GCA|3_prime_UTR_variant|MODIFIER|KRT40|ENSG00000204889|transcript|ENST00000461923|nonsense_mediated_decay|8/9|n.*509T>C|||||2348|
                                ANN     GCG|3_prime_UTR_variant|MODIFIER|KRT40|ENSG00000204889|transcript|ENST00000461923|nonsense_mediated_decay|8/9|n.*507_*509delTGTinsCGC|||||2346|
                                ANN     GCA|downstream_gene_variant|MODIFIER|AC004231.2|ENSG00000234477|transcript|ENST00000418393|antisense||n.*815A>G|||||3027|
                                ANN     GCG|downstream_gene_variant|MODIFIER|AC004231.2|ENSG00000234477|transcript|ENST00000418393|antisense||n.*815_*815delACAinsGCG|||||3027|
                                ANN     GCA|non_coding_exon_variant|MODIFIER|KRT40|ENSG00000204889|transcript|ENST00000461923|nonsense_mediated_decay|8/9|n.*509T>C||||||
                                ANN     GCG|non_coding_exon_variant|MODIFIER|KRT40|ENSG00000204889|transcript|ENST00000461923|nonsense_mediated_decay|8/9|n.*507_*509delTGTinsCGC||||||
                                Cases   3
                                Cases   0
                                Cases   6
                                Controls        0
                                Controls        12
                                Controls        18
                                CC_TREND        7.008e-02
                                CC_GENO NaN
                                CC_ALL  1.700e-01
                                CC_DOM  1.231e-01
                                CC_REC  1.000e+00
```
A chart showing how the variant propagates across the pedigree structure can be created as follows:
```
java -jar SnpSift.jar pedShow \
    protocols/pedigree.tfam \
    protocols/ex1.filtered.vcf \
    protocols/chart
```
### Step 4. Using clinical databases.

So far, since the purpose of the example was to show how annotations and filtering are performed to uncover new variants, we assumed that the causative variant was not known.
In reality the variant is known and databases, such as ClinVar, have this information in convenient VCF format that can be used for annotations.

We can annotate using ClinVar by using the following command:
```
java -Xmx1g -jar SnpSift.jar \
    annotate \
    -v \
    protocols/db/clinvar_00-latest.vcf \
    protocols/ex1.ann.cc.vcf \
    > protocols/ex1.ann.cc.clinvar.vcf
```

Our variant of interest is then annotated as "Cystic Fibrosis"  (to find the variant, we filter for variants having ClinVar annotation "CLNDBN" that are in CFTR gene and have a `stop_gained` annotation):
```
$ cat protocols/ex1.ann.cc.clinvar.vcf \
    | java -jar SnpSift.jar filter \
    "(exists CLNDBN) & (ANN[*].EFFECT has 'stop_gained') & (ANN[*].GENE = 'CFTR')" \
    > protocols/ex1.ann.cc.clinvar.filtered.vcf

$ cat protocols/ex1.ann.cc.clinvar.filtered.vcf | ./scripts/vcfInfoOnePerLine.pl
7    117227832    rs113993959      G    T       .    .
                                                AC              14
                                                AN              22
                                                ANN             T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000003084|protein_coding|12/27|c.1624G>T|p.Gly542*|1756/6128|1624/4443|542/1480||
                                                ANN             T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000454343|protein_coding|11/26|c.1441G>T|p.Gly481*|1573/5949|1441/4260|481/1419||
                                                ANN             T|stop_gained|HIGH|CFTR|ENSG00000001626|transcript|ENST00000426809|protein_coding|11/26|c.1534G>T|p.Gly512*|1534/4316|1534/4316|512/1437||WARNING_TRANSCRIPT_INCOMPLETE
                                                ANN             T|sequence_feature|LOW|CFTR|ENSG00000001626|topological_domain:Cytoplasmic|ENST00000003084|protein_coding||c.1624G>T||||||
                                                ANN             T|sequence_feature|LOW|CFTR|ENSG00000001626|domain:ABC_transporter_1|ENST00000003084|protein_coding||c.1624G>T||||||
                                                ANN             T|sequence_feature|LOW|CFTR|ENSG00000001626|beta_strand|ENST00000003084|protein_coding||c.1624G>T||||||
                                                ANN             T|sequence_feature|LOW|CFTR|ENSG00000001626|beta_strand|ENST00000454343|protein_coding||c.1441G>T||||||
                                                ANN             T|upstream_gene_variant|MODIFIER|AC000111.5|ENSG00000234001|transcript|ENST00000448200|processed_pseudogene||n.-1C>A|||||1362|
                                                ANN             T|downstream_gene_variant|MODIFIER|CFTR|ENSG00000001626|transcript|ENST00000472848|processed_transcript||n.*148G>T|||||29|
                                                LOF             (CFTR|ENSG00000001626|11|0.27)
                                                NMD             (CFTR|ENSG00000001626|11|0.27)
                                                Cases           3
                                                Cases           0
                                                Cases           6
                                                Controls        0
                                                Controls        8
                                                Controls        8
                                                CC_TREND        9.111e-04
                                                CC_GENO         NaN
                                                CC_ALL          4.025e-02
                                                CC_DOM          6.061e-03
                                                CC_REC          1.000e+00
                                                ASP             true
                                                CLNACC          RCV000007535.6|RCV000058931.3|RCV000119041.1
                                                CLNALLE         1
                                                CLNDBN          Cystic_fibrosis|not_provided|Hereditary_pancreatitis
                                                CLNDSDB         GeneReviews:MedGen:OMIM:Orphanet:SNOMED_CT|MedGen|GeneReviews:MedGen:OMIM:Orphanet:SNOMED_CT
                                                CLNDSDBID       NBK1250:C0010674:219700:ORPHA586:190905008|CN221809|NBK84399:C0238339:167800:ORPHA676:68072000
                                                CLNHGVS         NC_000007.13:g.117227832G>T
                                                CLNORIGIN       1
                                                CLNREVSTAT      prof|single|single
                                                CLNSIG          5|5|5
                                                CLNSRC          CFTR2|HGMD|OMIM_Allelic_Variant|OMIM_Allelic_Variant
                                                CLNSRCID        G542X|CM900049|602421.0009|602421.0095
                                                GENEINFO        CFTR:1080
                                                LSD             true
                                                NSN             true
                                                OM              true
                                                PM              true
                                                PMC             true
                                                REF             true
                                                RS              113993959
                                                RSPOS           117227832
                                                S3D             true
                                                SAO             1
                                                SSR             0
                                                VC              SNV
                                                VLD             true
                                                VP              0x050268000605040002110100
                                                WGT             1
                                                dbSNPBuildID    132
```

## Example 2: Software Integration (GATK &amp; Galaxy)

Software Integration (Optional): Sequence analysis software is often run in high performance computers combining several programs into processing pipelines.
Annotations and impact assessment software needs to provide integration points with other analysis steps of the pipeline.

In the following paragraphs we describe how to integrate SnpEff with two programs commonly used in sequencing analysis pipelines:

* Genome Analysis toolkit (GATK 2), a command-line driven software;
* Galaxy 3, a web based software.

### GATK

The Genome Analysis Toolkit 2 is one of the most popular programs for bioinformatics pipelines.

Annotations can be easily integrated into GATK using SnpEff and GATK's VariantAnnotator module.
Here we show how to annotate a file using SnpEff and GATK, as an alternative way of performing step 1.
You should perform this step only if your processing pipeline is based on GATK: compared to running SnpEff from the command line, the results obtained when using GATK will only contain the highest impact annotation for each variant.
This was a conscious trade-off made by the designers of GATK, partly because most biologists do this implicitly when reading a list of variants, but also to improve the readability and reduce the size of the annotation results.

The method requires two steps:

1. Annotating a VCF file using SnpEff
2. Using GATK's VariantAnnotator to incorporate those annotations into the final VCF file.

When using SnpEff for GATK compatibility, we must use the `-o gatk` command line option:
```
java -Xmx8g -jar snpEff.jar \
    -v \
    -o gatk \
    GRCh37.75 \
    protocols/ex1.vcf \
    > protocols/ex1.ann.gatk.vcf
```

Next, we process these variants using GATK. For this step to work correctly, we need to make sure that our data files are compatible with the requirements GATK places on reference genomes (see GATK's documentation for more details):

* in the fasta file, chromosomes are expected to be sorted in karyotypic order;
* a genome fasta-index file must be available; and
* a dictionary file must be pre-computed.

Assuming these requirements are satisfied, we can run the following command, which will produce a GATK annotated file ("ex1.gatk.vcf"):
```
java -Xmx8g -jar $HOME/tools/gatk/GenomeAnalysisTK.jar \
    -T VariantAnnotator \
    -R $HOME/genomes/GRCh37.75.fa \
    -A SnpEff \
    --variant protocols/ex1.vcf \
    --snpEffFile protocols/ex1.ann.gatk.vcf \
    -L protocols/ex1.vcf \
    -o protocols/ex1.gatk.vcf
```

Note: We assumed GATK is installed in "$HOME/tools/gatk/" and the reference genome is contained in "$HOME/genomes/GRCh37.75.fa" These file locations should be adapted to the actual path in your computer.

### Galaxy

Anther popular tool in bioinformatics is Galaxy 3, which allows pipelines to be created in a web environment using graphical interface, making it flexible and straightforward to use.
SnpEff provides [Galaxy modules](snpeff/integration.md#integration-galaxy).

Once these modules are installed, we can run our sample annotation pipeline in Galaxy.

![figure3](images/Cingolani_Figure3.png){: .center}

## Example 3: Non-Coding variants

We show how to use SnpEff & SnpSift to annotate, prioritize and filter non-coding variants.

**Dataset:** This example shows how to perform basic annotation of non-coding variants.
It is based on a short list of 20 non-coding that were identified by sequencing a 700 kb region surrounding the gene T-box transcription factor (TBX5) in 260 patients with congenital heart disease 67.
TBX5 is a transcription factor that plays a well-established dosage-dependent role in heart and limb development.
Coding mutations in TBX5 have been frequently identified in patients with Holt-Oram syndrome, which is associated with abnormal hand, forearm and cardiac development.

**Data source**: [Regulatory variation in a TBX5 enhancer leads to isolated congenital heart disease](http://www.ncbi.nlm.nih.gov/pubmed/22543974).

### Step 1. Annotating variants.

We will perform non-coding variant annotation using SnpEff following a similar approach to Procedure I.
In this case, we construct a command line that instructs SnpEff to include motif information ("-motif") and putative transcription factor binding sites (TFBS) identified in the ENSEMBL Regulatory Build and the Jaspar database:

```
java -Xmx8g -jar snpEff.jar \
    -v \
    -motif \
    GRCh37.75 \
    protocols/ex2.vcf \
    > protocols/ex2.ann.basic.vcf
```

### Step 2. Adding custom regulatory information.

A quick scan through the results shows that most variants are catalogued as "INTERGENIC", and none of them is associated with a known TFBS.
This is not surprising since TFBS are small and also because regulatory elements involved in cardiac or limb development may not be widely active in commonly studied adult tissues.
In this case, basic annotations did not provide additional information that can be used to narrow down the list of candidate SNVs.

To solve this, the authors examined data from other sources, including ChIP-seq data for H3K4me1 (a post-translationally modified histone protein found in transcriptionally active genome regions, including enhancers and promoters).
Data produced from ChIP-Seq analysis are frequently published in BED, BigBed or similar formats, which can be used directly by SnpEff by adding the `-interval` command line option.

This command line option can be used to add annotations using ChIP-Seq experiments from the ENCODE and Epigenome Roadmap projects: since multiple `-interval` options are allowed in each command line, it is a simple way to combine several annotations:

```
java -Xmx8g -jar snpEff.jar \
    -v \
    -motif \
    -interval protocols/ex2_regulatory.bed \
    GRCh37.75 \
    protocols/ex2.vcf \
    > protocols/ex2.ann.vcf
```
In the output VCF file, variants intersecting genomic regions from the `-interval` command line option are annotated as `"CUSTOM[ex2_regulatory]"` :  the name in brackets identifies the file name provided to distinguish multiple annotation files.

### Step 3. Adding conservation information.

In order to refine our search, we can also look for variants in highly conserved non-coding bases.
SnpEff natively supports PhastCons scores, but can also add annotations based on any other user-defined score provided as a Wig or VCF file.

The command line for annotating using the PhastCons score is:
```
java -Xmx1g -jar SnpSift.jar \
    phastCons \
    -v \
    protocols/phastcons \
    protocols/ex2.ann.vcf \
    > protocols/ex2.ann.cons.vcf
```

Now we can filter our results looking for a highly conserved SNP in the regulatory region.
We do this by using a "SnpSift filter" command and the appropriate Boolean expression:
```
cat protocols/ex2.ann.cons.vcf \
    | java -jar SnpSift.jar filter \
    "(ANN[*].EFFECT = 'CUSTOM[ex2_regulatory]') & (exists PhastCons) & (PhastCons > 0.9)" \
    > protocols/ex2.filtered.vcf
```

SnpSift filter supports a flexible syntax to create Boolean expressions using the annotation data that provides a versatile way to prioritize shorter lists of SNPs for subsequent validation.
This syntax is described in detail in the [online manual](snpsift/filter.md).
In this example, our filter results in only two candidate SNPs, one of which was extensively validated in the original study and is assumed to be causative.

The principles illustrated in our example for a small set of SNVs can be applied to millions of variants from whole genome sequencing experiments. Similarly, although we filtered the SNVs using "custom" ChIP-seq data that provided in the original study, regulatory information from public Encode or Epigenome Roadmap datasets could be used in a first line investigation before generating our own Chip-seq or RNA-seq data using disease-relevant cells and tissues.

## Example 4: Sequencing data analysis

Here we show an example on how to get from Sequencing data to an annotated variants file.

### Sequencing data example

!!! warning
    This is an extremely simplified version on how to analyze the data from scratch.
    This is not meant to be a tutorial on sequencing analysis as it would be way beyond the scope of this handbook.

Let's assume you have sequence data in FASTQ format (file "s.fastq") and your reference genome is dm5.34 (fly genome)
```
# Download the genome, uncompress and rename file
wget ftp://ftp.flybase.net/genomes/Drosophila_melanogaster/dmel_r5.34_FB2011_02/fasta/dmel-all-chromosome-r5.34.fasta.gz
gunzip dmel-all-chromosome-r5.34.fasta.gz
mv dmel-all-chromosome-r5.34.fasta dm5.34.fasta

# Create a genome index (we assume you installed BWA)
bwa index -bwtsw dm5.34.fasta

# Map sequences to the genome: Create SAI file
bwa aln -bwtsw dm5.34.fasta s.fastq > s.sai

# Map sequences to the genome: Create SAM file
bwa samse dm5.34.fasta s.sai s.fastq > s.sam

# Create BAM file (we assume you installed SamTools)
samtools view -S -b s.sam > s.bam

# Sort BAM file (will create s_sort.bam)
samtools sort s.bam s_sort

# Create VCF file (BcfTools is part of samtools distribution)
samtools mpileup -uf dm5.34.fasta s_sort.bam | bcftools view -vcg - > s.vcf

# Analyze variants using snpEff
java -Xmx8g -jar snpEff.jar dm5.34 s.vcf > s.ann.vcf
```

This highly simplified sequencing data analysis pipeline, has these basic steps:

1. Index the reference genome (bwa)
2. Map reads to reference genome (bwa)
3. Call variants (bcftools)
4. Annotate variants (SnpEff)

##  Example 5: Filter out variants (dbSnp)

Here we show an example on how to get from Sequencing data to an annotated variants file.

These are slightly more advanced examples.
Here we'll try to show how to perform specific tasks.

If you want to filter out SNPs from dbSnp, you can do it using SnpSift.
You can download SnpSift from the "Downloads" page.

You can download the file for this example [here](adds/file.vcf).

Here is how to do it:

1. Annotate ID fields using `SnpSift annotate` and DbSnp.

        # Annotate ID field using dbSnp
        # Note: SnpSift will automatically download and uncompress dbSnp database if not locally available.
        java -jar SnpSift.jar annotate -dbsnp file.vcf > file.dbSnp.vcf

    !!! info
        We annotate using dbSnp before using SnpEff in order to have 'known' and 'unknown' statistics in SnpEff's summary page.
        Those stats are based on the presence of an ID field. If the ID is non-empty, then it is assumed to be a 'known variant'.

2. Annotate using SnpEff:

        java -Xmx8g -jar snpEff.jar eff -v GRCh37.75 file.dbSnp.vcf > file.ann.vcf

3. Filter out variants that have a non-empty ID field.
    These variants are the ones that are NOT in dbSnp, since we annotated the ID field using rs-numbers from dbSnp in step 1.

        java -jar SnpSift.jar filter -f file.ann.vcf "! exists ID" > file.ann.not_in_dbSnp.vcf

    !!! info
        The expression using to filter the file is "! exists ID".
        This means that the ID field does not exists (i.e. the value is empty) which is represented as a dot (".") in a VCF file.

**Pipes**

Obviously you can perform the three previous commands, pipeling the out from one command to the next, thus avoiding the creation of intermediate files (for very large projects, this can be a significant amount of time).

!!! info
    In SnpEff &amp; SnpSift the STDIN is denoted by file name `"-"`

So the previous commands would be:
```
java -jar SnpSif.jar annotate -dbsnp file.vcf \
    | java -Xmx8g -jar snpEff.jar eff -v GRCh37.75 - \
    | java -jar SnpSift.jar filter "! exists ID" \
    > file.ann.not_in_dbSnp.vcf
```

Here is an example of some entries in the annotated output file.
You can see the 'ANN' field was added, predicting STOP_GAINED protein changes:
```
$ cat demo.1kg.snpeff.vcf | grep stop_gained
1    889455    .    G    A    100.0    PASS    ...;ANN=A|stop_gained|HIGH|...
1    897062    .    C    T    100.0    PASS    ...;ANN=T|stop_gained|HIGH|...
1    900375    .    G    A    100.0    PASS    ...;ANN=A|stop_gained|HIGH|...
```
Note: The real output was edited for readability reasons.

## Example 6: Custom annotations

SnpEff can annotate using user specified (custom) genomic intervals, allowing you to add any kind of annotations you want.

In this example, we are analyzing using a specific version of the Yeast genome (we will assume that the database is not available, just to show a more complete example).
We also want to add annotations of genomic regions known as 'ARS', which are defined in a GFF file.
This turns out to be quite easy, thanks to SnpEff's "custom intervals" feature.
SnpEff allows you to add "custom" annotations from intervals in several formats: TXT, BED, BigBed, VCF, GFF.

So, for this example, we need to:

* Build the database: For the sake of this example, we are assuming that SnpEff doesn't have this database (which is not true in most real life situations).
* Create a file with the features we want to analyze (ARS)
* Annotate using the ARS features

### Step 1: Build database.

Once more, this is done for the sake of the example, in real life Yeast databases are available and you don't need to build the database yourself.
```
#---
# Download data
#---
$ cd ~/snpEff
$ mkdir data/sacCer
$ cd data/sacCer
$ wget http://downloads.yeastgenome.org/curation/chromosomal_feature/saccharomyces_cerevisiae.gff
$ mv saccharomyces_cerevisiae.gff genes.gff
```

Now that we've downloaded the reference genome, we can build the database:
```
#---
# Build
#---
$ cd ../..

# Add entry to config file
$ echo "sacCer.genome : Yeast" >> snpEff.config

# Build database
$ java -Xmx1G -jar snpEff.jar build -gff3 sacCer
```

### Step 2: Create custom annotations file.

We need a file that has our features of interest (in this case, the "ARS" features).
Since those features ara available in the original GFF (saccharomyces_cerevisiae.gff) file, we can filter the file to create our "custom" annotations file.

```
#---
# Create a features file
#---

# GFF files have both genomic records and sequences, we need to know
# where the 'records' section ends (it is delimited by a "##FASTA" line)
$ grep -n "^#" data/sacCer/genes.gff | tail -n 1
22994:##FASTA

# Note that I'm cutting the INFO column (only for readability reasons)
$ head -n 22994 data/sacCer/genes.gff \
    | grep -v "^#" \
    | grep ARS  \
    | cut -f 1 -d ";" \
    > sacCer_ARS_features.gff
```

So now we have a custom file ready to be used.

### Step 3: Annotate.

We built the database and we have the ARS features file, so we are ready to annotate:
```
#---
# Features annotations example
#---

# Create a fake VCF file (one line), this is just an example to show that it works
$ echo -e "chrI\t700\t.\tA\tT\t.\t.\t." > my.vcf

$ java -jar snpEff.jar -interval sacCer_features.gff sacCer my.vcf > my.ann.vcf
```

If we take a look at the results, we can see that the "ARS" feature is annotates (see last line)
```
$ cat my.ann.vcf | grep -v "^#" | cut -f 8 | tr ",;" "\n\n"
EFF=missense_variant(LOW|MISSENSE|Cca/Tca|p.Pro55Ser/c.163A>T|84|YAL068W-A|protein_coding|CODING|YAL068W-A_mRNA|1|1|WARNING_REF_DOES_NOT_MATCH_GENOME)
upstream_gene_variant(MODIFIER||1780||75|YAL067W-A|protein_coding|CODING|YAL067W-A_mRNA||1)
downstream_gene_variant(MODIFIER||1107||120|YAL068C|protein_coding|CODING|YAL068C_mRNA||1)
downstream_gene_variant(MODIFIER||51||104|YAL069W|protein_coding|CODING|YAL069W_mRNA||1)
custom[sacCer_features](MODIFIER||||||ARS102||||1)
```

# SnpSift GeneSets

Annotating GeneSets, such as Gene Ontology (GO), KEGG, Reactome, etc.; can be quite useful to find significant variants.

Gene set annotations can be added to a SnpEff annotated file using `SnpSift geneSets` command.
The VCF file must be annotated using `SnpEff` before performing Gene Sets annotations.
This is because we must know which gene the variant affects).

!!! info
    You can download MSigDb from [Broad Institute](http://www.broadinstitute.org/gsea/msigdb)

Usage example:
```
$ java -jar SnpSift.jar geneSets -v db/msigDb/msigdb.v3.1.symbols.gmt test.ann.vcf > test.eff.geneSets.vcf
00:00:00.000	Reading MSigDb from file: 'db/msigDb/msigdb.v3.1.symbols.gmt'
00:00:01.168	Done. Total:
        8513 gene sets
        31847 genes
00:00:01.168	Annotating variants from: 'test.ann.vcf'
00:00:01.298	Done.
# Summary
#	    gene_set	gene_set_size	variants
#	    ACEVEDO_METHYLATED_IN_LIVER_CANCER_DN	940	8
#	    CHR1P36	504	281
#	    KEGG_OLFACTORY_TRANSDUCTION	389	8
#	    REACTOME_GPCR_DOWNSTREAM_SIGNALING	805	8
#	    REACTOME_OLFACTORY_SIGNALING_PATHWAY	328	8
...
#	    REACTOME_SIGNALING_BY_GPCR	920	8

$ cat test.eff.geneSets.vcf
## INFO=<ID=MSigDb,Number=.,Type=String,Description="Gene set from MSigDB database (GSEA)">
1	69849	.	G	A	454.73	PASS	AC=33;EFF=STOP_GAINED(HIGH|NONSENSE|tgG/tgA|W253*|305|OR4F5|protein_coding|CODING|ENST00000335137|1|1);MSigDb=ACEVEDO_METHYLATED_IN_LIVER_CANCER_DN,CHR1P36,KEGG_OLFACTORY_TRANSDUCTION,REACTOME_GPCR_DOWNSTREAM_SIGNALING,REACTOME_OLFACTORY_SIGNALING_PATHWAY,REACTOME_SIGNALING_BY_GPCR
```

# SnpSift CaseControl

Allows you to count how many samples are in 'case' and 'control' groups.

### Typical usage

This command counts the number of 'homozygous', 'heterozygous' and 'total' variants in a case and control groups and performs some basic pValue calculation using Fisher exact test and Cochran-Armitage test.

Case and Control groups can be defined either by a command line string or a TFAM file (see [PLINK's documentation](http://zzz.bwh.harvard.edu/plink/data.shtml#tr)).

Case/Control command line string containing plus and minus symbols {'+', '-', '0'} where '+' is case, '-' is control and '0' is neutral (ignored).

E.g. We have ten samples, which means ten genotype columns in the VCF file.
The first four are 'cases', the fifth one is 'neutral', and the last five are 'control'.
So the description string would be "++++0-----" (note that the following output has been edited, only counts are shown, no pValues):
```
$ java -jar SnpSift.jar caseControl "++++0-----" cc.vcf
#CHROM  POS    ID  REF  ALT  QUAL  FILTER  INFO                                FORMAT  Sample_01  Sample_02  Sample_03  Sample_04  Sample_05  Sample_06  Sample_07  Sample_08  Sample_09  Sample_10
1       69496  .   G    A    .     PASS    AF=0.01;Cases=1,2,4;Controls=2,2,6  GT      0/1        1/1        1/0        0/0        0/0        0/1        1/1        1/1        1/0        0/0
```
Cases genotypes are samples 1 to 4 : 0/1, 1/1, 1/0 and 0/0. So there are 1 homozygous, 2 heterozygous, and a total of 4 variants (2 * 1 + 1 * 2 = 4).
Thus the annotation is `Cases=1,2,4`

Control genotypes are samples 6 to 10 : 0/1, 1/1, 1/1, 1/0 and 0/0. So there are 2 homozygous, 2 heterozygous, and a total of 6 variants (2 * 2 + 1 * 2 = 6)
Thus the annotation is `Controls=2,2,6`

!!! info
    You can use the `-tfam` command line option to specify a TFAM file.
    Case, control from are read from phenotype field of a TFAM file (6th column).
    Phenotype order in TFAM files do not need to match VCF sample order (sample IDs are used).
    Phenotype column should be coded as {0,1,2} meaning {Missing, Control, Case} respectively.
    See [PLINK's reference](http://zzz.bwh.harvard.edu/plink/data.shtml#tr) for details about TFAM file format.

!!! info
    You can use the `-name nameString` command line option to add name to the INFO tags.

    This can be used to count different case/control groups in the same dataset (e.g. multiple phenotypes)

        $  java -jar SnpSift.jar caseControl -name "_MY_GROUP" "++++0-----" cc.vcf \
        | java -jar SnpSift.jar caseControl -name "_ANOTHER_GROUP" "+-+-+-+-+-" -

        #CHROM  POS    ID  REF  ALT  QUAL  FILTER  INFO                                                                                                         FORMAT  Sample_01  Sample_02  Sample_03  Sample_04  Sample_05  Sample_06  Sample_07  Sample_08  Sample_09  Sample_10
        1       69496  .   G    A    .     PASS    AF=0.01;Cases_MY_GROUP=1,2,4;Controls_MY_GROUP=2,2,6;Cases_ANOTHER_GROUP=1,3,5;Controls_ANOTHER_GROUP=2,1,5  GT      0/1        1/1        1/0        0/0        0/0        0/1        1/1        1/1        1/0        0/0

### p-values
SnpSift caseControl calculates the p-value using different models: dominant, recessive, allelic and co-dominant.

!!! info
    When we say we use Fisher exact test, it means that we use the real Fisher exact test calculation, not approximations (like Chi-Square approximations).
    So the p-values should be correct even for low counts on any of the values in the contingency tables.
    Approximations tend to be wrong when any count in a contingency table is below 5.
    You should not see that problem here.

Models:

* Dominant model (`CC_DOM`): A 2 by 2 contingency table is created:

    --       | Alt (A/a + a/a) | Ref (A/A)
    -------- | --------------- | ---------
    Cases    | N11             | N12
    Controls | N21             | N22

    This means that the first column are the number of samples that have ANY non-reference: either 1 (heterozygous) or 2 (homozygous).
    Fisher exact test is used to calculate the p-value.

* Recessive model (`CC_REC`): A 2 by 2 contingency table is created:

    --       | Alt (a/a) | Ref + Het (A/A + A/a)
    -------- | --------- | ---------
    Cases    | N11       | N12
    Controls | N21       | N22

    This means that the first column are the number of samples that have both non-reference chromosomes: homozygous ALT.
    Fisher exact test is used to calculate the p-value.

* Allelic model (`CC_ALL`): A 2 by 2 contingency table is created:

    --       | Variants | References
    -------- | -------- | ----------
    Cases    | N11 | N12
    Controls | N21 | N22

    This means that the first column are the number of non-reference genotypes.
    For instance homozygous reference samples count as 0, heterozygous count as 1 and homozygous non-reference count as 2.
    Fisher exact test is used to calculate the p-value.

* Genotipic / Codominant model (`CC_GENO`): A 2 by 3 contingency table is created:

    --       | A/A | a/A | a/a
    -------- | --- | --- | ---
    Cases    | N11 | N12 | N13
    Controls | N21 | N22 | N23

    This means that the first column are the number of homozygous reference genotypes. The second column is the number of heterozygous.
    And the third column is the number of homozygous non-reference.

    **Chi-Square** distribution with two degrees of freedom is calculate the p-value.

* Cochran-Armitage trend model (`CC_TREND`): A 2 by 3 contingency table is created:

    --       | A/A | a/A | a/a
    -------- | --- | --- | ---
    Cases    | N11 | N12 | N13
    Controls | N21 | N22 | N23
    Weight   | 0.0 | 1.0 | 2.0

    This means that the first column are the number of homozygous reference genotypes.
    The second column is the number of heterozygous.
    And the third column is the number of homozygous non-reference.

    **Cochran-Armitage** test is used to calculate the p-value, using the weights shown in the last row.

# SnpSift phastCons

Annotate using PhastCons conservation scores.

!!! info
    You must download PhastCons files [here](http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/).

!!! info
    You also need a chromosome size file, which can be created using `samtools faidx`, or you can download it from [here](adds/genome.fai).

Full example.
Most of the example deals with downloading and installing PhastCons database, which is done only once.
The real annotation process is done in the last line.
```
# Create a dir for PhastCons database
cd ~/snpEff
mkdir -p db/phastCons/

# Download all PhastCons files
cd db/phastCons/
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr1.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr2.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr3.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr4.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr5.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr6.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr7.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr8.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr9.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr10.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr11.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr12.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr13.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr14.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr15.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr16.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr17.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr18.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr19.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr20.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr21.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chr22.phastCons100way.wigFix.gz                 
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrM.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrX.phastCons100way.wigFix.gz                  
wget http://hgdownload.soe.ucsc.edu/goldenPath/hg19/phastCons100way/hg19.100way.phastCons/chrY.phastCons100way.wigFix.gz

# Create a chromosome size file and name it "genome.fai"
samtools faidx path/to/genome/hg19.fa.gz
cp path/to/genome/hg19.fa.gz.fai ./genome.fai

# Now we are ready to annotate
java -Xmx8g -jar SnpSift.jar phastCons ~/snpEff/db/phastCons file.vcf > file.phastCons.vcf
```

You can annotate intervals using BED files and `-bed` command line option.
In the output BED formatted intervals, the score column (fifth column), is the average conservation score of all bases within the interval.

It is possible to extract sub-intervals having at least 'minScore' conservation score and 'len' length by using `-minScore score` and `-extract len` command line options.
For instance, the following command:

    java -jar SnpSift.jar phastCons -minScore 0.8 -extract 10 -bed path/to/phastCons/dir input.bed
extracts all subintervals from each line in `input.bed`, that has at least `10` bases length and a conservation score of `0.8`

# Building databases

SnpEff needs a database to perform genomic annotations.
There are pre-built databases for thousands of genomes, so chances are that your organism of choice already has a SnpEff database available.
In the (unlikely?) event that you need to build one yourself, here we describe how to it.

!!! info
    You can know which genomes are supported by running the following command:

        java -jar snpEff.jar databases

!!! warning
    Most people do NOT need to build a database, and can safely use a pre-built one.
    So unless you are working with a rare genome you most likely don't need to do it either.

### Managing SnpEff databases manually

SnpEff databases for the most popular genomes are already pre-built and available for you to download.
So, chances are that you don't need to build a database yourself (this will save you a LOT of work).

!!! warning
    By default SnpEff automatically downloads and installs the database for you, so you don't need to do it manually.
    The following instructions are for people that want to pre-install databases manually (again, most people don't need to do this).

The easiest way to download and install a pre-built SnpEff database manually, is using the `download` command.
E.g. if you want to install the SnpEff database for the human genome, you can run the following command:

```
java -jar snpEff.jar download -v GRCh37.75
```

### Backwards compatible databases

In many cases the databases from previous SnpEff versions might be compatible with newer versions.
So, SnpEff has a *fallback* mechanism for *"backwards-compatible database formats"*.
If database format version 5.1 is backward compatible with "5.0", then we can use the "old" (5.0) databases in SnpEff version 5.1

For example, let's say GRCh38.99 was built for "SnpEff version 5.0".
When I released version 5.1 I don't need to rebuild GRCh38.99 (or any of the other thousands of databases) again for 5.1, we can just use the "old" 5.0 versions.

How does it work? SnpEff checks the database in "5.1" path, if it doesn't work it fallback to "5.0" path.
If you take a look a SnpEff's download output using the `-v` command, you'll see that it tries two times:

```
$ java -jar snpEff.jar download -v GRCm38.99

00:00:00 SnpEff version SnpEff 5.1d (build 2022-04-19 15:49), by Pablo Cingolani
00:00:00 Command: 'download'
00:00:00 Reading configuration file 'snpEff.config'. Genome: 'GRCm38.99'
00:00:00 Reading config file: /Users/pcingola/snpEff/snpEff.config
00:00:00 done
00:00:00 Downloading database for 'GRCm38.99'
00:00:00 Downloading from 'https://snpeff.blob.core.windows.net/databases/v5_1/snpEff_v5_1_GRCm38.99.zip' to local file '/var/folders/s9/y0bgs3l55rj_jkkkxr2drz4157r1dz/T//snpEff_v5_1_GRCm38.99.zip'
00:00:00 Connecting to https://snpeff.blob.core.windows.net/databases/v5_1/snpEff_v5_1_GRCm38.99.zip
00:00:01 Connecting to https://snpeff.blob.core.windows.net/databases/v5_1/snpEff_v5_1_GRCm38.99.zip, using proxy: false
00:00:01 ERROR while connecting to https://snpeff.blob.core.windows.net/databases/v5_1/snpEff_v5_1_GRCm38.99.zip
00:00:01 Downloading from 'https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.99.zip' to local file '/var/folders/s9/y0bgs3l55rj_jkkkxr2drz4157r1dz/T//snpEff_v5_0_GRCm38.99.zip'
00:00:01 Connecting to **https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.99.zip**
00:00:01 Connecting to https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.99.zip, using proxy: false
00:00:02 Local file name: '/var/folders/s9/y0bgs3l55rj_jkkkxr2drz4157r1dz/T//snpEff_v5_0_GRCm38.99.zip'
......
```

So, it starts searching at `https://snpeff.blob.core.windows.net/databases/v5_1/snpEff_v5_1_GRCm38.99.zip`
bu`t it doesn't find it there, so it proceeds with the databse `5.0` path `https://snpeff.blob.core.windows.net/databases/v5_0/snpEff_v5_0_GRCm38.99.zip`, where the blob is found, thus proceeds to download and install it from there.

!!! info
    If you are running SnpEff from a directory different than the one it was installed, you will have to specify where the config file is.
    This is done using the `-c` command line option:

        java -Xmx8g -jar snpEff.jar download -c path/to/snpEff/snpEff.config -v GRCh37.75

### Building a database

In order to build a database for a new genome, you need to:

!!! warning
    Most people do NOT need to build a database, and can safely use a pre-built one.
    So unless you are working with a rare genome you most likely don't need to do it either.

1. **Step 1:** [Configure a new genome](#step-1-configure-a-new-genome) in SnpEff's config file `snpEff.config`.

     1. [Add genome entry](#add-a-genome-to-the-configuration-file) to snpEff's configuration
     2. If the genome uses a non-standard codon table: [Add codon table parameter](#configuring-codon-tables-not-always-required)

2. **Step 2:** [Build using gene annotations and reference sequences](#step-2-build-using-gene-annotations-and-reference-sequences)

    1. [Option 1:](#step-2-option-1-building-a-database-from-gtf-files) Building a database from GTF files (**recommended for large genomes**)
    2. [Option 2:](#step-2-option-2-building-a-database-from-genbank-files) Building a database from GenBank files (**recommended for small genomes**)
    3. [Option 3:](#step-2-option-3-building-a-database-from-gff-files) Building a database from GFF files
    4. [Option 4:](#step-2-option-4-building-a-database-from-refseq-table-from-ucsc) Building a database from RefSeq table from UCSC

3. **Step 3:** [Checking the database](#step-3-checking-the-database): SnpEff will check the database by comparing predicted protein sequences and CDS sequences with ones provided by the user.

    1. [Checking CDS sequences](#checking-cds-sequences)
    2. [Checking Protein sequences](#checking-protein-sequences)

!!! info
    All files can be compressed using `gzip`
    E.g. the reference file 'hg19.fa' can be compressed to 'hg19.fa.gz', snpEff will automatically decompress the file.

!!! warning
    Some files claimed to be compressed using GZIP are actually not or even use a block compression variant not supported by Java's gzip library.
    If you notice that your build process finishes abruptly for no apparent reason, try uncompressing the files.

### Step 1: Configure a new genome

In order to tell SnpEff that there is a new genome available, you must update SnpEff's configuration file `snpEff.config`.

You must add a new genome entry to `snpEff.config`.

If your genome, or a chromosome, uses non-standard codon tables you must update `snpEff.config` accordingly.
A typical case is when you use mitochondrial DNA. Then you specify that chromosome 'MT' uses `codon.Invertebrate_Mitochondrial` codon table.
Another common case is when you are adding a bacterial genome, then you specify that the codon table is `Bacterial_and_Plant_Plastid`.

#### Add a genome to the configuration file

This example shows how to add a new genome to the config files. For this example we'll use the mouse genome (mm37.61):

1. Edit the config file to create the new genome:

        vi snpEff.config

    Add the following lines (you are editing snpEff.config):

        # Mouse genome, version mm37.61
        mm37.61.genome : Mouse

    !!! warning
        You may need to add codon table information for the genome or some parts of it (e.g. mitochondrial "chromosome").
        See next section for details.

2. Optional: Add genome to Galaxy's menu:

        cd /path/to/galaxy
        cd tools/snpEffect/
        vi snpEffect.xml

    Add the following lines to the file:

        <param name="genomeVersion" type="select" label="Genome">
            <option value="hg37">Human (hg37)<option>
            <option value="mm37.61">Mouse (mm37.61)<option>
        <param>

#### Configuring codon tables (not always required)

Codon tables are provided in the ```snpEff.config``` configuration file under the section ```codon.Name_of_your_codon_table```.
The format is a comma separated list of ```CODON/AMINO_ACID```.

E.g.:

    codon.Invertebrate_Mitochondrial:  TTT/F, TTC/F, TAC/Y, TAA/*, ATG/M+, ATG/M+, ACT/T, ...

Note that codons marked with '*' are STOP codons and codons marked with a '+' are START codons.

In order for you to use them, you have to specify that a given "chromosome" uses one of the tables (otherwise the default codon table is used).

E.g. Here we say the chromosome 'M' from fly genome (dm3) uses Invertebrate_Mitochondrial codon table:

    dm3.M.codonTable : Invertebrate_Mitochondrial

...of course, chromosome 'M' is not a real chromosome, it is just a way to mark the sequence as mitochondrial DNA in the reference genome.

### Step 2: Build using gene annotations and reference sequences

To build a database, SnpEff needs:

1. The reference genome sequence: This is the sequence of all chromosomes in the genome, typically in a FASTA file
2. Gene annotations files: This is the information on where the genes, transcripts and exons are in the genome. Typically, from files in GTF, GeneBank, GFF, or RefSeq formats
3. Sequences of CDS or Proteins from the genome. These are used to check that SnpEff's database is consistent and doesn't have errors  (see sections [Checking CDS sequences](#checking-cds-sequences) and [Checking Protein sequences](#checking-protein-sequences))


#### Step 2, Option 1: Building a database from GTF files

GTF 2.2 files are supported by SnpEff (e.g. ENSEMBL releases genome annotations in this format).

See a more detailed explanation about [SnpEff's requirements for GTF files here](build_db_gff_gtf.md)

1. Get the genome and uncompress it:

        # Create directory for this new genome
        cd /path/to/snpEff/data/
        mkdir mm37.61
        cd mm37.61

        # Get annotation files
        wget ftp://ftp.ensembl.org/pub/current/gtf/mus_musculus/Mus_musculus.NCBIM37.61.gtf.gz
        mv Mus_musculus.NCBIM37.61.gtf.gz genes.gtf.gz

        # Get the genome reference sequence file
        cd /path/to/snpEff/data/genomes
        wget ftp://ftp.ensembl.org/pub/current/fasta/mus_musculus/dna/Mus_musculus.NCBIM37.61.dna.toplevel.fa.gz
        mv Mus_musculus.NCBIM37.61.dna.toplevel.fa.gz mm37.61.fa.gz

2. **Note:** The FASTA file can be either in <br> `/path/to/snpEff/data/genomes/mm37.61.fa` <br>or in <br> `/path/to/snpEff/data/mm37.61/sequences.fa`
3. Add the new genome to the config file (see [Add a new genome to the configuration file](#add-a-genome-to-the-configuration-file) for details)
4. Create database:

        cd /path/to/snpEff
        java -jar snpEff.jar build -gtf22 -v mm37.61

#### Step 2, Option 2: Building a database from GenBank files

In this section, we show how to build a genome database using GeneBank files.

!!! info
    Using GeneBank files is the recommended way for databases for small genomes, such as viruses or bacteria


!!! info
    For NCBI genomes, you can use the script `buildDbNcbi.sh` that downloads and builds the database.
    See details in [this FAQ](faq.md#how-to-building-an-ncbi-genome-genbank-file)


**Example:** This example shows how to create a database for a new genome.

!!! info
    GenBank files usually include genome sequence as well as CDS sequences.
    If these sequences are NOT in the GeneBank file, you should provide separate FASTA files for genome reference and CDS (or Protein) sequences.


For this example we'll use "Staphylococcus aureus":

1. Go to NIH page for [CP000730](http://www.ncbi.nlm.nih.gov/nuccore/CP000730.1)
2. Download the features in geneBank format, by clicking as shown in the following images (red arrows):

   ![genBank0](../images/genBank_0.png){: .center}

   Make sure you click the "Update" button!

   Then you go to the "Send" menu:

   ![genBank1](../images/genBank_1.png){: .center}

   and then:

   ![genBank2](../images/genBank_2.png){: .center}

3. Save the GenBank data to `/path/to/snpEff/data/CP000730/genes.gbk`

   **Note:** If there are more than one genbank file for an organism (e.g. multiple chromosomes), then you can download each file and concatenate them.

   E.g.: Vibrio Cholerae has two chromosomes with GenBank accessions: NC_002505.1 and NC_002506.1.
   You can download both files and save them as `snpEff/data/vibrio/NC_002505.1.gbk` and `snpEff/data/vibrio/NC_002506.1.gbk` respectively, and then concatenate both files:

        cat NC_002505.1.gbk NC_002506.1.gbk > genes.gbk

   Add the following entries in the config file:

        # Vibrio Cholerae
        vibrio.genome : Vibrio Cholerae
                vibrio.chromosomes : NC_002505.1, NC_002506.1
                vibrio.NC_002505.1.codonTable : Bacterial_and_Plant_Plastid
                vibrio.NC_002506.1.codonTable : Bacterial_and_Plant_Plastid

4. Create database (note the `-genbank` flag):

        cd /path/to/snpEff
        java -jar snpEff.jar build -genbank -v CP000730


#### Step 2, Option 3: Building a database from GFF files

!!! warning
    Using GFF is highly discouraged, we recommend you use GTF files instead (whenever possible).

See a more detailed explanation about [SnpEff's requirements for GFF files here](build_db_gff_gtf.md)

This example shows how to create a database for a new genome using GFF file (e.g. FlyBase, WormBase, BeeBase release GFF files).
For this example we'll use the Drosophila melanogaster genome (dm5.31):

1. Get a GFF file to `path/to/snpEff/data/dm5.31/genes.gff`:

        mkdir path/to/snpEff/data/dm5.31
        cd path/to/snpEff/data/dm5.31
        wget ftp://ftp.flybase.net/genomes/Drosophila_melanogaster/dmel_r5.31_FB2010_08/gff/dmel-all-r5.31.gff.gz
        mv dmel-all-r5.31.gff.gz genes.gff.gz

2. **Note:** GFF3 files can include the reference sequence in the same file. This is done by dumping the fasta file after a '##FASTA' line. You can also add the sequence fasta file to the 'data/genomes/' directory, like it is done in when using GTF format.
3. Add the new genome to the config file (see [Add a new genome to the configuration file](#add-a-genome-to-the-configuration-file) for details)
4. Create database (note the "-gff3" flag):

        cd /path/to/snpEff
        java -jar snpEff.jar build -gff3 -v dm5.31

#### Step 2, Option 4: Building a database from RefSeq table from UCSC

This example shows how to create a database for a new genome using UCSC's genome tables.
For this example we'll use the Human genome (hg19).

!!! warning
    Using UCSC genome tables is highly discouraged, we recommend you use ENSEMBL versions instead.

!!! warning
    UCSC tables sometimes change for different species.
    This means that even if these instructions work for human genome, it might not work for other genomes.
    Obviously creating a new parser for each genome is impractical, so working with UCSC genomes is highly discouraged.
    We recommend to use ENSEMBL genomes instead.

!!! warning
    UCSC genomes provide only major release version, but NOT sub-versions.
    E.g. UCSC's "hg19" has major version 19 but there is no "sub-version", whereas ENSEMBL's GRCh37.70 clearly has major version 37 and minor version 70.
    Not providing a minor version means that they might change the database and two "hg19" genomes are actually be different.
    This creates all sorts of consistency problems (e.g. the annotations may not be the same that you see in the UCSC genome browser, even though both of them are 'hg19' version).
    Using UCSC genome tables is highly discouraged, we recommend you use ENSEMBL versions instead.

In order to build a genome using UCSC tables, you can follow these instructions:

1. Go to [UCSC genome browser](http://genome.ucsc.edu/)
2. Click on "Table" menu
3. Select parameters as shown here:

    ![uscs_ref_Seq](../images/ucsc_refSeq.png){: .center}

4. Click on "get output" and save the data to file "/path/to/snpEff/data/hg19/genes.refseq".
5. Add the fasta reference genome. The FASTA file can be either in:

    `/path/to/snpEff/data/genomes/hg19.fa`

    or in:

    `/path/to/snpEff/data/hg19/sequences.fa`

6. Add the new genome to the config file (see [Add a new genome to the configuration file](#add-a-genome-to-the-configuration-file) for details)
7. Create database (note the `-refSeq` flag):

        cd /path/to/snpEff
        java -jar snpEff.jar build -refSeq -v hg19

### Step 3: Checking the database

SnpEff makes sure that the database is built correctly by comparing the internal representation with CDS and Protein sequences.
The CDS and Protein sequences are obtained from the same source as the genome reference and gene annotation files.

IMPORTANT: When building databases, SnpEff will attempt to check the database against a CDS FASTA file and a Protein FASTA file.
If neither a CDS FASTA file nor a Protein FASTA file is provided, this check will fail and SnpEff will refuse to save the database, by showing error message like this one:

```
ERROR: CDS check file './data/MY_GENOME/cds.fa' not found.
ERROR: Protein check file './data/MY_GENOME/protein.fa' not found.
ERROR: Database check failed.
```

!!! warning
    If neither a "Protein" nor a "CDS" sequences are provided, SnpEff will not be able to check the database.
    By default, SnpEff will refuse to save any unchecked database.

You can override this behaviour by using the `build` command with these command line options:

- `-noCheckCds`: Skip CDS sequences check.
- `-noCheckProtein`: Skip Protein sequences check.
- `-noCheckCds -noCheckProtein`: When using *BOTH* command line options, SnpEff to save the new database without checking it (i.e. neither CDS nor protein sequences are checked).

#### Checking CDS sequences

When building a database, SnpEff will try to check CDS sequences for all transcripts in the database when

- building via GFT/GFF/RefSeq: A CDS sequences FASTA file is available.
- building via GenBank file: CDS sequences are available within the GenBank file

!!! info
You can disable this check unsing command line option `-noCheckCds`

FASTA cds file format:

- The file name should be `cds.fa` (or `cds.fa.gz` if compressed)
- Each transcript should have one CDS sequence
- Each FASTA header has the transcript ID either:
    - The header contains only the transcript ID
    - The header contains Transcript ID and maybe other IDs separated by either spaces, commas, colon, dots, equal sign, or some combination of these
    - Some example sequences with valid header examples:
```
>ENST00000448914
ACTGGGGGATACG

>chromosome:GRCh38:14:22449113:22449125:1 transcript:ENST00000448914.1 cds gene:ENSG00000228985.1 gene_biotype:TR_D_gene transcript_biotype:TR_D_gene gene_symbol:TRDD3 description:T cell receptor delta diversity 3
ACTGGGGGATACG
```

CSD checking output.
When run using the `-v` (verbose) command line option, for each transcript in the FASTA file, SnpEff will output one character

- `+`: OK, the CDS sequence matches the one predicted by SnpEff
- `.`: Missing transcript. SnpEff could not find the transcript ID from the FASTA file. This might indicate a problem parsing the FASTA file header to find the
- `*`: Error. The CDS sequence from inferred from SnpEff's database and the one provided in the CDS file do not match.

After these line a "Summary statistics" line shows the total number of FASTA entries checked, as well as the number of errors (and a percentage), e.g.:

```
CDS check:	GRCh38.86	OK: 94384	Warnings: 22766	Not found: 103618	Errors: 0	Error percentage: 0.0%
```

!!! warning
As a "rule of the thumb", you should not get more than 2% or 3% of errors.

!!! info
**Debugging:** You can run SnpEff using `-d` (debug) command line option to get detailed messages for each CDS sequence comparison.
The message shows the transcript ID, CDS sequence inferred by SnpEff's, and the CDS sequence from the FASTA file, as well as the places where they differ.

#### Checking Protein sequences

This is very similar to the CDS checking in the previous sub-section.
When building a database, SnpEff will also try to check Protein sequences for all transcripts when

- building via GFT/GFF/RefSeq: A protein sequences FASTA file is available.
- building via GenBank file: protein sequences are available within the GenBank file

!!! info
You can disable this check unsing command line option `-noCheckProtein`

FASTA protein file:

- The file name should be `protein.fa` (or `protein.fa.gz` if compressed)
- Each transcript should have one protein sequence
- Each FASTA header has the transcript ID either:
    - The header contains only the transcript ID
    - The header contains Transcript ID and maybe other IDs separated by either spaces, commas, colon, dots, equal sign, or some combination of these
    - Some example sequences with valid header examples (sequences have been cut for readability):
```
>ENST00000382044
MPGEQMDPTGSQLDSDFSQQDTPCLIIEDSQPESQVLEDDSGSHFSMLSRHLPNLQTHKE
NPVLDVVSNPEQTAGEERGDGNSGFNEHLKENKVADPVDSSNLDTCGSISQVIEQLPQPN
RTSSVLGMSVESAPAVEEEKGEELEQKEKEKEEDTSGNTTHSLGAEDTASSQLGFGVLEL
...

>ENSP00000371475 pep chromosome:GRCh38:15:43403061:43493171:-1 gene:ENSG00000067369 transcript:ENST00000382044 gene_biotype:protein_coding transcript_biotype:protein_coding gene_symbol:TP53BP1 description:tumor protein p53 binding protein
MPGEQMDPTGSQLDSDFSQQDTPCLIIEDSQPESQVLEDDSGSHFSMLSRHLPNLQTHKE
NPVLDVVSNPEQTAGEERGDGNSGFNEHLKENKVADPVDSSNLDTCGSISQVIEQLPQPN
RTSSVLGMSVESAPAVEEEKGEELEQKEKEKEEDTSGNTTHSLGAEDTASSQLGFGVLEL
...
```

**Protein checking output:**

When run using the `-v` (verbose) command line option, for each transcript in the FASTA file, SnpEff will output one character:

- `+`: OK, the protein sequence matches the one predicted by SnpEff
- `.`: Missing transcript. SnpEff could not find the transcript ID from the FASTA file. This might indicate a problem parsing the FASTA file header to find the
- `*`: Error. The Protein sequence from inferred from SnpEff's database and the one provided in the protein file do not match.

After these line a "Summary statistics" line shows the total number of FASTA entries checked, as well as the number of errors (and a percentage), e.g.:
```
Protein check:  GRCh38.86       OK: 94371       Not found: 0    Errors: 13      Error percentage: 0.01377352093575182%
```

!!! warning
As a "rule of the thumb", the errors should be below 2% or 3%.

**How exactly protein sequences are compared**
The rules used for protein sequence comparison are:

- Comparison is case-insensitive
- Trailing STOP codon (`'*'`) is removed
- Trailing incomplete codon (`'?'`) is removed
- Leading incomplete codons (`'?'`) are removed

If these comparisons fails, further attempts are made:

- Replace "unknown" codon characters: Codons using old `'X'` characters are replaced by newer `'?'` characters
- If any of the sequences only differ by the first codon, they are considered equal (the start codon is translates as 'Met' even when the codon code translates to another Amino acid)
- Replace rare amino acids, which often tranlate as stop codons in the middle of the sequence: E.g. replace `'*'` by `'U'`
- Try replacing unknown aminco acids (`'?'`) by the ones at the same position in the protein sequence from the FASTA file

If after all these attempts the protein sequence still do not match, they are considered "not equal".

!!! info
**Debugging:** You can run SnpEff using `-d` (debug) command line option to get detailed messages for each protein sequence comparison.
The message shows the transcript ID, protein sequence inferred by SnpEff's, and the protein sequence from the FASTA file, as well as the places where they differ.


### Example: Building the Human Genome database

This is a full example on how to build the human genome database (using GTF file from ENSEBML), it includes support for regulatory features, sanity check, rare amino acids, etc..
```
# Go to SnpEff's install dir
cd ~/snpeff

# Create database dir
mkdir data/GRCh37.70
cd data/GRCh37.70

# Download annotated genes
wget ftp://ftp.ensembl.org/pub/release-70/gtf/homo_sapiens/Homo_sapiens.GRCh37.70.gtf.gz
mv Homo_sapiens.GRCh37.70.gtf.gz genes.gtf.gz

# Download proteins
# This is used for:
#	- "Rare Amino Acid" annotations
#	- Sanity check (checking protein predicted from DNA sequences match 'real' proteins)
wget ftp://ftp.ensembl.org/pub/release-70/fasta/homo_sapiens/pep/Homo_sapiens.GRCh37.70.pep.all.fa.gz
mv Homo_sapiens.GRCh37.70.pep.all.fa.gz protein.fa.gz

# Download CDSs
# Note: This is used as "sanity check" (checking that CDSs predicted from gene sequences match 'real' CDSs)
wget ftp://ftp.ensembl.org/pub/release-70/fasta/homo_sapiens/cdna/Homo_sapiens.GRCh37.70.cdna.all.fa.gz
mv Homo_sapiens.GRCh37.70.cdna.all.fa.gz cds.fa.gz

# Download regulatory annotations
wget ftp://ftp.ensembl.org/pub/release-70/regulation/homo_sapiens/AnnotatedFeatures.gff.gz
mv AnnotatedFeatures.gff.gz regulation.gff.gz

# Uncompress
gunzip *.gz

# Download genome
cd ../genomes/
wget ftp://ftp.ensembl.org/pub/release-70/fasta/homo_sapiens/dna/Homo_sapiens.GRCh37.70.dna.toplevel.fa.gz
mv Homo_sapiens.GRCh37.70.dna.toplevel.fa.gz GRCh37.70.fa.gz

# Uncompress:
# Why do we need to uncompress?
# Because ENSEMBL compresses files using a block compress gzip which is not compatible with Java's library Gunzip
gunzip GRCh37.70.fa.gz

# Edit snpEff.config file
#
# WARNING! You must do this yourself. Just copying and pasting this into a terminal won't work.
#
# Add lines:
#		GRCh37.70.genome : Homo_sapiens
#		GRCh37.70.reference : ftp://ftp.ensembl.org/pub/release-70/gtf/

# Now we are ready to build the database
cd ~/snpeff
java -Xmx20g -jar snpEff.jar build -v GRCh37.70 2>&1 | tee GRCh37.70.build
```

### Troubleshooting Database builds

!!! warning
    By far the most common problem is that the FASTA file chromosome names are different than the GFF chromosome names.
    Make sure chromosome names are consistent in all the files you use.

**When I build the database using GFF 3 SnpEff reports that Exons don't have sequences**

GFF3 files can have sequence information either in the same file or in a separate fasta file.

In order to add sequence information in the GFF file, you can do this:
```
cat annotations.gff > genes.gff
echo "###"  >> genes.gff
echo "##FASTA"  >> genes.gff
cat sequence.fa  >> genes.gff
```
**When building a database, I get zero protein coding genes**

When building a database, snpEff tries to find which transcripts are protein coding. This is done using the 'bioType' information.

The bioType information is not a standard GFF or GTF feature. So I follow ENSEMBL's convention of using the second column ('source') for bioType, as well as the gene_biotype attribute.

If your file was not produced by ENSEMBL, it probably doesn't have this information. This means that snpEff doesn't know which genes are protein coding and which ones are not.

Having no information, snpEff will treat all genes as protein coding (assuming you have `-treatAllAsProteinCoding Auto` option in the command line, which is the default).

So you will get effects as if all genes were protein coding, then you can filter out the irrelevant genes. Unfortunately, this is the best I can do if there is no 'bioType' information

**When building a database, I get too many warnings**

There are plenty of GFF and GTF files that, unfortunately, do not follow the specification.
SnpEff usually complains about this, but tries hard to correct the problems.
So the database may be OK even after you see many warnings.

You can check the database to see if the features (genes, exons, UTRs) have been correctly incorporated, by taking a look at the database:

    java -jar snpEff.jar dump myGenome | less

# SnpSift Join

Join files by genomic regions (i.e. chr:start-end).

Files can be generic TXT (tab separated), VCF or BED.

Usage example:
```
Usage: java -jar SnpSift.jar join [options] file1 file2
Note: It is assumed that both files fit in memory.
Options:
    -if1 <num>       : Offset for file1 (e.g. 1 if coordinates are one-based. Default: 1
    -if2 <num>       : Offset for file2 (e.g. 2 if coordinates are one-based. Default: 1
    -cols1 <colDef>  : Column definition for file 1. Format: chrCol,startCol,endCol (e.g. '1,2,3').
                       Shortcuts 'bed' or 'vcf' are allowed. Default: 'vcf
    -cols2 <colDef>  : Column definition for file 2. Format: chrCol,startCol,endCol (e.g. '1,2,3').
                       Shortcuts 'bed' or 'vcf' are allowed. Default: 'vcf
    -all             : For each interval, show all intersecting.
                       Default: show only one (the largest intersection)
    -closest         : Show closest intervals in file2 if none intersect.
                       Default: off
    -empty           : Show intervals in file1 even if they do not intersect with any other interval.
                       Default: off
```

Example: Join two bed files, showing intersecting or closest intervals

    java -Xmx2G -jar SnpSift.jar join -v -cols1 bed -cols2 bed -closest file1.bed file2.bed

Example: Join one bed file and another file having chr:start-end in columns 7,8 and 9 respectively. Showing intervals form file1 that do not intersect any interval from file2

    java -Xmx2G -jar SnpSift.jar join -v -cols1 bed -cols2 7,8,9 -empty file.bed my_weird_file.txt

Users of SnpEff include most major research and academic institutions, as well as pharmaceutical companies and clinical sequencing projects.

**Some Academic &amp; Research institutions using SnpEff:**

* Broad Institute (MIT &amp; Harvard)
* NIH (US)
* Harvard University
* Princeton University
* BGI (China)
* Massachusetts General Hospital
* Whitehead Institute, MIT
* Wellcome Trust Sanger Institute (UK)
* UC Berkeley
* Wellcome Trust Centre for Human Genetics (UK)
* University of Cambridge (UK)
* Duke University
* Max Planck (Germany)
* Cold Spring Harbor Laboratory (CSHL)
* Institut Pasteur (France)
* NCI / NIH (National Cancer Institute, US)
* McGill University (Canada)
* EMBL (Cambridge, UK)
* University of Toronto (Canada)
* University of Cambridge (UK)
* Yale University
* Columbia University
* Stanford University
* Brown University
* Genome Quebec (Canada)
* Centre national de la recherche scientifique (CNRS, France)
* University of Michigan
* Kyoto University (Japan)
* Institut National de la Recherche Agronomique (INRA, France)
* University of Wisconsin-Madison
* UT Southwestern Medical Center
* University of Southern California
* Bologna University (Italy)
* Casa Sollievo della Sofferenza - Mendel (Italy)
* Universitat Wien (Vienna, Austria)
* Ottawa University (Canada)
* Peter MacCallum Cancer Centre (Australia)
* University of Alabama Birmigham
* University of Bristol (UK)
* UC-Davis (California)
* Winsconsin University
* TUM University (Germany)
* The Translational Genomics Institute (Tgen)
* Rutgers University (New Jersey)
* Nagasaki University (Japan)
* Washington University
* Netherlands Cancer Institute (NKI)
* Centro Nacional de Biotecnolog&iacute;a, (National Center for Biotecnology) CNB-CSIC, Madrid, Spain
* University of California-Riverside
* Carleton University (Canada)
* Memorial Sloan-Kettering Cancer Center
* Boston University 
* University of California, San Francisco (UCSF) 
* Institute of Cancer Research (ICR), UK
* University of Virginia
* University of British Columbia (Canada)
* Seoul National University (Korea)
* University of Southern California (USC)
* Arizona State University (ASU)
* NeuroTexas Institute at St. David's HealthCare
* University of Otago (New Zealand)
* Queensland Institute of Medical Research (Australia)
* National University of Singapore (NUS)
* Children's Hospital of Philadelphia
* Technion (Israel)
* Queensland UNiversity (Australia)
* Vall d'Hebron Research Institute: VHIR (Barcelona. Catalonia. Spain)
* University of Pretoria (South Africa).
* Centrum Wiskunde &amp; Informatica (Amsterdam, Netherlands)
* Technical University of Denmark: DTU (Denmark)
* Spanish National Research Council (CSIC, Spain)
* Swedish University of Agricultural Sciences: SLU (Sweden)
* University of Iowa
* Bilkent University (Turkey)
* The Hebrew University of Jerusalem (Israel)
* Laboratory of Malaria and Vector Research NIH/NIAID
* Max F. Perutz Laboratories: MFPL (Vienna, Austria)
* Animal Health Trust: AHT (UK)
* BC Cancer Agency (Canada)
* University of California, Irvine
* University College London (London, UK)
* Centro Nacional de An&aacute;lisis Gen&oacute;mico: CNAG (Barcelona, Spain)
* Advanced Genomics and Bioinformatic Research Center (Turkey)

**Some private Companies &amp; Corporations users of SnpEff:**

* Bayer
* Novartis
* Illumina
* Johnson &amp; Johnson
* AstraZeneca
* Novocraft 
* Sanofi (France)
* Accelrys
* DnaNexus
* Bio-Prodict (Netherlands)
* Spiral Genetics
* Covance
* Eisai (Japan)
* EdgeBio
* BioBase
* Counsyl


!!! note
    These are not by any means comprehensive lists.
